      SUBROUTINE CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
      DIMENSION RPNT(*),IEDG(*),ITRI(*),RWRK(*),IWRK(*),IAMA(*)
C
C The function of the routine CTLBAM is to add to an area map boxes
C surrounding all of the labels.
C
C RPNT is an array of nodes defining vertices of triangles.
C
C IEDG is an array of nodes defining edges of triangles.
C
C ITRI is an array of nodes defining triangles.
C
C RWRK is the user's real workspace array.
C
C IWRK is the user's integer workspace array.
C
C IAMA is the user's area-map array.
C
C
C Declare all of the CONPACKT common blocks.
C
C
C CTCOM1 contains integer and real variables.
C
      COMMON /CTCOM1/ ANCF,ANHL,ANIL,ANLL,CDMX,CHWM,CINS,CINT(10)
      COMMON /CTCOM1/ CINU,CLDB(256),CLDL(256),CLDR(256)
      COMMON /CTCOM1/ CLDT(256),CLEV(256),CLWA(258),CXCF
      COMMON /CTCOM1/ CXIL,CYCF,CYIL,DBLF,DBLM,DBLN,DBLV,DFLD,DMAX
      COMMON /CTCOM1/ DMIN,DOPT,DVAL,EPSI,FNCM,GRAV,GRSD,GSDM,HCHL
      COMMON /CTCOM1/ HCHS,HLSR,IAIA(258),IAIB(256),IBCF,IBHL
      COMMON /CTCOM1/ IBIL,IBLL,ICAF,ICCF,ICCL(258),ICFF,ICHI
      COMMON /CTCOM1/ ICHL,ICIL,ICLL(256),ICLO,ICLP(256),ICLS
      COMMON /CTCOM1/ ICLU(258),ICLV,ICLW,IDUF,IGCL,IGLB,IGRM
      COMMON /CTCOM1/ IGRN,IGVS,IHCF,IHLE,IIWS(2),IIWU,ILBC
      COMMON /CTCOM1/ IMPF,INCX(8),INCY(8),INHL,INIL,INIT,INLL
      COMMON /CTCOM1/ IOCF,IOHL,IOLL,IPAI,IPCF,IPIC,IPIE,IPIL,IPLL
      COMMON /CTCOM1/ IRWS(4),IRWU,ISET,ITBM,IWSO,JODP,JOMA
      COMMON /CTCOM1/ JOTZ,LCTM,LEA1,LEA2,LEA3,LEE1,LEE2,LEE3,LINS
      COMMON /CTCOM1/ LINT(10),LINU,LIWB,LIWK,LIWM,LIWS(2),LNLG
      COMMON /CTCOM1/ LOEN,LOPN,LOTN,LRWC,LRWG,LRWK,LRWM,LRWS(4)
      COMMON /CTCOM1/ LSDD,LSDL,LSDM,LTCF,LTHI,LTIL,LTLO,MIRO
      COMMON /CTCOM1/ NCLB(256),NCLV,NDGL,NEDG,NEXL,NEXT,NEXU
      COMMON /CTCOM1/ NLBS,NLSD,NLZF,NOMF,NOVS,NPNT,NR04,NSDL
      COMMON /CTCOM1/ NSDR,NTRI,OORV,PITH,SCFS,SCFU,SEGL,T2DS
      COMMON /CTCOM1/ UCMN,UCMX,UVPB,UVPL,UVPR,UVPS,UVPT,UWDB,UWDL
      COMMON /CTCOM1/ UWDR,UWDT,WCCF,WCHL,WCIL,WCLL,WLCF,WLHL,WLIL
      COMMON /CTCOM1/ WLLL,WOCH,WODA,WTCD,WTGR,WTNC,WTOD,WWCF,WWHL
      COMMON /CTCOM1/ WWIL,WWLL,XLBC,XMAX,XMIN,XVPL,XVPR,XWDL,XWDR
      COMMON /CTCOM1/ YLBC,YMAX,YMIN,YVPB,YVPT,YWDB,YWDT,ZMAX,ZMIN
C
      EQUIVALENCE (IIWS(1),II01),(LIWS(1),LI01)
      EQUIVALENCE (IIWS(2),II02),(LIWS(2),LI02)
      EQUIVALENCE (IRWS(1),IR01),(LRWS(1),LR01)
      EQUIVALENCE (IRWS(2),IR02),(LRWS(2),LR02)
      EQUIVALENCE (IRWS(3),IR03),(LRWS(3),LR03)
      EQUIVALENCE (IRWS(4),IR04),(LRWS(4),LR04)
      SAVE   /CTCOM1/
C
C CTCOM2 holds character parameters.
C
      COMMON /CTCOM2/ CHEX,CLBL(256),CLDP(258),CTMA,CTMB,FRMT
      COMMON /CTCOM2/ TXCF,TXHI,TXIL,TXLO
      CHARACTER*13 CHEX
      CHARACTER*64 CLBL
      CHARACTER*128 CLDP
      CHARACTER*500 CTMA,CTMB
      CHARACTER*8 FRMT
      CHARACTER*64 TXCF
      CHARACTER*32 TXHI
      CHARACTER*128 TXIL
      CHARACTER*32 TXLO
      SAVE   /CTCOM2/
C
C Check for an uncleared prior error.
C
      IF (ICFELL('CTLBAM - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C If initialization has not been done, log an error and quit.
C
      IF (INIT.EQ.0) THEN
        CALL SETER ('CTLBAM - INITIALIZATION CALL NOT DONE',2,1)
        RETURN
      END IF
C
C Do the proper SET call.
C
      CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
      IF (ICFELL('CTLBAM',3).NE.0) RETURN
C
C Make sure we have space for 10 coordinate values in real workspace 1.
C
      CALL CTGRWS (RWRK,1,10,IWSE)
      IF (IWSE.NE.0.OR.ICFELL('CTLBAM',4).NE.0) GO TO 102
C
C If the constant-field flag is set, put the constant-field message box
C into the area map and quit.
C
      IF (ICFF.NE.0) THEN
        CALL CTCFLB (2,RWRK,IAMA)
        IF (ICFELL('CTLBAM',5).NE.0) RETURN
        GO TO 101
      END IF
C
C Make sure label positions have been chosen.
C
      CALL CTPKLP (RPNT,IEDG,ITRI,RWRK,IWRK)
      IF (ICFELL('CTLBAM',6).NE.0) THEN
        NLBS=0
        NR04=0
        INIL=0
        INHL=0
        INLL=0
        RETURN
      END IF
C
C If there are no labels in the label list, quit.
C
      IF (NLBS.LE.0) GO TO 101
C
C Put label boxes into the area map.
C
      CALL SET (XVPL,XVPR,YVPB,YVPT,XVPL,XVPR,YVPB,YVPT,1)
      IF (ICFELL('CTLBAM',7).NE.0) RETURN
C
      DO 10001 I=1,NLBS
        XCLB=RWRK(IR03+4*(I-1)+1)
        YCLB=RWRK(IR03+4*(I-1)+2)
        ANLB=RWRK(IR03+4*(I-1)+3)
        SALB=SIN(ANLB)
        CALB=COS(ANLB)
        ICLB=INT(RWRK(IR03+4*(I-1)+4))
        IF (ICLB.LE.0) THEN
          DLLB=RWRK(IR04-ICLB+3)
          DRLB=RWRK(IR04-ICLB+4)
          DBLB=RWRK(IR04-ICLB+5)
          DTLB=RWRK(IR04-ICLB+6)
        ELSE
          DLLB=CLDL(ICLB)
          DRLB=CLDR(ICLB)
          DBLB=CLDB(ICLB)
          DTLB=CLDT(ICLB)
        END IF
        RWRK(IR01+ 1)=XCLB-DLLB*CALB+DBLB*SALB
        RWRK(IR01+ 2)=XCLB+DRLB*CALB+DBLB*SALB
        RWRK(IR01+ 3)=XCLB+DRLB*CALB-DTLB*SALB
        RWRK(IR01+ 4)=XCLB-DLLB*CALB-DTLB*SALB
        RWRK(IR01+ 5)=RWRK(IR01+1)
        RWRK(IR01+ 6)=YCLB-DLLB*SALB-DBLB*CALB
        RWRK(IR01+ 7)=YCLB+DRLB*SALB-DBLB*CALB
        RWRK(IR01+ 8)=YCLB+DRLB*SALB+DTLB*CALB
        RWRK(IR01+ 9)=YCLB-DLLB*SALB+DTLB*CALB
        RWRK(IR01+10)=RWRK(IR01+6)
        CALL AREDAM (IAMA,RWRK(IR01+1),RWRK(IR01+6),5,IGLB,-1,0)
        IF (ICFELL('CTLBAM',8).NE.0) RETURN
10001 CONTINUE
C
      CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
      IF (ICFELL('CTLBAM',9).NE.0) RETURN
C
C If the area map has no edges in it, something has gone wrong.  Put
C a dummy rectangle in the area map to prevent problems which result.
C
  101 IF (IAMA(7).EQ.0) THEN
        CALL SET (XVPL,XVPR,YVPB,YVPT,XVPL,XVPR,YVPB,YVPT,1)
        IF (ICFELL('CTLBAM',10).NE.0) RETURN
        RWRK(IR01+ 1)=0.
        RWRK(IR01+ 2)=1.
        RWRK(IR01+ 3)=1.
        RWRK(IR01+ 4)=0.
        RWRK(IR01+ 5)=RWRK(IR01+1)
        RWRK(IR01+ 6)=0.
        RWRK(IR01+ 7)=0.
        RWRK(IR01+ 8)=1.
        RWRK(IR01+ 9)=1.
        RWRK(IR01+10)=RWRK(IR01+6)
        CALL AREDAM (IAMA,RWRK(IR01+1),RWRK(IR01+6),5,IGLB,0,-1)
        IF (ICFELL('CTLBAM',11).NE.0) RETURN
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        IF (ICFELL('CTLBAM',12).NE.0) RETURN
      END IF
C
C Release real workspace 1.
C
  102 LR01=0
C
C Done.
C
      RETURN
C
      END
