#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20101229

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "wrapit.y"
#include <stdio.h>
#include <ncarg/hlu/hlu.h>
#include <ncarg/hlu/NresDB.h>
#include <ncarg/ncl/defs.h>
#include <ncarg/ncl/NclDataDefs.h>
#include "WSymbol.h"
#include "fstrings.h"
extern char *yytext;
void yyerror(const char *);
extern char* gettxt();
typedef struct wrap_src_node_list {
	void *node;
	struct wrap_src_node_list *next;
}WrapSrcListNode;

typedef struct int_list {
	int val;
	struct int_list *next;
}IntList;
extern char *wrapname;
int nargs;
int w_nargs;
extern WWrapRec *current;

WParamLoc* theparam = NULL;

WrapSrcListNode *WMakeListNode(void) 
{
	WrapSrcListNode *tmp = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
	tmp->next = NULL;
	tmp->node = NULL;
	return(tmp);
}

extern WCentry *WNewVDef(char* ,int , int ,char* ,int);
extern WGetArgValue *WNewArgVal();
extern WCallRec* WNewCallRec(char* ,int );
extern WSrcList* WNewAdditionalSrc(char*,int);
extern WParamLoc* NewParamLoc(NclSymbol*);

extern void DoTotal(NclSymbol*);
extern void DoDimsizes(NclSymbol*);


int FType(char *fname) {
	switch(fname[0]) {
	case 'i':
	case 'I':
	case 'j':
	case 'J':
	case 'k':
	case 'K':
	case 'l':
	case 'L':
	case 'm':
	case 'M':
	case 'n':
	case 'N':
		return(NCL_int);
	default:
		return(NCL_float);
	}
}
char *NType(int datatype) {
	switch(datatype) {
	case NCL_byte:
		return("NCL_byte");
	case NCL_char:
		return("NCL_char");
	case NCL_float:
		return("NCL_float");
	case NCL_double:
		return("NCL_double");
	case NCL_int:
		return("NCL_int");
	case NCL_short:
		return("NCL_short");
	case NCL_long: 
		return("NCL_long");
	case NCL_none:
		return("NclANY");
	case NCL_string: 
		return("string");
	default:
		return("void");
	}
}
char *CType(int datatype) {
	switch(datatype) {
	case NCL_byte:
		return("byte");
	case NCL_char:
		return("char");
	case NCL_float:
		return("float");
	case NCL_double:
		return("double");
	case NCL_int:
		return("int");
	case NCL_short:
		return("short");
	case NCL_long: 
		return("long");
	case NCL_string: 
		return("string");
	case NCL_none:
	default:
		return("void");
	}
}


#line 115 "wrapit.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
	int integer;
	char *str;
	struct _NclSymbol *sym;
	struct _DimVal *dim;
	struct _FTypeVal *ftyp;
	void *src_node;
	WParamLoc  *ploc;
	WDSpecList *dsp;
	WModList *mod;
	struct int_list *ilist;
	struct wrap_src_node_list *list;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 153 "y.tab.c"
/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#define YYERROR_DECL() yyerror(const char *s)
#define YYERROR_CALL(msg) yyerror(msg)

extern int YYPARSE_DECL();

#define EOLN 257
#define ENDOFIF 258
#define INT 259
#define BYTE1 260
#define INTEGER2 261
#define INTEGER4 262
#define INTEGER8 263
#define REAL4 264
#define REAL8 265
#define DIMENSION 266
#define DATA 267
#define SAVE 268
#define COMMON 269
#define IMPLICIT 270
#define WPARAM 271
#define FNAME 272
#define UNDEF 273
#define SUBROUTINE 274
#define FUNCTION 275
#define NEW 276
#define IN 277
#define OUT 278
#define INOUT 279
#define TYPE 280
#define NOMISSING 281
#define DIMSIZES 282
#define PROCEDURE 283
#define MISSING 284
#define RETURN 285
#define REAL 286
#define PRECISION 287
#define INTEGER 288
#define FLOAT 289
#define LONG 290
#define DOUBLE 291
#define BYTE 292
#define CHARACTER 293
#define STRNG 294
#define SHORT 295
#define LOGICAL 296
#define FARG 297
#define FUNC 298
#define SUBR 299
#define PROC 300
#define XFARG 301
#define CVAR 302
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    0,   12,   12,   12,   30,   12,    2,    2,    1,
    1,   31,   31,   32,   32,   22,   22,   29,   29,    6,
    6,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,   23,   23,    3,
    3,    3,    3,    3,    3,    3,   24,   24,    7,    7,
    7,    9,    9,   14,   14,   14,   13,   13,   13,   13,
   25,   25,    4,    4,    4,    4,   28,   28,   28,   28,
    5,    5,    5,    5,    5,    5,    5,    5,    5,   27,
   27,   15,   33,   15,   21,   21,   21,   21,   26,   26,
   34,   16,   20,   20,   20,   20,   20,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   11,   11,   11,
   11,   11,   11,   11,   11,   19,   19,   18,   18,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
};
static const short yylen[] = {                            2,
    2,    3,    2,    2,    3,    0,    4,    8,    7,    6,
    5,    0,    1,    1,    2,    1,    3,    0,    1,    3,
    4,    1,    1,    1,    2,    1,    1,    1,    1,    1,
    3,    1,    5,    3,    3,    3,    3,    1,    3,    1,
    3,    5,    4,    4,    1,    4,    1,    3,    1,    1,
    1,    0,    1,    0,    1,    1,    7,    7,    5,    6,
    1,    3,    1,    3,    2,    4,    3,    3,    4,    4,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    3,    1,    0,    3,    3,    4,    4,    7,    2,    3,
    0,    3,    5,    3,    4,    4,    7,    1,    1,    2,
    2,    5,    3,    4,    4,    7,    3,    1,    2,    2,
    5,    1,    2,    2,    5,    0,    1,    2,    3,    3,
    3,    1,    1,    1,    3,    3,    4,    4,    2,    2,
};
static const short yydefred[] = {                         0,
   30,   27,   29,   28,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   53,    0,    0,    0,    0,    0,
   25,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    1,    0,   37,   35,   34,    0,   31,   36,    2,    0,
    0,    0,   38,    0,    0,    0,    0,    5,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   14,
   20,    0,    7,    0,    0,   55,   56,    0,   11,    0,
    0,   33,   21,   51,   50,   49,   47,    0,    0,    0,
    0,   41,   39,   15,    0,    0,    0,   17,   10,    0,
   46,   44,   43,    0,    0,    0,   61,    0,    0,    0,
    0,    0,   48,   42,    0,    0,    0,    0,    0,    0,
   59,    0,    9,    0,    0,    0,    0,   82,   91,   83,
    0,   73,   71,   72,   75,   77,   76,   78,   74,   79,
   64,    0,    0,    0,    0,   62,    0,    0,    8,    0,
    0,   80,    0,    0,    0,   68,   67,   66,    0,    0,
    0,    0,    0,    0,    0,   85,    0,    0,   94,    0,
    0,    0,   92,   84,   81,   69,   70,   89,    0,    0,
   87,    0,   95,    0,    0,    0,  122,  123,  124,    0,
    0,    0,  118,    0,   90,    0,    0,    0,    0,   98,
   99,    0,    0,    0,    0,    0,    0,  119,    0,    0,
    0,  100,    0,    0,    0,    0,    0,  108,  112,  125,
  126,  121,  120,   88,   97,    0,    0,    0,  107,  103,
  127,  128,    0,    0,  109,  113,    0,    0,  104,    0,
    0,  102,    0,    0,    0,    0,  111,  115,  106,
};
static const short yydgoto[] = {                         12,
   13,   14,   43,   97,  131,   26,   77,   15,   16,  192,
  211,   17,   48,   68,  117,  118,  183,  162,  163,  119,
  120,   52,   44,   78,   98,  153,  121,  108,   28,   45,
   61,   62,  144,  143,
};
static const short yysindex[] = {                      -160,
    0,    0,    0,    0, -233,    4,   18, -204,   46,   51,
   58, -160, -129, -129,    0, -174, -139,   83, -135, -125,
    0, -101,  -30,  -99, -128, -129, -220,    0, -236, -108,
    0,  -22,    0,    0,    0,  124,    0,    0,    0, -220,
   11,  114,    0,  -19, -236, -103, -100,    0,  -37,  -70,
  144,  148,  149,  -19,  -33,  -68,  -33,  -10, -220,    0,
    0,  -65,    0,  153,  154,    0,    0,  155,    0,  -77,
  -70,    0,    0,    0,    0,    0,    0,  103,  150,  107,
  156,    0,    0,    0,   -8,   -5,   -4,    0,    0,  -33,
    0,    0,    0,  158,  -57,  -17,    0,  108,  -56,  109,
  -70,  161,    0,    0, -156, -110,  -25,  -15,  -69,  -54,
    0,  -52,    0,  -70,  151,  152,  -49,    0,    0,    0,
 -156,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  118,  119, -110,   -7,    0, -156,  -88,    0,  -21,
  -31,    0,  157,  157,  -43,    0,    0,    0,  123,  125,
 -156,  -40,  -88,  -48,  -47,    0,  -46,  -39,    0,  159,
  -36,  163,    0,    0,    0,    0,    0,    0,   24,  142,
    0,  188,    0,  -32,    9,   10,    0,    0,    0,  223,
  229,  231,    0,  -36,    0,   36,   40,   29,   32,    0,
    0,  260,  245,  247,  -35,  -34,  -34,    0,  216,  220,
  225,    0,  -24,  -34,  -34, -249, -247,    0,    0,    0,
    0,    0,    0,    0,    0,   55,   47,   48,    0,    0,
    0,    0,  226,  230,    0,    0,  227,  232,    0,   63,
   65,    0,   66,  233,  234,  235,    0,    0,    0,
};
static const short yyrindex[] = {                        54,
    0,    0,    0,    0,    0, -225, -195,    0, -170, -162,
 -157,   54, -216, -216,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -214,    0, -213,   72,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    5,   19,    0, -202,    0,    0,    0,    0,  291, -202,
  292,    0,    0, -202,    0,    0,    0,    0,    0,    0,
    0, -171,    0,    0,    0,    0,    0,    0,    0,    0,
 -202,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  130,    0,    0,    0,    0,
 -202,    0,    0,    0,    0,    0,    0,  131,    0,    0,
    0,    0,    0, -202,    0,    0,    0,    0,    0,    0,
   74,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   77,   77,    0,    0,    0,    0,    0,    0,
   78,    0,   79,    0,    0,    0,    0,    0,    0,    0,
    0,   81,    0,    0,    0,    0,    0,    0,    0,  -51,
    0,  -50,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -29,  -27,   13,    0,    0,    0,    0,    0,    0,
  -38,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   17,   21,    0,    0,    0,  -26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
static const short yygindex[] = {                         0,
    0,    0,  276,  236, -113,    0,  249,  129,    0,    0,
  -28,  328,  296,    0,  -94,    8,  160,    0,  198,    0,
    0,   22,  303,  289,  261,    0,  211,    0,  335,    0,
  -16,    0,    0,    0,
};
#define YYTABLESIZE 349
static const short yytable[] = {                        207,
  207,  176,  189,  158,   66,  101,   86,   96,   74,   36,
  218,  206,  206,  155,  188,  157,  132,  105,   50,  101,
  148,  223,  217,  225,   59,  154,  145,  175,   93,   81,
  129,  105,   95,   69,  149,   99,  101,   73,   46,   18,
  106,   18,  134,   19,    4,   19,   47,   26,   45,   26,
   55,  224,   41,  226,   89,   12,  145,   56,   18,   20,
   19,    6,   40,   12,   12,   12,   18,   12,   19,    6,
  130,   26,   12,  107,  110,  135,   42,   23,  114,   23,
   12,  210,   21,   12,  113,   12,   13,   22,   12,   12,
   12,   88,   23,   12,   13,   13,   13,  139,   13,   24,
   30,   23,   22,   13,   22,    1,    2,    3,  102,    4,
   32,   13,   32,    5,   13,   24,   13,   24,   31,   13,
   13,   13,   32,   33,   13,    6,   22,    7,  115,   39,
    8,    9,   10,   34,   32,   11,    1,    2,    3,   24,
    4,   27,   27,   91,  116,  152,   90,   93,  110,  112,
   90,  109,  109,   57,   40,   58,    6,   35,    7,   38,
  169,    8,    9,   10,   49,   53,   11,  212,  213,   64,
   63,   65,   65,   63,   65,  221,  222,  122,  123,  124,
  125,  126,  127,  128,  129,  130,   60,   70,   71,   72,
   79,   84,   85,   86,   87,   51,   92,   94,  104,  105,
  111,  114,  137,   96,  138,   86,   96,  142,  140,  141,
  146,  147,  116,  165,  161,  166,  168,  167,  101,  174,
  184,   67,  170,  171,  172,   75,  190,   93,   37,  129,
  105,  173,  186,  133,  219,  208,  208,   60,  191,  159,
  177,  178,  179,  180,  160,  181,  220,  182,   82,  156,
   51,  150,  122,  123,  124,  125,  126,  127,  128,  129,
  130,   45,   45,   76,   96,  209,  209,   96,   51,  130,
   45,   45,   45,  110,   45,   40,   40,  114,  187,   45,
  185,  193,  194,  195,   40,   40,   40,   45,   40,  196,
   45,  197,   45,   40,  199,   45,   45,   45,  200,  201,
   45,   40,  202,  203,   40,  204,   40,  205,  214,   40,
   40,   40,  215,  227,   40,  216,  230,  228,  229,  232,
  231,  234,  233,  235,  236,  237,  238,  239,   52,    3,
   54,   60,   16,  116,   83,   58,   57,  117,  103,   25,
   63,  164,   54,  198,  136,   80,  100,  151,   29,
};
static const short yycheck[] = {                         35,
   35,   38,   35,   35,   42,   44,   58,   58,   42,   40,
   35,   47,   47,   35,   47,   47,   42,   44,   41,   58,
  134,  271,   47,  271,   44,   47,  121,   64,   58,   40,
   58,   58,   41,   50,   42,   41,   41,   54,  275,  273,
   58,  258,   58,  258,  258,   42,  283,  273,   44,  275,
   40,  301,  273,  301,   71,  258,  151,   47,  275,   42,
  275,  275,   44,  266,  267,  268,  283,  270,  283,  283,
   58,  297,  275,   91,   58,   91,  297,  273,   58,  275,
  283,  195,  287,  286,  101,  288,  258,   42,  291,  292,
  293,   70,   42,  296,  266,  267,  268,  114,  270,   42,
  275,  297,  273,  275,  275,  266,  267,  268,   87,  270,
  273,  283,  275,  274,  286,  273,  288,  275,  258,  291,
  292,  293,   40,  259,  296,  286,  297,  288,  285,  258,
  291,  292,  293,  259,  297,  296,  266,  267,  268,  297,
  270,   13,   14,   41,  301,  138,   44,   41,   41,   41,
   44,   44,   44,   40,   26,   42,  286,  259,  288,  259,
  153,  291,  292,  293,  273,   42,  296,  196,  197,  273,
   41,   41,  273,   44,   44,  204,  205,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  257,   44,   41,   41,
  259,  257,   40,   40,   40,  273,   47,   42,   41,  257,
  257,   41,  257,  273,  257,  257,  257,  257,   58,   58,
   93,   93,  301,  257,   58,   93,  257,   93,  257,   61,
   58,  259,  271,  271,  271,  259,  259,  257,  259,  257,
  257,  271,   91,  259,  259,  271,  271,  257,  271,  271,
  277,  278,  279,  280,  276,  282,  271,  284,  259,  271,
  273,  259,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  257,  258,  297,  273,  301,  301,  273,  273,  257,
  266,  267,  268,  257,  270,  257,  258,  257,   91,  275,
  257,  273,  273,   61,  266,  267,  268,  283,  270,   61,
  286,   61,  288,  275,  259,  291,  292,  293,  259,  271,
  296,  283,  271,   44,  286,   61,  288,   61,   93,  291,
  292,  293,   93,  259,  296,   91,   91,  271,  271,   93,
   91,  259,   91,  259,  259,   93,   93,   93,  275,  258,
   40,  258,   41,  257,   59,  258,  258,  257,   90,   12,
   45,  144,   40,  184,  109,   57,   86,  137,   14,
};
#define YYFINAL 12
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 302
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'#'",0,0,"'&'",0,"'('","')'","'*'",0,"','",0,0,"'/'",0,0,0,0,0,0,0,0,0,0,
"':'",0,0,"'='",0,0,"'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"EOLN","ENDOFIF","INT","BYTE1","INTEGER2","INTEGER4",
"INTEGER8","REAL4","REAL8","DIMENSION","DATA","SAVE","COMMON","IMPLICIT",
"WPARAM","FNAME","UNDEF","SUBROUTINE","FUNCTION","NEW","IN","OUT","INOUT",
"TYPE","NOMISSING","DIMSIZES","PROCEDURE","MISSING","RETURN","REAL","PRECISION",
"INTEGER","FLOAT","LONG","DOUBLE","BYTE","CHARACTER","STRNG","SHORT","LOGICAL",
"FARG","FUNC","SUBR","PROC","XFARG","CVAR",
};
static const char *yyrule[] = {
"$accept : interface_list",
"interface_list : interface ENDOFIF",
"interface_list : interface_list interface ENDOFIF",
"interface : function_def odata_defs",
"interface : subroutine_def odata_defs",
"interface : function_def odata_defs wrap_interface",
"$$1 :",
"interface : subroutine_def odata_defs $$1 wrap_interface",
"function_def : otyp FUNCTION UNDEF len '(' arg_list ')' oEOLN_list",
"function_def : otyp FUNCTION UNDEF len '(' ')' oEOLN_list",
"subroutine_def : SUBROUTINE UNDEF '(' arg_list ')' oEOLN_list",
"subroutine_def : SUBROUTINE UNDEF '(' ')' oEOLN_list",
"oEOLN_list :",
"oEOLN_list : EOLN_list",
"EOLN_list : EOLN",
"EOLN_list : EOLN_list EOLN",
"arg_list : UNDEF",
"arg_list : UNDEF ',' arg_list",
"odata_defs :",
"odata_defs : data_defs",
"data_defs : ftype name_list oEOLN_list",
"data_defs : data_defs ftype name_list oEOLN_list",
"ftype : BYTE",
"ftype : INTEGER",
"ftype : LOGICAL",
"ftype : DOUBLE PRECISION",
"ftype : REAL",
"ftype : DATA",
"ftype : IMPLICIT",
"ftype : SAVE",
"ftype : DIMENSION",
"ftype : CHARACTER '*' INT",
"ftype : CHARACTER",
"ftype : CHARACTER '*' '(' '*' ')'",
"ftype : BYTE '*' INT",
"ftype : INTEGER '*' INT",
"ftype : LOGICAL '*' INT",
"ftype : REAL '*' INT",
"name_list : param_def",
"name_list : name_list ',' param_def",
"param_def : FARG",
"param_def : FARG '*' INT",
"param_def : FARG '*' '(' '*' ')'",
"param_def : FARG '(' dim_list ')'",
"param_def : UNDEF '/' INT '/'",
"param_def : UNDEF",
"param_def : UNDEF '(' dim_list ')'",
"dim_list : dim",
"dim_list : dim_list ',' dim",
"dim : FARG",
"dim : INT",
"dim : '*'",
"otyp :",
"otyp : ftype",
"len :",
"len : '*'",
"len : INT",
"wrap_interface : PROCEDURE UNDEF '(' arg_dec_list ')' EOLN parg_map_list",
"wrap_interface : FUNCTION UNDEF '(' arg_dec_list ')' EOLN farg_map_list",
"wrap_interface : PROCEDURE UNDEF '(' ')' EOLN",
"wrap_interface : FUNCTION UNDEF '(' ')' EOLN farg_map_list",
"arg_dec_list : declaration",
"arg_dec_list : arg_dec_list ',' declaration",
"declaration : UNDEF",
"declaration : UNDEF ':' datatype",
"declaration : UNDEF dim_size_list",
"declaration : UNDEF dim_size_list ':' datatype",
"dim_size_list : '[' INT ']'",
"dim_size_list : '[' '*' ']'",
"dim_size_list : dim_size_list '[' '*' ']'",
"dim_size_list : dim_size_list '[' INT ']'",
"datatype : FLOAT",
"datatype : LONG",
"datatype : INTEGER",
"datatype : SHORT",
"datatype : DOUBLE",
"datatype : CHARACTER",
"datatype : BYTE",
"datatype : STRNG",
"datatype : LOGICAL",
"farg_map_list : farg_map EOLN",
"farg_map_list : farg_map_list farg_map EOLN",
"farg_map : normal_param",
"$$2 :",
"farg_map : rparam $$2 omods",
"rparam : RETURN ':' WPARAM",
"rparam : RETURN ':' '/' WPARAM",
"rparam : RETURN ':' '#' WPARAM",
"rparam : RETURN ':' '/' WPARAM '[' INT ']'",
"parg_map_list : normal_param EOLN",
"parg_map_list : parg_map_list normal_param EOLN",
"$$3 :",
"normal_param : param_loc $$3 omods",
"param_loc : XFARG ':' NEW '=' dspec_list",
"param_loc : XFARG ':' WPARAM",
"param_loc : XFARG ':' '#' WPARAM",
"param_loc : XFARG ':' '/' WPARAM",
"param_loc : XFARG ':' '/' WPARAM '[' INT ']'",
"dspec_list : INT",
"dspec_list : WPARAM",
"dspec_list : '#' WPARAM",
"dspec_list : '/' WPARAM",
"dspec_list : '/' WPARAM '[' INT ']'",
"dspec_list : dspec_list ',' WPARAM",
"dspec_list : dspec_list ',' '#' WPARAM",
"dspec_list : dspec_list ',' '/' WPARAM",
"dspec_list : dspec_list ',' '/' WPARAM '[' INT ']'",
"dspec_list : dspec_list ',' INT",
"vspec : WPARAM",
"vspec : '#' WPARAM",
"vspec : '/' WPARAM",
"vspec : '/' WPARAM '[' INT ']'",
"vspec : XFARG",
"vspec : '#' XFARG",
"vspec : '/' XFARG",
"vspec : '/' XFARG '[' INT ']'",
"omods :",
"omods : mods_list",
"mods_list : ':' mod",
"mods_list : mods_list ':' mod",
"mod : MISSING '=' vspec",
"mod : DIMSIZES '=' vspec",
"mod : IN",
"mod : OUT",
"mod : INOUT",
"mod : TYPE '=' datatype",
"mod : TYPE '=' vspec",
"mod : '@' UNDEF '=' vspec",
"mod : '&' UNDEF '=' vspec",
"mod : '@' UNDEF",
"mod : '&' UNDEF",

};
#endif
/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 2007 "wrapit.y"
void yyerror
#if __STDC__
(const char *s)
#else
(s)
	char *s;
#endif
{
	char error_buffer[1024];
	int i;

	
	fprintf(stderr,"A syntax error occurred while parsing: %s\n",yytext);
	exit(0);
}
#line 629 "y.tab.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 155 "wrapit.y"
	{
		WVDefList *c_vdefs;
		WArgValList *c_argval;
		WSrcList *additional_src;
		WCallRec *c_callrec;
		char buffer[BUFFSIZE];
		char upper[BUFFSIZE];
		char lower[BUFFSIZE];
		int i;


		c_callrec = current->c_callrec;
		fprintf(stdout,fdef_fmt,current->c_defstring);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			sprintf(buffer,"%s ",CType(c_vdefs->def->datatype));
			if(c_vdefs->def->isptr) {
				strcat(buffer,"*");
			}
			strcat(buffer,c_vdefs->def->string);
			if(c_vdefs->def->array_spec != NULL) {
				strcat(buffer,c_vdefs->def->array_spec);
			}
			fprintf(stdout,"\t%s;\n",buffer);
			c_vdefs = c_vdefs->next;
		}
		
		c_argval = current->c_argval;
		while(c_argval != NULL) {
			fprintf(stdout,argval_fmt,
				c_argval->arec->assign_to,
				CType(c_argval->arec->datatype),
				c_argval->arec->pnum,
				c_argval->arec->totalp,
				c_argval->arec->ndims==NULL?"NULL":c_argval->arec->ndims,
				c_argval->arec->dimsizes==NULL?"NULL":c_argval->arec->dimsizes,
				c_argval->arec->missing==NULL?"NULL":c_argval->arec->missing,
				c_argval->arec->hasmissing==NULL?"NULL":c_argval->arec->hasmissing,
				c_argval->arec->type==NULL?"NULL":c_argval->arec->type,
				c_argval->arec->rw);
			additional_src = c_argval->arec->additional_src;
			while(additional_src != NULL) {
				if(additional_src->src) {
					fprintf(stdout,"%s",additional_src->src);
				}
				additional_src = additional_src->next;
			}
			c_argval = c_argval->next;	
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 0) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 1) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_callrec = current->c_callrec;
		fprintf(stdout,"\t%s",c_callrec->callstring);
		sprintf(buffer,"(");
		for(i = 0; i < c_callrec->n_args;i++) {
			if(c_callrec->arg_strings[i] == NULL) {
				strcat(buffer,"NULL");
			} else if(!c_callrec->arg_strings[i]->isptr) {
				strcat(buffer,"&");
				strcat(buffer,c_callrec->arg_strings[i]->string);
			} else {
				strcat(buffer,c_callrec->arg_strings[i]->string);
			}
			if(i!= c_callrec->n_args-1) {
				strcat(buffer,",");
			} 
		}
		if(c_callrec->nstrs != 0) {
			strcat(buffer,",");
			for(;i < c_callrec->n_args+c_callrec->nstrs;i++) {
				strcat(buffer,c_callrec->arg_strings[i]->string);
				if(i!= c_callrec->n_args + c_callrec->nstrs -1) {
					strcat(buffer,",");
				} 
			}
		}
		strcat(buffer,");\n\n");
		fprintf(stdout,"%s",buffer);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 2) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		fprintf(stdout,"\t%s\n",current->rtrn);
		fprintf(stdout,"}\n");
		
		nargs = 0;
		w_nargs = 0;
	}
break;
case 2:
#line 277 "wrapit.y"
	{
		WVDefList *c_vdefs;
		WArgValList *c_argval;
		WSrcList *additional_src;
		WCallRec *c_callrec;
		char buffer[BUFFSIZE];
		char upper[BUFFSIZE];
		char lower[BUFFSIZE];
		int i;


		c_callrec = current->c_callrec;
		fprintf(stdout,fdef_fmt,current->c_defstring);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			sprintf(buffer,"%s ",CType(c_vdefs->def->datatype));
			if(c_vdefs->def->isptr) {
				strcat(buffer,"*");
			}
			strcat(buffer,c_vdefs->def->string);
			if(c_vdefs->def->array_spec != NULL) {
				strcat(buffer,c_vdefs->def->array_spec);
			}
			fprintf(stdout,"\t%s;\n",buffer);
			c_vdefs = c_vdefs->next;
		}
		
		c_argval = current->c_argval;
		while(c_argval != NULL) {
			fprintf(stdout,argval_fmt,
				c_argval->arec->assign_to,
				CType(c_argval->arec->datatype),
				c_argval->arec->pnum,
				c_argval->arec->totalp,
				c_argval->arec->ndims==NULL?"NULL":c_argval->arec->ndims,
				c_argval->arec->dimsizes==NULL?"NULL":c_argval->arec->dimsizes,
				c_argval->arec->missing==NULL?"NULL":c_argval->arec->missing,
				c_argval->arec->hasmissing==NULL?"NULL":c_argval->arec->hasmissing,
				c_argval->arec->type==NULL?"NULL":c_argval->arec->type,
				c_argval->arec->rw);
			if(c_argval->arec->additional_src != NULL) {
				fprintf(stdout,"%s",c_argval->arec->additional_src);
			}
			c_argval = c_argval->next;
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order==0 ) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				} 
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order==1 ) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				} 
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_callrec = current->c_callrec;
		fprintf(stdout,"\t%s",c_callrec->callstring);
		sprintf(buffer,"(");
		for(i = 0; i < c_callrec->n_args;i++) {
			if(c_callrec->arg_strings[i] == NULL) {
				strcat(buffer,"NULL");
			} else if(!c_callrec->arg_strings[i]->isptr) {
				strcat(buffer,"&");
				strcat(buffer,c_callrec->arg_strings[i]->string);
			} else {
				strcat(buffer,c_callrec->arg_strings[i]->string);
			}
		
			if((i!= c_callrec->n_args-1)) {
				strcat(buffer,",");
			} 
		}
		if(c_callrec->nstrs != 0) {
			strcat(buffer,",");
			for(;i < c_callrec->n_args+c_callrec->nstrs;i++) {
				strcat(buffer,c_callrec->arg_strings[i]->string);
				if(i!= c_callrec->n_args + c_callrec->nstrs -1) {
					strcat(buffer,",");
				} 
			}
		}
		strcat(buffer,");\n\n");
		fprintf(stdout,"%s",buffer);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 2) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		fprintf(stdout,"\t%s\n",current->rtrn);
		fprintf(stdout,"}\n");
		
		nargs = 0;
		w_nargs = 0;
	}
break;
case 3:
#line 396 "wrapit.y"
	{
/*
* No wrapper info, so output records have not been built.
*/
		int i,j,tmpj,nstrs;
		NclSymbol *s,*s0;
		NclSymbol *wp;
		char buffer[BUFFSIZE];
		char upper[BUFFSIZE];
		char lower[BUFFSIZE];
		WGetArgValue *arg;
		WCallRec *thecall;
		NclSymbol **tmp;
		WCentry *tmpc;
		WSrcList *tmp_src;

		thecall = WNewCallRec(yystack.l_mark[-1].sym->name,nargs);
/*
* Now since its a one-one function the wrapper parameter information must
* be take from the FORTRAN information This list would otherwise be created
* already.
*/
		for(i = 0; i < strlen(yystack.l_mark[-1].sym->name); i++) {
                        if((!isdigit(yystack.l_mark[-1].sym->name[i]))&&(isalpha(yystack.l_mark[-1].sym->name[i]))) {
                        	if(isupper(yystack.l_mark[-1].sym->name[i])) {
                               		upper[i] = yystack.l_mark[-1].sym->name[i];
                               		lower[i] = (char)((int)yystack.l_mark[-1].sym->name[i] + 32);
                        	} else {
                                	lower[i] = yystack.l_mark[-1].sym->name[i];
                                	upper[i] = (char)((int)yystack.l_mark[-1].sym->name[i] - 32);
                        	}
			} else {
				upper[i] = lower[i] = yystack.l_mark[-1].sym->name[i];
			}
                }
		lower[i] = '\0';
		upper[i] = '\0';
		fprintf(stdout,"extern %s NGCALLF(%s,%s)();\n",CType(yystack.l_mark[-1].sym->u.func->datatype),lower,upper);

		current->f_or_p = 1;
		current->c_defstring = malloc(strlen(yystack.l_mark[-1].sym->name)+1);
		strcpy(current->c_defstring, yystack.l_mark[-1].sym->name);

		sprintf(buffer,"%s_ret",yystack.l_mark[-1].sym->name);
		tmpc = WNewVDef(buffer,yystack.l_mark[-1].sym->u.func->datatype,0,NULL,0);

		sprintf(buffer,"%s = NGCALLF(%s,%s)",tmpc->string,lower,upper);
		thecall->callstring = malloc(strlen(buffer)+1);
		strcpy(thecall->callstring,buffer);

		sprintf(buffer,"%s_ret_dimsizes",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,"[NCL_MAX_DIMENSIONS]",0);
		

		for (i = 0; i < yystack.l_mark[-1].sym->u.func->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.func->args[i];
/*
* Also since no wrapper only need to retrieve pointer to var
* no need for ndims,dimsizes,missing....
*/
			wp = _NclAddInScope(current->wrec,(char*)s->name,WPARAM);
			wp->u.wparam = (WParamInfo*)malloc(sizeof(WParamInfo));


			arg = WNewArgVal();
			if(s->u.farg->datatype == NCL_none) {
				s->u.farg->datatype = wp->u.wparam->datatype = FType(s->name);
			} else {
				wp->u.wparam->datatype = s->u.farg->datatype;
			}
			wp->u.wparam->n_dims = s->u.farg->n_dims;
			for(j = 0; j < s->u.farg->n_dims; j++) {
				wp->u.wparam->dim_sizes[j] = s->u.farg->dim_sizes[j];
			}
			arg->assign_to = s->name;
			arg->datatype = s->u.farg->datatype;
			arg->pnum = i;
			arg->totalp = yystack.l_mark[-1].sym->u.func->n_args;
			arg->rw = 1;
			arg->nd[0] = '\t';
			arg->nd[1] = ')';
			arg->nd[2] = ';';
			arg->nd[3] = '\n';
			arg->nd[4] = '\0';
			wp->u.wparam->getarg = arg;
			thecall->arg_strings[i] = WNewVDef(s->name,s->u.farg->datatype,1,NULL,0);
		}
/*
* This loop searches for string arguments and defines the length argument needed by FORTRAN
*/
		nstrs = 0;
		for (i = 0; i < yystack.l_mark[-1].sym->u.func->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.func->args[i];
			if(s->u.farg->datatype == NCL_string) {
				sprintf(buffer,"%s_len",s->name);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs] = WNewVDef(buffer,NCL_int,0,NULL,0);
				sprintf(buffer,"\t%s_len = strlen(NrmQuarkToString(*%s));\n",s->name,s->name);
				tmp_src = thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs]->additional_src;
				thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs]->additional_src->next = tmp_src;


				sprintf(buffer,"%s_str",s->name);
				thecall->arg_strings[i] = WNewVDef(buffer,NCL_char,1,NULL,1);
				sprintf(buffer,"\t%s_str = malloc(%s_len + 1);\n\tstrcpy(%s_str,NrmQuarkToString(*%s));\n",s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[i]->additional_src->next = tmp_src;
				sprintf(buffer,"\t%s_str[%s_len] = \'\\0\';\n\t*%s = NrmStringToQuark(%s_str);\n\tfree(%s_str);\n",s->name,s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,2);
				thecall->arg_strings[i]->additional_src->next = tmp_src;

				nstrs++;
			} else {
				for(j = 0; j < yystack.l_mark[-1].sym->u.func->args[i]->u.farg->n_dims; j++) {
					if(yystack.l_mark[-1].sym->u.func->args[i]->u.farg->dim_refs[j] != NULL) {
						s0 = _NclLookUpInScope(current->wrec,yystack.l_mark[-1].sym->u.func->args[i]->name);
						DoDimsizes(s0);
						sprintf(buffer,"\tif(*%s != %s_dimsizes[%d]) {\n\t\tNhlPError(NhlFATAL,NhlEUNKNOWN,\"%s: dimension size of dimension (%d) of %s must be equal to the value of %s\");\n\t\treturn(NhlFATAL);\n\t}\n",yystack.l_mark[-1].sym->u.func->args[i]->u.farg->dim_refs[j]->name,yystack.l_mark[-1].sym->u.func->args[i]->name,j,yystack.l_mark[-1].sym->name,j,yystack.l_mark[-1].sym->u.func->args[i]->name,yystack.l_mark[-1].sym->u.func->args[i]->u.farg->dim_refs[j]->name);
						tmp_src = thecall->arg_strings[i]->additional_src;
						thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
						thecall->arg_strings[i]->additional_src->next = tmp_src;
					}
				}
			}
		}
		thecall->nstrs = nstrs;
		sprintf(buffer,"%s_ret_dimsizes[0] = 1;\n\treturn(NclReturnValue(&%s_ret,1,%s_ret_dimsizes,NULL,%s,1));",yystack.l_mark[-1].sym->name,yystack.l_mark[-1].sym->name,yystack.l_mark[-1].sym->name,NType(yystack.l_mark[-1].sym->u.func->datatype));
		current->rtrn = malloc(strlen(buffer)+1);
		strcpy(current->rtrn,buffer);
		
	}
break;
case 4:
#line 531 "wrapit.y"
	{
/*
* No wrapper info, so output records have not been built.
*/
		int i,j,nstrs,tmpj;
		NclSymbol *s,*s0;
		NclSymbol *wp;
		char buffer[BUFFSIZE];
		char lower[BUFFSIZE];
		char upper[BUFFSIZE];
		WGetArgValue *arg;
		WCallRec *thecall;
		NclSymbol **tmp;
		WSrcList *tmp_src;

		thecall = WNewCallRec(yystack.l_mark[-1].sym->name,nargs);
/*
* Now since its a one-one function the wrapper parameter information must
* be take from the FORTRAN information This list would otherwise be created
* already.
*/
		for(i = 0; i < strlen(yystack.l_mark[-1].sym->name); i++) {
			if((!isdigit(yystack.l_mark[-1].sym->name[i]))&&(isalpha(yystack.l_mark[-1].sym->name[i]))) {
                        	if(isupper(yystack.l_mark[-1].sym->name[i])) {
                                	upper[i] = yystack.l_mark[-1].sym->name[i];
                                	lower[i] = (char)((int)yystack.l_mark[-1].sym->name[i] + 32);
                        	} else {
                                	lower[i] = yystack.l_mark[-1].sym->name[i];
                                	upper[i] = (char)((int)yystack.l_mark[-1].sym->name[i] - 32);
                        	}
			} else {
                                	upper[i] = lower[i] = yystack.l_mark[-1].sym->name[i];
			}
                }
		lower[i] = '\0';
		upper[i] = '\0';
		sprintf(buffer,"NGCALLF(%s,%s)",lower,upper);
		thecall->callstring = malloc(strlen(buffer)+1);
		strcpy(thecall->callstring,buffer);
		current->f_or_p = 0;
		current->c_defstring = malloc(strlen(yystack.l_mark[-1].sym->name)+1);
		strcpy(current->c_defstring, yystack.l_mark[-1].sym->name);
		for (i = 0; i < yystack.l_mark[-1].sym->u.subr->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.subr->args[i];
/*
* Also since no wrapper only need to retrieve pointer to var
* no need for ndims,dimsizes,missing....
*/
			wp = _NclAddInScope(current->wrec,(char*)s->name,WPARAM);
			wp->u.wparam = (WParamInfo*)malloc(sizeof(WParamInfo));


			arg = WNewArgVal();
			if(s->u.farg->datatype == NCL_none) {
				s->u.farg->datatype = wp->u.wparam->datatype = FType(s->name);
			} else {
				wp->u.wparam->datatype = s->u.farg->datatype;
			}
			wp->u.wparam->n_dims = s->u.farg->n_dims;
			for(j = 0; j < s->u.farg->n_dims; j++) {
				wp->u.wparam->dim_sizes[j] = s->u.farg->dim_sizes[j];
			}
			arg->assign_to = s->name;
			arg->datatype = s->u.farg->datatype;
			arg->pnum = i;
			arg->totalp = yystack.l_mark[-1].sym->u.subr->n_args;
			arg->rw = 1;
			arg->nd[0] = '\t';
			arg->nd[1] = ')';
			arg->nd[2] = ';';
			arg->nd[3] = '\n';
			arg->nd[4] = '\0';
			wp->u.wparam->getarg = arg;
			thecall->arg_strings[i] = WNewVDef(s->name,s->u.farg->datatype,1,NULL,0);
		}
/*
* This loop searches for string arguments and defines the length argument needed by FORTRAN
*/
		nstrs = 0;
		for (i = 0; i < yystack.l_mark[-1].sym->u.subr->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.subr->args[i];
			if(s->u.farg->datatype == NCL_string) {
				sprintf(buffer,"%s_len",s->name);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs] = WNewVDef(buffer,NCL_int,0,NULL,0);
				sprintf(buffer,"\t%s_len = strlen(NrmQuarkToString(*%s));\n",s->name,s->name);
				tmp_src = thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs]->additional_src;
				thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs]->additional_src->next = tmp_src;


				sprintf(buffer,"%s_str",s->name);
				thecall->arg_strings[i] = WNewVDef(buffer,NCL_char,1,NULL,1);
				sprintf(buffer,"\t%s_str = malloc(%s_len + 1);\n\tstrcpy(%s_str,NrmQuarkToString(*%s));\n",s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[i]->additional_src->next = tmp_src;
				sprintf(buffer,"\t%s_str[%s_len] = \'\\0\';\n\t*%s = NrmStringToQuark(%s_str);\n\tfree(%s_str);\n",s->name,s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,2);
				thecall->arg_strings[i]->additional_src->next = tmp_src;
				nstrs++;
			} else {
				for(j = 0; j < yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->n_dims; j++) {
					if(yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->dim_refs[j] != NULL) {
						s0 = _NclLookUpInScope(current->wrec,yystack.l_mark[-1].sym->u.subr->args[i]->name);
						DoDimsizes(s0);
						sprintf(buffer,"\tif(*%s != %s_dimsizes[%d]) {\n\t\tNhlPError(NhlFATAL,NhlEUNKNOWN,\"%s: dimension size of dimension (%d) of %s must be equal to the value of %s\");\n\t\treturn(NhlFATAL);\n\t}\n",yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->dim_refs[j]->name,yystack.l_mark[-1].sym->u.subr->args[i]->name,j,yystack.l_mark[-1].sym->name,j,yystack.l_mark[-1].sym->u.subr->args[i]->name,yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->dim_refs[j]->name);
						tmp_src = thecall->arg_strings[i]->additional_src;
						thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
						thecall->arg_strings[i]->additional_src->next = tmp_src;
					}
				}
			}
		}
		thecall->nstrs = nstrs;
		current->rtrn = malloc(strlen("return(NhlNOERROR);")+1);
		strcpy(current->rtrn,"return(NhlNOERROR);");
		
		
	}
break;
case 5:
#line 653 "wrapit.y"
	{
        }
break;
case 6:
#line 655 "wrapit.y"
	{ (void)WNewCallRec(yystack.l_mark[-1].sym->name,nargs); }
break;
case 7:
#line 656 "wrapit.y"
	{
        }
break;
case 8:
#line 661 "wrapit.y"
	{
		WrapSrcListNode* tmp,*tmp2;
		int count = 0;
		yystack.l_mark[-5].sym->type = FUNC;
		yystack.l_mark[-5].sym->u.func = (WFuncInfo*)malloc(sizeof(WFuncInfo));

                tmp = yystack.l_mark[-2].list;
                while(tmp != NULL) {
                        count++;
                        tmp = tmp->next;
                }
		yystack.l_mark[-5].sym->u.func->n_args = count;
		yystack.l_mark[-5].sym->u.func->args = (NclSymbol**)malloc(sizeof(NclSymbol*)*count);
		if(yystack.l_mark[-7].ftyp == NULL) {
			yystack.l_mark[-5].sym->u.func->datatype = FType(yystack.l_mark[-5].sym->name);
		} else {
			yystack.l_mark[-5].sym->u.func->datatype = yystack.l_mark[-7].ftyp->datatype;
		}
		tmp = yystack.l_mark[-2].list;
		for(count = 0; count < yystack.l_mark[-5].sym->u.func->n_args; count++) {
			yystack.l_mark[-5].sym->u.func->args[count] = tmp->node;
			tmp2 = tmp;
			tmp = tmp->next;
			free(tmp2);
		}
		yyval.sym = yystack.l_mark[-5].sym;
		

	}
break;
case 9:
#line 691 "wrapit.y"
	{
		yystack.l_mark[-4].sym->type = FUNC;
		yystack.l_mark[-4].sym->u.func = (WFuncInfo*)malloc(sizeof(WFuncInfo));
		yystack.l_mark[-4].sym->u.func->n_args = 0;
		yystack.l_mark[-4].sym->u.func->args = NULL;
		if(yystack.l_mark[-6].ftyp == NULL) {
			yystack.l_mark[-4].sym->u.func->datatype = FType(yystack.l_mark[-4].sym->name);
		} else {
			yystack.l_mark[-4].sym->u.func->datatype = yystack.l_mark[-6].ftyp->datatype;
		}
		yyval.sym = yystack.l_mark[-4].sym;
	}
break;
case 10:
#line 706 "wrapit.y"
	{
		WrapSrcListNode* tmp,*tmp2;
		int count = 0;
		yystack.l_mark[-4].sym->type = SUBR;
		yystack.l_mark[-4].sym->u.subr = (WSubrInfo*)malloc(sizeof(WSubrInfo));
	
		tmp = yystack.l_mark[-2].list;
		while(tmp != NULL) {
			count++;
			tmp = tmp->next;
		}
		yystack.l_mark[-4].sym->u.subr->args = (NclSymbol**)malloc(sizeof(NclSymbol*)*count);
		yystack.l_mark[-4].sym->u.subr->n_args = count;
		tmp = yystack.l_mark[-2].list;
		for( count = 0; count < yystack.l_mark[-4].sym->u.subr->n_args; count++ ) {
			yystack.l_mark[-4].sym->u.subr->args[count] = tmp->node;
			tmp2 =tmp;
			tmp = tmp->next;
			free(tmp2);
		}
		yyval.sym = yystack.l_mark[-4].sym;
	}
break;
case 11:
#line 729 "wrapit.y"
	{
		yystack.l_mark[-3].sym->type = SUBR;
		yystack.l_mark[-3].sym->u.subr = (WSubrInfo*)malloc(sizeof(WSubrInfo));
		yystack.l_mark[-3].sym->u.subr->args = NULL;
		yystack.l_mark[-3].sym->u.subr->n_args = 0;
		yyval.sym = yystack.l_mark[-3].sym;
	}
break;
case 12:
#line 738 "wrapit.y"
	{
	}
break;
case 13:
#line 741 "wrapit.y"
	{
	}
break;
case 14:
#line 745 "wrapit.y"
	{
	}
break;
case 15:
#line 748 "wrapit.y"
	{
	}
break;
case 16:
#line 752 "wrapit.y"
	{
		NclSymbol *s;
		char buffer[10];
		yystack.l_mark[0].sym->type = FARG;
		yystack.l_mark[0].sym->u.farg = (WFargInfo*)malloc(sizeof(WFargInfo));
		yystack.l_mark[0].sym->u.farg->arg_num = nargs;
		yystack.l_mark[0].sym->u.farg->dim_sizes[0] = 1;
		yystack.l_mark[0].sym->u.farg->dim_refs[0] = NULL;
		yystack.l_mark[0].sym->u.farg->n_dims = 1;
		sprintf(buffer,"FARG%d",nargs++);
#if  YYDEBUG
#endif
		s = _NclAddInScope(current->wrec,buffer,XFARG);
		s->u.xref = yystack.l_mark[0].sym;
		yyval.list = WMakeListNode();
		yyval.list->node = yystack.l_mark[0].sym;
		yyval.list->next = NULL;
	}
break;
case 17:
#line 771 "wrapit.y"
	{
		NclSymbol *s;
		char buffer[BUFFSIZE];
		yystack.l_mark[-2].sym->u.farg = (WFargInfo*)malloc(sizeof(WFargInfo));
		yystack.l_mark[-2].sym->type = FARG;
		yystack.l_mark[-2].sym->u.farg->arg_num = nargs;
		yystack.l_mark[-2].sym->u.farg->dim_sizes[0] = 1;
		yystack.l_mark[-2].sym->u.farg->dim_refs[0] = NULL;
		yystack.l_mark[-2].sym->u.farg->n_dims = 1;
		sprintf(buffer,"FARG%d",nargs++);
#if  YYDEBUG
#endif

		s = _NclAddInScope(current->wrec,buffer,XFARG);
		s->u.xref = yystack.l_mark[-2].sym;
		yyval.list = WMakeListNode();
		yyval.list->node = yystack.l_mark[-2].sym;
		yyval.list->next = yystack.l_mark[0].list;
	}
break;
case 18:
#line 792 "wrapit.y"
	{
	}
break;
case 19:
#line 795 "wrapit.y"
	{
	}
break;
case 20:
#line 800 "wrapit.y"
	{
		WrapSrcListNode * tmp,*tmp2;
/*
*------> This is where problems with MD char arrays happens
*/
		tmp = yystack.l_mark[-1].list;
		while(tmp != NULL) {
			tmp2 = tmp;
			((NclSymbol*)tmp->node)->u.farg->datatype = yystack.l_mark[-2].ftyp->datatype;
			if((yystack.l_mark[-2].ftyp->datatype == NCL_char)&&(yystack.l_mark[-2].ftyp->size != -1)) {
				((NclSymbol*)tmp->node)->u.farg->dim_sizes[0] = yystack.l_mark[-2].ftyp->size;
				((NclSymbol*)tmp->node)->u.farg->dim_refs[0] = NULL;
			}
			tmp = tmp->next;
			free(tmp2);
		}

	}
break;
case 21:
#line 818 "wrapit.y"
	{
		WrapSrcListNode * tmp,*tmp2;

		tmp = yystack.l_mark[-1].list;
		while(tmp != NULL) {
			tmp2 = tmp;
			((NclSymbol*)tmp->node)->u.farg->datatype = yystack.l_mark[-2].ftyp->datatype;
			if((yystack.l_mark[-2].ftyp->datatype == NCL_char)&&(yystack.l_mark[-2].ftyp->size != -1)) {
				((NclSymbol*)tmp->node)->u.farg->dim_sizes[0] = yystack.l_mark[-2].ftyp->size;
				((NclSymbol*)tmp->node)->u.farg->dim_refs[0] = NULL;
			}
			tmp = tmp->next;
			free(tmp2);
		}
	}
break;
case 22:
#line 835 "wrapit.y"
	{	yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_byte;
		yyval.ftyp->size = -1;
	}
break;
case 23:
#line 840 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_int;
		yyval.ftyp->size = -1;
	}
break;
case 24:
#line 846 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_logical;
		yyval.ftyp->size = -1;
	}
break;
case 25:
#line 852 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_double;
		yyval.ftyp->size = -1;
	}
break;
case 26:
#line 858 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_float;
		yyval.ftyp->size = -1;
	}
break;
case 27:
#line 864 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
break;
case 28:
#line 870 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
break;
case 29:
#line 876 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
break;
case 30:
#line 882 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
break;
case 31:
#line 887 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype =  NCL_char;
		yyval.ftyp->size = yystack.l_mark[0].integer;
	}
break;
case 32:
#line 893 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype =  NCL_char;
		yyval.ftyp->size = -1;
	}
break;
case 33:
#line 899 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_string;
		yyval.ftyp->size = -1;
	}
break;
case 34:
#line 905 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer) {
		case 1:
			yyval.ftyp->datatype = NCL_byte;
			break;
		case 2:
			yyval.ftyp->datatype = NCL_short;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_int;
			break;
		default:
			yyval.ftyp->datatype = NCL_none;
		}
	}
break;
case 35:
#line 923 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer){
		case 1:
			yyval.ftyp->datatype = NCL_byte;
			break;
		case 2:
			yyval.ftyp->datatype = NCL_short;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_int;
			break;
		case 8:
			if(sizeof(long)==8) {
				yyval.ftyp->datatype = NCL_long;
			} else {
				yyval.ftyp->datatype = NCL_none;
			}
		default:
			yyval.ftyp = NCL_none;
		}
	}
break;
case 36:
#line 947 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer){
		case 1:
			yyval.ftyp->datatype = NCL_byte;
			break;
		case 2:
			yyval.ftyp->datatype = NCL_short;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_logical;
			break;
		default:
			yyval.ftyp->datatype = NCL_none;
		}
	}
break;
case 37:
#line 965 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer){
		case 1:
		case 2:
			yyval.ftyp->datatype = NCL_none;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_float;
			break;
		case 8:
			yyval.ftyp->datatype = NCL_double;
			break;
		default:
			yyval.ftyp = NCL_none;
		}
	}
break;
case 38:
#line 987 "wrapit.y"
	{
		if(yystack.l_mark[0].sym != NULL) {
			yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
			yyval.list->node = yystack.l_mark[0].sym;
			yyval.list->next = NULL;
		} else {
			yyval.list = NULL;
		}
	}
break;
case 39:
#line 997 "wrapit.y"
	{
		if(yystack.l_mark[0].sym != NULL) {
			yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
			yyval.list->node = yystack.l_mark[0].sym;
			yyval.list->next = yystack.l_mark[-2].list;
		} else {
			yyval.list = yystack.l_mark[-2].list;
		}
	}
break;
case 40:
#line 1009 "wrapit.y"
	{
		yystack.l_mark[0].sym->u.farg->n_dims = 1;
		yystack.l_mark[0].sym->u.farg->dim_sizes[0] = 1;
		yyval.sym = yystack.l_mark[0].sym;
	}
break;
case 41:
#line 1015 "wrapit.y"
	{
		yystack.l_mark[-2].sym->u.farg->n_dims = 1;
		yystack.l_mark[-2].sym->u.farg->dim_sizes[0] = yystack.l_mark[0].integer;
		yyval.sym = yystack.l_mark[-2].sym;
	}
break;
case 42:
#line 1021 "wrapit.y"
	{
		yystack.l_mark[-4].sym->u.farg->n_dims = 1;
		yystack.l_mark[-4].sym->u.farg->dim_sizes[0] = -1;
		yyval.sym = yystack.l_mark[-4].sym;
	}
break;
case 43:
#line 1027 "wrapit.y"
	{
		int n_dims=0;
		int i;
		WrapSrcListNode* tmp;
		tmp = yystack.l_mark[-1].list;
		while(tmp != NULL) {
			n_dims++;
			tmp = tmp->next;
		}
		yystack.l_mark[-3].sym->u.farg->n_dims = n_dims;
		tmp = yystack.l_mark[-1].list;
		for(i = 0; i < n_dims; i++) {
			if(((DimVal*)tmp->node)->kind) {
				yystack.l_mark[-3].sym->u.farg->dim_sizes[i]  = -1;
				yystack.l_mark[-3].sym->u.farg->dim_refs[i] = ((DimVal*)tmp->node)->u.sym;
			} else {
				yystack.l_mark[-3].sym->u.farg->dim_refs[i]  = NULL;
				yystack.l_mark[-3].sym->u.farg->dim_sizes[i] = ((DimVal*)tmp->node)->u.val;
			}
			tmp = tmp->next;
		}
		yyval.sym = yystack.l_mark[-3].sym;
	}
break;
case 44:
#line 1051 "wrapit.y"
	{
		yyval.sym = NULL;
	}
break;
case 45:
#line 1055 "wrapit.y"
	{
		yyval.sym = NULL;
	}
break;
case 46:
#line 1059 "wrapit.y"
	{
		yyval.sym = NULL;
	}
break;
case 47:
#line 1065 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->node = yystack.l_mark[0].dim;
		yyval.list->next = NULL;
	}
break;
case 48:
#line 1071 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->node = yystack.l_mark[0].dim;
		yyval.list->next = yystack.l_mark[-2].list;
	}
break;
case 49:
#line 1079 "wrapit.y"
	{
		yyval.dim = (DimVal*)malloc(sizeof(DimVal));
		yyval.dim->kind = 1;
		yyval.dim->u.sym = yystack.l_mark[0].sym;
	}
break;
case 50:
#line 1085 "wrapit.y"
	{
		yyval.dim = (DimVal*)malloc(sizeof(DimVal));
		yyval.dim->kind = 0;
		yyval.dim->u.val = yystack.l_mark[0].integer;
	}
break;
case 51:
#line 1091 "wrapit.y"
	{
		yyval.dim = (DimVal*)malloc(sizeof(DimVal));
		yyval.dim->kind = 0;
		yyval.dim->u.val = -1;
	}
break;
case 52:
#line 1099 "wrapit.y"
	{
		yyval.ftyp = NULL;
	}
break;
case 53:
#line 1103 "wrapit.y"
	{
		if(yystack.l_mark[0].ftyp->datatype == NCL_none) {
			fprintf(stderr,"Unsupported FORTRAN type detected\n");
		}
		yyval.ftyp = yystack.l_mark[0].ftyp;
	}
break;
case 54:
#line 1113 "wrapit.y"
	{
	}
break;
case 55:
#line 1116 "wrapit.y"
	{
	}
break;
case 56:
#line 1119 "wrapit.y"
	{
	}
break;
case 57:
#line 1124 "wrapit.y"
	{
		WrapSrcListNode* tmp;
		NclSymbol *s;

		tmp = yystack.l_mark[-3].list;

		while(tmp!= NULL) {
			s = (NclSymbol*)tmp->node;		
			s->u.wparam->getarg->totalp = w_nargs;
			tmp = tmp->next;
		}
		yystack.l_mark[-5].sym->type = PROC;
		current->f_or_p = 0;
		current->c_defstring = malloc(strlen(yystack.l_mark[-5].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-5].sym->name);

	}
break;
case 58:
#line 1142 "wrapit.y"
	{
		WrapSrcListNode* tmp;
		NclSymbol *s;

		tmp = yystack.l_mark[-3].list;

		while(tmp!= NULL) {
			s = (NclSymbol*)tmp->node;		
			s->u.wparam->getarg->totalp = w_nargs;
			tmp = tmp->next;
		}
		yystack.l_mark[-5].sym->type = FUNC;
		current->f_or_p = 1;
		current->c_defstring = malloc(strlen(yystack.l_mark[-5].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-5].sym->name);
	}
break;
case 59:
#line 1159 "wrapit.y"
	{
		yystack.l_mark[-3].sym->type = PROC;
		current->f_or_p = 0;
		current->c_defstring = malloc(strlen(yystack.l_mark[-3].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-3].sym->name);
	}
break;
case 60:
#line 1166 "wrapit.y"
	{
		yystack.l_mark[-4].sym->type = FUNC;
		current->f_or_p = 1;
		current->c_defstring = malloc(strlen(yystack.l_mark[-4].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-4].sym->name);
	}
break;
case 61:
#line 1175 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->next = NULL;
		yyval.list->node = (void*)yystack.l_mark[0].sym;
	}
break;
case 62:
#line 1181 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->next = yystack.l_mark[-2].list;
		yyval.list->node = (void*)yystack.l_mark[0].sym;
	}
break;
case 63:
#line 1187 "wrapit.y"
	{
		WGetArgValue *tmp;
		char buffer[BUFFSIZE];
		yystack.l_mark[0].sym->type = WPARAM;	
		yystack.l_mark[0].sym->u.wparam = malloc(sizeof(WParamInfo));
		yystack.l_mark[0].sym->u.wparam->n_dims = -1;
		yystack.l_mark[0].sym->u.wparam->dim_sizes[0] = -1;
		yystack.l_mark[0].sym->u.wparam->datatype = -1;
		yystack.l_mark[0].sym->u.wparam->getarg = tmp = WNewArgVal();
		tmp->assign_to = yystack.l_mark[0].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = -1;
		tmp->rw = 1;
		yyval.sym = yystack.l_mark[0].sym;
		(void)WNewVDef(yystack.l_mark[0].sym->name,-1,1,NULL,0);
		w_nargs++;
	}
break;
case 64:
#line 1205 "wrapit.y"
	{
		WGetArgValue *tmp;
		WSrcList *srclist;
		char buffer[BUFFSIZE];

		yystack.l_mark[-2].sym->type = WPARAM;
		yystack.l_mark[-2].sym->u.wparam = malloc(sizeof(WParamInfo));
		yystack.l_mark[-2].sym->u.wparam->n_dims = -1;
		yystack.l_mark[-2].sym->u.wparam->dim_sizes[0] = -1;
		yystack.l_mark[-2].sym->u.wparam->datatype = yystack.l_mark[0].integer;
		yystack.l_mark[-2].sym->u.wparam->getarg = tmp = WNewArgVal();
		(void)WNewVDef(yystack.l_mark[-2].sym->name,yystack.l_mark[0].integer,1,NULL,0);

		tmp->assign_to = yystack.l_mark[-2].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = yystack.l_mark[0].integer;
		tmp->rw = 1;
                sprintf(buffer,"&%s_type",yystack.l_mark[-2].sym->name);
                tmp->type = malloc(strlen(buffer)+1);
                strcpy(tmp->type,buffer);


		sprintf(buffer,"%s_type",yystack.l_mark[-2].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);

		yyval.sym = yystack.l_mark[-2].sym;
		w_nargs++;
	}
break;
case 65:
#line 1234 "wrapit.y"
	{	
		WGetArgValue *tmp;
		char buffer[BUFFSIZE];
		IntList *itmp;
		int i = 0 ;

		yystack.l_mark[-1].sym->type = WPARAM;
		yystack.l_mark[-1].sym->u.wparam = malloc(sizeof(WParamInfo));
		itmp = yystack.l_mark[0].ilist;
		while(itmp != NULL) {
			yystack.l_mark[-1].sym->u.wparam->dim_sizes[i] = itmp->val;	
			i++;
			itmp = itmp->next;
		}
		yystack.l_mark[-1].sym->u.wparam->n_dims = i;
		yystack.l_mark[-1].sym->u.wparam->datatype = -1;
		yystack.l_mark[-1].sym->u.wparam->getarg = tmp = WNewArgVal();
		sprintf(buffer,"%s",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,-1,1,NULL,0);

		tmp->assign_to = yystack.l_mark[-1].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = -1;
		tmp->rw = 1;

		sprintf(buffer,"&%s_ndims",yystack.l_mark[-1].sym->name);
		tmp->ndims = malloc(strlen(buffer)+1);
		strcpy(tmp->ndims,buffer);


		sprintf(buffer,"%s_ndims",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);

		sprintf(buffer,"%s_dimsizes",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,"[NCL_MAX_DIMENSIONS]",0);
		tmp->dimsizes = malloc(strlen(buffer)+1);
		strcpy(tmp->dimsizes,buffer);


		yyval.sym = yystack.l_mark[-1].sym;
		w_nargs++;
	}
break;
case 66:
#line 1277 "wrapit.y"
	{	
		WGetArgValue *tmp;
		char buffer[BUFFSIZE];
		IntList *itmp;
		int i = 0 ;
		yystack.l_mark[-3].sym->type = WPARAM;
		yystack.l_mark[-3].sym->u.wparam = malloc(sizeof(WParamInfo));
		itmp = yystack.l_mark[-2].ilist;
		while(itmp != NULL) {
			yystack.l_mark[-3].sym->u.wparam->dim_sizes[i] = itmp->val;	
			i++;
			itmp = itmp->next;
		}
		yystack.l_mark[-3].sym->u.wparam->n_dims = i;
		yystack.l_mark[-3].sym->u.wparam->datatype = yystack.l_mark[0].integer;
		yystack.l_mark[-3].sym->u.wparam->getarg = tmp = WNewArgVal();
		sprintf(buffer,"%s",yystack.l_mark[-3].sym->name);
		(void)WNewVDef(buffer,yystack.l_mark[0].integer,1,NULL,0);

		tmp->assign_to = yystack.l_mark[-3].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = yystack.l_mark[0].integer;
		tmp->rw = 1;

		sprintf(buffer,"&%s_ndims",yystack.l_mark[-3].sym->name);	
		tmp->ndims = malloc(strlen(buffer)+1);
		strcpy(tmp->ndims,buffer);
		sprintf(buffer,"%s_ndims",yystack.l_mark[-3].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);


		sprintf(buffer,"%s_dimsizes",yystack.l_mark[-3].sym->name);
		tmp->dimsizes= malloc(strlen(buffer)+1);
		strcpy(tmp->dimsizes,buffer);
		(void)WNewVDef(buffer,NCL_int,0,"[NCL_MAX_DIMENSIONS]",0);

		sprintf(buffer,"&%s_type",yystack.l_mark[-3].sym->name);
		tmp->type = malloc(strlen(buffer)+1);
		strcpy(tmp->type,buffer);

		sprintf(buffer,"%s_type",yystack.l_mark[-3].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);

		yyval.sym = yystack.l_mark[-3].sym;
		w_nargs++;
	}
break;
case 67:
#line 1325 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = yystack.l_mark[-1].integer;
                yyval.ilist->next = NULL;
	}
break;
case 68:
#line 1331 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = -1;
                yyval.ilist->next = NULL;
	}
break;
case 69:
#line 1337 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = -1;
                yyval.ilist->next = yystack.l_mark[-3].ilist;
	}
break;
case 70:
#line 1343 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = yystack.l_mark[-1].integer;
                yyval.ilist->next = yystack.l_mark[-3].ilist;
	}
break;
case 71:
#line 1350 "wrapit.y"
	{ yyval.integer = NCL_float; }
break;
case 72:
#line 1351 "wrapit.y"
	{ yyval.integer = NCL_long; }
break;
case 73:
#line 1352 "wrapit.y"
	{ yyval.integer = NCL_int; }
break;
case 74:
#line 1353 "wrapit.y"
	{ yyval.integer = NCL_short; }
break;
case 75:
#line 1354 "wrapit.y"
	{ yyval.integer = NCL_double; }
break;
case 76:
#line 1355 "wrapit.y"
	{ yyval.integer = NCL_char; }
break;
case 77:
#line 1356 "wrapit.y"
	{ yyval.integer = NCL_byte; }
break;
case 78:
#line 1357 "wrapit.y"
	{ yyval.integer = NCL_string; }
break;
case 79:
#line 1358 "wrapit.y"
	{ yyval.integer = NCL_logical; }
break;
case 80:
#line 1363 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = NULL;
	}
break;
case 81:
#line 1369 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = yystack.l_mark[-2].list;
	}
break;
case 82:
#line 1376 "wrapit.y"
	{
	}
break;
case 83:
#line 1378 "wrapit.y"
	{theparam = yystack.l_mark[0].ploc;}
break;
case 84:
#line 1378 "wrapit.y"
	{
		
	}
break;
case 85:
#line 1384 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WParamLoc *loc = (WParamLoc*)malloc(sizeof(WParamLoc));
		NclSymbol *s = _NclLookUpInScope(current->crec,yystack.l_mark[0].sym->name);
		int i;

		loc->type = RETURNPARAM;
		loc->datatype = yystack.l_mark[0].sym->u.wparam->datatype;
		loc->xfarg = NULL;
		loc->cdef = s->u.centry;
		loc->wsym = yystack.l_mark[0].sym;
		
		if(yystack.l_mark[0].sym->u.wparam->n_dims == -1) {
			loc->typeofdim = 1;
			loc->n_dims = 1;
			sprintf(buffer,"%s_dimsizes",yystack.l_mark[0].sym->name);	
			s = _NclLookUpInScope(current->crec,buffer);
			loc->altdimsref = s->u.centry;
			sprintf(loc->altndimref,"%s_ndims",yystack.l_mark[0].sym->name);
		} else {
			loc->typeofdim = 0;
			loc->n_dims = yystack.l_mark[0].sym->u.wparam->n_dims;
			for(i = 0; i < yystack.l_mark[0].sym->u.wparam->n_dims; i++) {
				loc->dim_sizes[i] = yystack.l_mark[0].sym->u.wparam->dim_sizes[i];
				if(loc->dim_sizes[i] = -1) {
					sprintf(loc->dim_refs[i],"(%s_dimsizes[%d])",yystack.l_mark[0].sym->name,i);
				} else {
					sprintf(loc->dim_refs[i],"(%d)",loc->dim_sizes[i]);
				}
			}
		}
		yyval.ploc = loc;
	}
break;
case 86:
#line 1418 "wrapit.y"
	{
	}
break;
case 87:
#line 1421 "wrapit.y"
	{
	}
break;
case 88:
#line 1424 "wrapit.y"
	{
        }
break;
case 89:
#line 1444 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = NULL;
	}
break;
case 90:
#line 1450 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = yystack.l_mark[-2].list;
	}
break;
case 91:
#line 1457 "wrapit.y"
	{ theparam = yystack.l_mark[0].ploc; }
break;
case 92:
#line 1458 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		int i,j;
		WSrcList *tmp;
		WModList *mods;


		switch(yystack.l_mark[-2].ploc->type) {
		case FARGNEW:
			current->c_callrec->arg_strings[yystack.l_mark[-2].ploc->xfarg->u.xref->u.farg->arg_num] = yystack.l_mark[-2].ploc->cdef;
			sprintf(buffer,"\t%s = (%s*)malloc(sizeof(%s)",yystack.l_mark[-2].ploc->cdef->string,CType(yystack.l_mark[-2].ploc->datatype),CType(yystack.l_mark[-2].ploc->datatype));
			for(i = 0; i < yystack.l_mark[-2].ploc->n_dims; i++) {
				strcat(buffer," * ");
				strcat(buffer,yystack.l_mark[-2].ploc->dim_refs[i]);
			}
			strcat(buffer,");\n");
			if(yystack.l_mark[-2].ploc->cdef->additional_src == NULL) {
				yystack.l_mark[-2].ploc->cdef->additional_src = WNewAdditionalSrc(buffer,1);
			} else {
				tmp =  WNewAdditionalSrc(buffer,1);
				tmp->next = yystack.l_mark[-2].ploc->cdef->additional_src;
				yystack.l_mark[-2].ploc->cdef->additional_src = tmp;
			}
			break;
		case PARAMVAL:
		case TOTALPARAM:
			current->c_callrec->arg_strings[yystack.l_mark[-2].ploc->xfarg->u.xref->u.farg->arg_num] = yystack.l_mark[-2].ploc->cdef;
			break;
		case DIMSPARAM:
			break;
		case DIMINDEXPARAM:
			break;
		}

	}
break;
case 93:
#line 1496 "wrapit.y"
	{
		WParamLoc *loc = NewParamLoc(yystack.l_mark[-4].sym);
		char buffer[BUFFSIZE];
		WDSpecList *tmp = yystack.l_mark[0].dsp;
		WCentry *ctmp;
		int j;
	
		loc->type = FARGNEW;
		loc->xfarg = yystack.l_mark[-4].sym;
		loc->cdef = WNewVDef(yystack.l_mark[-4].sym->name,yystack.l_mark[-4].sym->u.xref->u.farg->datatype,1,NULL,1);
		sprintf(loc->call_string,"%s",yystack.l_mark[-4].sym->name);

		loc->n_dims = 0	;
		while(tmp != NULL) {

			switch(tmp->type) {
			case INTDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(%d)",tmp->u.val);
				loc->n_dims++;
				break;
			case PARAMVALDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(*%s)",tmp->u.pval.wsym->name);
				loc->n_dims++;
				break;
			case TOTALPARAMDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(%s_total)",tmp->u.tpval.wsym->name);
				loc->n_dims++;
				break;
			case DIMSPARAMDIMSIZES:
				if(tmp->u.dpval.wsym->u.wparam->n_dims == -1) {
					DoTotal(tmp->u.dpval.wsym);
					sprintf(loc->dim_refs[loc->n_dims],"(%s_total)",tmp->u.dpval.wsym->name);
					loc->n_dims++;
				} else {
					for(j = 0; j < tmp->u.dpval.wsym->u.wparam->n_dims; j++) {
						sprintf(loc->dim_refs[loc->n_dims],"(%s_dimsizes[%d])",tmp->u.dpval.wsym->name,j);	
						loc->n_dims++;
					}
				}
				break;
			case DIMINDEXPARAMDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(%s_dimsizes[%d])",tmp->u.dipval.wsym->name,tmp->u.dipval.index);	
				loc->n_dims++;
				break;
			}
			tmp = tmp->next;
		}
		yyval.ploc = loc;
	}
break;
case 94:
#line 1546 "wrapit.y"
	{

		WParamLoc *loc = NewParamLoc(yystack.l_mark[-2].sym);
		NclSymbol *tmp;
		int i;
		char buffer[BUFFSIZE];

		DoDimsizes(yystack.l_mark[0].sym);
		loc->type = PARAMVAL;
		loc->xfarg = yystack.l_mark[-2].sym;
		tmp = _NclLookUpInScope(current->crec,yystack.l_mark[0].sym->name);
		loc->cdef = tmp->u.centry;
		sprintf(loc->call_string,"%s",yystack.l_mark[0].sym->name);
		loc->n_dims = yystack.l_mark[0].sym->u.wparam->n_dims;
		for(i = 0; i < yystack.l_mark[0].sym->u.wparam->n_dims; i++) {
			loc->dim_sizes[i] = yystack.l_mark[0].sym->u.wparam->dim_sizes[i];
			sprintf(loc->dim_refs[i],"(%s_dimsizes[%d])",tmp->name,i);
		}
		loc->datatype = yystack.l_mark[0].sym->u.wparam->datatype;
		yyval.ploc = loc;
		
	}
break;
case 95:
#line 1569 "wrapit.y"
	{
		WParamLoc *loc = NewParamLoc(yystack.l_mark[-3].sym);
		WCentry *tmp;
		char buffer[BUFFSIZE];
		NclSymbol *s;

		DoTotal(yystack.l_mark[0].sym);
		loc->type = TOTALPARAM;
		loc->xfarg = yystack.l_mark[-3].sym;
		loc->n_dims = 1;
		loc->datatype = NCL_int;
		loc->dim_sizes[0] = 1;
		sprintf(loc->dim_refs[0],"(1)");
		sprintf(buffer,"%s_total",yystack.l_mark[0].sym->name);
		s = _NclLookUpInScope(current->crec,buffer);
		loc->cdef = s->u.centry;
		sprintf(loc->call_string,"&%s",buffer);
		yyval.ploc = loc;
	}
break;
case 96:
#line 1589 "wrapit.y"
	{
                WParamLoc *loc = NewParamLoc(yystack.l_mark[-3].sym);
		char buffer[BUFFSIZE];
		NclSymbol *s;
		DoDimsizes(yystack.l_mark[0].sym);

                loc->type = DIMSPARAM;
                loc->xfarg = yystack.l_mark[-3].sym;
		loc->n_dims = 1;
		loc->datatype = NCL_int;
		loc->dim_sizes[0] = yystack.l_mark[0].sym->u.wparam->n_dims;
		sprintf(loc->dim_refs[0],"(%d)",yystack.l_mark[0].sym->u.wparam->n_dims);
		sprintf(buffer,"%s_dimsizes",yystack.l_mark[0].sym->name);
		s = _NclLookUpInScope(current->crec,buffer);
                loc->cdef = s->u.centry;
		sprintf(loc->call_string,"%s",buffer);
		yyval.ploc = loc;

	}
break;
case 97:
#line 1609 "wrapit.y"
	{
                WParamLoc *loc = NewParamLoc(yystack.l_mark[-6].sym);
		char buffer[BUFFSIZE];
		NclSymbol *s;

		DoDimsizes(yystack.l_mark[-3].sym);

                loc->type = DIMINDEXPARAM;
                loc->xfarg = yystack.l_mark[-6].sym;
		loc->n_dims = 1;
		loc->dim_sizes[0] = 1;
		sprintf(loc->dim_refs[0],"(1)");
		sprintf(buffer,"%s_dimsizes",yystack.l_mark[-3].sym->name);
		s = _NclLookUpInScope(current->crec,buffer);
                loc->cdef = s->u.centry;
		sprintf(loc->call_string,"&(%s[%d])",buffer,yystack.l_mark[-1].integer);
		yyval.ploc = loc;
	}
break;
case 98:
#line 1644 "wrapit.y"
	{
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = INTDIMSIZES;
		yyval.dsp->u.val = yystack.l_mark[0].integer;
		yyval.dsp->next = NULL;
	}
break;
case 99:
#line 1651 "wrapit.y"
	{
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = PARAMVALDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
	}
break;
case 100:
#line 1658 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WCentry *tmp;
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = TOTALPARAMDIMSIZES;
		yyval.dsp->u.tpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoTotal(yystack.l_mark[0].sym);
	}
break;
case 101:
#line 1668 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMSPARAMDIMSIZES;
		yyval.dsp->u.dpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[0].sym);
	}
break;
case 102:
#line 1677 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMINDEXPARAMDIMSIZES;
		yyval.dsp->u.dipval.wsym = yystack.l_mark[-3].sym;
		yyval.dsp->u.dipval.index= yystack.l_mark[-1].integer;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[-3].sym);
	}
break;
case 103:
#line 1687 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = PARAMVALDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = yystack.l_mark[-2].dsp;
	}
break;
case 104:
#line 1695 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WCentry *tmp;
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = TOTALPARAMDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = yystack.l_mark[-3].dsp;
		DoTotal(yystack.l_mark[0].sym);
	}
break;
case 105:
#line 1705 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMSPARAMDIMSIZES;
		yyval.dsp->u.dpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = yystack.l_mark[-3].dsp;
		DoDimsizes(yystack.l_mark[0].sym);
	}
break;
case 106:
#line 1714 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMINDEXPARAMDIMSIZES;
		yyval.dsp->u.dipval.wsym = yystack.l_mark[-3].sym;
		yyval.dsp->u.dipval.index= yystack.l_mark[-1].integer;
		yyval.dsp->next = yystack.l_mark[-6].dsp;
		DoDimsizes(yystack.l_mark[-3].sym);
	}
break;
case 107:
#line 1724 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = INTDIMSIZES;
		yyval.dsp->u.val = yystack.l_mark[0].integer;
		yyval.dsp->next = yystack.l_mark[-2].dsp;
	}
break;
case 108:
#line 1760 "wrapit.y"
	{
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = PARAMVALDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
	}
break;
case 109:
#line 1767 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WCentry *tmp;
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = TOTALPARAMDIMSIZES;
		yyval.dsp->u.tpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoTotal(yystack.l_mark[0].sym);
	}
break;
case 110:
#line 1777 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMSPARAMDIMSIZES;
		yyval.dsp->u.dpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[0].sym);
	}
break;
case 111:
#line 1786 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMINDEXPARAMDIMSIZES;
		yyval.dsp->u.dipval.wsym = yystack.l_mark[-3].sym;
		yyval.dsp->u.dipval.index= yystack.l_mark[-1].integer;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[-3].sym);
	}
break;
case 112:
#line 1796 "wrapit.y"
	{
	}
break;
case 113:
#line 1799 "wrapit.y"
	{
        }
break;
case 114:
#line 1802 "wrapit.y"
	{
        }
break;
case 115:
#line 1805 "wrapit.y"
	{
        }
break;
case 116:
#line 1825 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 117:
#line 1829 "wrapit.y"
	{
		yyval.mod= yystack.l_mark[0].mod;
	}
break;
case 118:
#line 1835 "wrapit.y"
	{
		yystack.l_mark[0].mod->next = NULL;
		yyval.mod = yystack.l_mark[0].mod;
	}
break;
case 119:
#line 1840 "wrapit.y"
	{
		yystack.l_mark[0].mod->next = yystack.l_mark[-2].mod;
		yyval.mod = yystack.l_mark[0].mod;
	}
break;
case 120:
#line 1847 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 121:
#line 1851 "wrapit.y"
	{
		int i;
		char buffer[BUFFSIZE];
		NclSymbol *s;

		yyval.mod = (WModList*)malloc(sizeof(WModList));
		yyval.mod->type = DIMSIZESOF;
		switch(yystack.l_mark[0].dsp->type) {
		case PARAMVALDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.pval.wsym;
			yyval.mod->u.dims.index = -1;
			yyval.mod->u.dims.kind = 0;
			if(yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->n_dims == 1) {
				if(yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->dim_sizes[0] != -1) {
					theparam->typeofdim = 0;
					theparam->n_dims = yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->dim_sizes[0];
					for(i = 0; i < yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->dim_sizes[0]; i++) {
						sprintf(theparam->dim_refs[i],"(%s[%d])",yystack.l_mark[0].dsp->u.pval.wsym->name);
						theparam->dim_sizes[i] = -1;
					}
				} else {
					theparam->n_dims = 1;
					theparam->dim_sizes[0] = -1;
					theparam->typeofdim = 1;
					sprintf(buffer,"%s",yystack.l_mark[0].dsp->u.pval.wsym->name);
					s = _NclLookUpInScope(current->crec,buffer);
					theparam->altdimsref = s->u.centry; 

					sprintf(theparam->altndimref,"%s_dimsizes[0]",yystack.l_mark[0].dsp->u.pval.wsym->name);
				}
			} else if(yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->n_dims == -1) {
				theparam->n_dims = 1;
				theparam->dim_sizes[0] = -1;
				theparam->typeofdim = 1;
                                sprintf(buffer,"%s",yystack.l_mark[0].dsp->u.pval.wsym->name);
                                s = _NclLookUpInScope(current->crec,buffer);
                                theparam->altdimsref = s->u.centry; 
                                sprintf(theparam->altndimref,"%s_dimsizes[0]",yystack.l_mark[0].dsp->u.pval.wsym->name); 
			} else {
				fprintf(stderr,"Can not use a multidimensional variable (%s) to specify dimension sizes",yystack.l_mark[0].dsp->u.pval.wsym->name);
			}
		break;
		case DIMSPARAMDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.dpval.wsym;
			yyval.mod->u.dims.index = -1;
			yyval.mod->u.dims.kind = 1;
			theparam->typeofdim = 0;
			if(yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->n_dims != -1) {
				for(i = 0; i <  yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->n_dims; i++) {
					if(yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[i] == -1) {
						sprintf(theparam->dim_refs[i],"(%s_dimsizes[%d])",yystack.l_mark[0].dsp->u.dpval.wsym->name);
						theparam->dim_sizes[i] = -1;
					} else {
						sprintf(theparam->dim_refs[i],"(%d)",yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[i]);
						theparam->dim_sizes[i] = yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[i];
					}
				}
			} else {
				theparam->n_dims = -1;
				theparam->dim_sizes[0] = -1;
				theparam->typeofdim = 1;
                                sprintf(buffer,"%s_dimsizes",yystack.l_mark[0].dsp->u.dpval.wsym->name);
                                s = _NclLookUpInScope(current->crec,buffer);
                                theparam->altdimsref = s->u.centry;
                                sprintf(theparam->altndimref,"%s_ndims",yystack.l_mark[0].dsp->u.dpval.wsym->name);

			}
		break;
		case TOTALPARAMDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.tpval.wsym;
			yyval.mod->u.dims.index = -1;
			yyval.mod->u.dims.kind = 2;
			theparam->dim_sizes[0] = -1;
			theparam->typeofdim = 0;
			theparam->n_dims = 1;
			sprintf(theparam->dim_refs[0],"(%s_total)",yystack.l_mark[0].dsp->u.tpval.wsym->name);
		break;
		case DIMINDEXPARAMDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.dipval.wsym;
			yyval.mod->u.dims.index = yystack.l_mark[0].dsp->u.dipval.index;
			yyval.mod->u.dims.kind = 3;
			theparam->typeofdim = 0;
			theparam->dim_sizes[0] = yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[ yystack.l_mark[0].dsp->u.dipval.index];
			theparam->n_dims = 1;
			sprintf(theparam->dim_refs[0],"(%s_dimsizes[%d])",yystack.l_mark[0].dsp->u.dipval.wsym->name,yystack.l_mark[0].dsp->u.dipval.index);
		break;
		} 

		
	}
break;
case 122:
#line 1942 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 123:
#line 1946 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 124:
#line 1950 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 125:
#line 1954 "wrapit.y"
	{
		yyval.mod = (WModList*)malloc(sizeof(WModList));
		yyval.mod->type = TYPEOF;
		yyval.mod->u.type.datatype = yystack.l_mark[0].integer;
	}
break;
case 126:
#line 1960 "wrapit.y"
	{
		yyval.mod = (WModList*)malloc(sizeof(WModList));
		yyval.mod->type = TYPEOF;
		switch(yystack.l_mark[0].dsp->type) {
		case PARAMVALDIMSIZES:
			yyval.mod->u.type.datatype = yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->datatype;
			theparam->datatype = yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->datatype;
		break;
		case DIMSPARAMDIMSIZES:
			yyval.mod->u.type.datatype = NCL_int;
			theparam->datatype = NCL_int;
		break;
		case TOTALPARAMDIMSIZES:
			yyval.mod->u.type.datatype = NCL_int;
			theparam->datatype = NCL_int;
		break;
		case DIMINDEXPARAMDIMSIZES:
			yyval.mod->u.type.datatype = NCL_int;
			theparam->datatype = NCL_int;
		break;
		} 
	}
break;
case 127:
#line 1983 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 128:
#line 1987 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 129:
#line 1991 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
case 130:
#line 1995 "wrapit.y"
	{
		yyval.mod = NULL;
	}
break;
#line 2833 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
