/*
 * Brazilian Space Agency - INPE/CPTEC
 * Center: 46
 * Subcenter: 0
 * Parameter table version: 254
 */

TBLE2 cptec_254_params[] = {
{1, "Pressure", "hPa", "PRES"},
{2, "Pressure reduced to MSL", "hPa", "PSNM"},
{3, "Pressure tendency", "Pa/s", "TSPS"},
{6, "Geopotential", "dam", "GEOP"},
{7, "Geopotential height", "gpm", "ZGEO"},
{8, "Geometric height", "m", "GZGE"},
{11, "ABSOLUTE TEMPERATURE", "K", "TEMP"},
{12, "VIRTUAL TEMPERATURE", "K", "VTMP"},
{13, "POTENTIAL TEMPERATURE", "K", "PTMP"},
{14, "PSEUDO-ADIABATIC POTENTIAL TEMPERATURE", "K", "PSAT"},
{15, "MAXIMUM TEMPERATURE", "K", "MXTP"},
{16, "MINIMUM TEMPERATURE", "K", "MNTP"},
{17, "DEW POINT TEMPERATURE", "K", "TPOR"},
{18, "DEW POINT DEPRESSION", "K", "DPTD"},
{19, "LAPSE RATE", "K/m", "LPSR"},
{21, "RADAR SPECTRA(1)", "non-dim", "RDS1"},
{22, "RADAR SPECTRA(2)", "non-dim", "RDS2"},
{23, "RADAR SPECTRA(3)", "non-dim", "RDS3"},
{25, "TEMPERATURE ANOMALY", "K", "TPAN"},
{26, "PRESSURE ANOMALY", "Pa hPa", "PSAN"},
{27, "GEOPOT HEIGHT ANOMALY", "m", "ZGAN"},
{28, "WAVE SPECTRA(1)", "non-dim", "WVS1"},
{29, "WAVE SPECTRA(2)", "non-dim", "WVS2"},
{30, "WAVE SPECTRA(3)", "non-dim", "WVS3"},
{31, "WIND DIRECTION", "deg", "WIND"},
{32, "WIND SPEED", "m/s", "WINS"},
{33, "ZONAL WIND (U)", "m/s", "UVEL"},
{34, "MERIDIONAL WIND (V)", "m/s", "VVEL"},
{35, "STREAM FUNCTION", "m2/s", "FCOR"},
{36, "VELOCITY POTENTIAL", "m2/s", "POTV"},
{38, "SIGMA COORD VERT VEL", "sec/sec", "SGVV"},
{39, "OMEGA", "Pa/s", "OMEG"},
{40, "VERTICAL VELOCITY", "m/s", "OMG2"},
{41, "ABSOLUTE VORTICITY", "10**5/sec", "ABVO"},
{42, "ABSOLUTE DIVERGENCE", "10**5/sec", "ABDV"},
{43, "VORTICITY", "1/s", "VORT"},
{44, "DIVERGENCE", "1/s", "DIVG"},
{45, "VERTICAL U-COMP SHEAR", "1/sec", "VUCS"},
{46, "VERT V-COMP SHEAR", "1/sec", "VVCS"},
{47, "DIRECTION OF CURRENT", "deg", "DIRC"},
{48, "SPEED OF CURRENT", "m/s", "SPDC"},
{49, "U-COMPONENT OF CURRENT", "m/s", "UCPC"},
{50, "V-COMPONENT OF CURRENT", "m/s", "VCPC"},
{51, "SPECIFIC HUMIDITY", "kg/kg", "UMES"},
{52, "RELATIVE HUMIDITY", "no Dim", "UMRL"},
{53, "HUMIDITY MIXING RATIO", "kg/kg", "HMXR"},
{54, "INST. PRECIPITABLE WATER", "Kg/m2", "AGPL"},
{55, "VAPOUR PRESSURE", "Pa hpa", "VAPP"},
{56, "SATURATION DEFICIT", "Pa hPa", "SADF"},
{57, "EVAPORATION", "Kg/m2/day", "EVAP"},
{59, "PRECIPITATION RATE", "kg/m2/day", "PRCR"},
{60, "THUNDER PROBABILITY", "%", "THPB"},
{61, "TOTAL PRECIPITATION", "Kg/m2/day", "PREC"},
{62, "LARGE SCALE PRECIPITATION", "Kg/m2/day", "PRGE"},
{63, "CONVECTIVE PRECIPITATION", "Kg/m2/day", "PRCV"},
{64, "SNOWFALL", "Kg/m2/day", "NEVE"},
{65, "WAT EQUIV ACC SNOW DEPTH", "kg/m2", "WENV"},
{66, "SNOW DEPTH", "cm", "NVDE"},
{67, "MIXED LAYER DEPTH", "m cm", "MXLD"},
{68, "TRANS THERMOCLINE DEPTH", "m cm", "TTHD"},
{69, "MAIN THERMOCLINE DEPTH", "m cm", "MTHD"},
{70, "MAIN THERMOCLINE ANOM", "m cm", "MTHA"},
{71, "CLOUD COVER", "0-1", "CBNV"},
{72, "CONVECTIVE CLOUD COVER", "0-1", "CVNV"},
{73, "LOW CLOUD COVER", "0-1", "LWNV"},
{74, "MEDIUM CLOUD COVER", "0-1", "MDNV"},
{75, "HIGH CLOUD COVER", "0-1", "HINV"},
{76, "CLOUD WATER", "kg/m2", "WTNV"},
{77, "BEST LIFTED INDEX (TO 500 HPA)", "K", "BLI"},
{81, "LAND SEA MASK", "0,1", "LSMK"},
{82, "DEV SEA_LEV FROM MEAN", "m", "DSLM"},
{83, "ROUGHNESS LENGTH", "m", "ZORL"},
{84, "ALBEDO", "%", "ALBE"},
{85, "DEEP SOIL TEMPERATURE", "K", "DSTP"},
{86, "SOIL MOISTURE CONTENT", "Kg/m2", "SOIC"},
{87, "VEGETATION", "%", "VEGE"},
{89, "DENSITY", "kg/m3", "DENS"},
{91, "ICE CONCENTRATION", "fraction", "ICEC"},
{92, "ICE THICKNESS", "m", "ICET"},
{93, "DIRECTION OF ICE DRIFT", "deg", "ICED"},
{94, "SPEED OF ICE DRIFT", "m/s", "ICES"},
{95, "U-COMP OF ICE DRIFT", "m/s", "ICEU"},
{96, "V-COMP OF ICE DRIFT", "m/s", "ICEV"},
{97, "ICE GROWTH", "m", "ICEG"},
{98, "ICE DIVERGENCE", "sec/sec", "ICDV"},
{100, "SIG HGT COM WAVE/SWELL", "m", "SHCW"},
{101, "DIRECTION OF WIND WAVE", "deg", "WWDI"},
{102, "SIG HGHT OF WIND WAVES", "m", "WWSH"},
{103, "MEAN PERIOD WIND WAVES", "sec", "WWMP"},
{104, "DIRECTION OF SWELL WAVE", "deg", "SWDI"},
{105, "SIG HEIGHT SWELL WAVES", "m", "SWSH"},
{106, "MEAN PERIOD SWELL WAVES", "sec", "SWMP"},
{107, "PRIMARY WAVE DIRECTION", "deg", "PRWD"},
{108, "PRIM WAVE MEAN PERIOD", "s", "PRMP"},
{109, "SECOND WAVE DIRECTION", "deg", "SWDI"},
{110, "SECOND WAVE MEAN PERIOD", "s", "SWMP"},
{111, "SHORT WAVE ABSORBED AT GROUND", "W/m2", "OCAS"},
{112, "NET LONG WAVE AT BOTTOM", "W/m2", "SLDS"},
{113, "NET SHORT-WAV RAD(TOP)", "W/m2", "NSWR"},
{114, "OUTGOING LONG WAVE AT TOP", "W/m2", "ROLE"},
{115, "LONG-WAV RAD", "W/m2", "LWRD"},
{116, "SHORT WAVE ABSORBED BY EARTH/ATMOSPHERE", "W/m2", "SWEA"},
{117, "GLOBAL RADIATION", "W/m2 ", "GLBR"},
{121, "LATENT HEAT FLUX FROM SURFACE", "W/m2", "CLSF"},
{122, "SENSIBLE HEAT FLUX FROM SURFACE", "W/m2", "CSSF"},
{123, "BOUND LAYER DISSIPATION", "W/m2", "BLDS"},
{127, "IMAGE", "-", "IMAG"},
{128, "2 METRE TEMPERATURE", "K", "TP2M"},
{129, "2 METRE DEWPOINT TEMPERATURE", "K", "DP2M"},
{130, "10 METRE U-WIND COMPONENT", "m/s", "U10M"},
{131, "10 METRE V-WIND COMPONENT", "m/s", "V10M"},
{132, "TOPOGRAPHY", "m", "TOPO"},
{133, "GEOMETRIC MEAN SURFACE PRESSURE", "hPa", "GSFP"},
{134, "LN SURFACE PRESSURE", "hPa", "LNSP"},
{135, "SURFACE PRESSURE", "hPa", "PSLC"},
{136, "M S L PRESSURE (MESINGER METHOD)", "hPa", "PSLM"},
{137, "MASK", "-/+", "MASK"},
{138, "MAXIMUM U-WIND", "m/s", "MXWU"},
{139, "MAXIMUM V-WIND", "m/s", "MXWV"},
{140, "CONVECTIVE AVAIL. POT.ENERGY", "m2/s2", "CAPE"},
{141, "CONVECTIVE INHIB. ENERGY", "m2/s2", "CINE"},
{142, "CONVECTIVE LATENT HEATING", "K/s", "LHCV"},
{143, "CONVECTIVE MOISTURE SOURCE", "1/s", "MSCV"},
{144, "SHALLOW CONV. MOISTURE SOURCE", "1/s", "SCVM"},
{145, "SHALLOW CONVECTIVE HEATING", "K/s", "SCVH"},
{146, "MAXIMUM WIND PRESS. LVL", "hPa", "MXWP"},
{147, "STORM MOTION U-COMPONENT", "m/s", "USTR"},
{148, "STORM MOTION V-COMPONENT", "m/s", "VSTR"},
{149, "MEAN CLOUD COVER", "0-1", "CBNT"},
{150, "PRESSURE AT CLOUD BASE", "hPa", "PCBS"},
{151, "PRESSURE AT CLOUD TOP", "hPa", "PCTP"},
{152, "FREEZING LEVEL HEIGHT", "m", "FZHT"},
{153, "FREEZING LEVEL RELATIVE HUMIDITY", "%", "FZRH"},
{154, "FLIGHT LEVELS TEMPERATURE", "K", "FDLT"},
{155, "FLIGHT LEVELS U-WIND", "m/s", "FDLU"},
{156, "FLIGHT LEVELS V-WIND", "m/s", "FDLV"},
{157, "TROPOPAUSE PRESSURE", "hPa", "TPPP"},
{158, "TROPOPAUSE TEMPERATURE", "K", "TPPT"},
{159, "TROPOPAUSE U-WIND COMPONENT", "m/s", "TPPU"},
{160, "TROPOPAUSE v-WIND COMPONENT", "m/s", "TPPV"},
{162, "GRAVITY WAVE DRAG DU/DT", "m/s2", "GVDU"},
{163, "GRAVITY WAVE DRAG DV/DT", "m/s2", "GVDV"},
{164, "GRAVITY WAVE DRAG SFC ZONAL STRESS", "Pa", "GVUS"},
{165, "GRAVITY WAVE DRAG SFC MERIDIONAL STRESS", "Pa", "GVVS"},
{167, "DIVERGENCE OF SPECIFIC HUMIDITY", "1/s", "DVSH"},
{168, "HORIZ. MOISTURE FLUX CONV.", "1/s", "HMFC"},
{169, "VERT. INTEGRATED MOISTURE FLUX CONV.", "kg/(m2*s)", "VMFL"},
{170, "VERTICAL MOISTURE ADVECTION", "kg/(kg*s)", "VADV"},
{171, "NEG. HUM. CORR. MOISTURE SOURCE", "kg/(kg*s)", "NHCM"},
{172, "LARGE SCALE LATENT HEATING", "K/s", "LGLH"},
{173, "LARGE SCALE MOISTURE SOURCE", "1/s", "LGMS"},
{174, "SOIL MOISTURE AVAILABILITY", "0-1", "SMAV"},
{175, "SOIL TEMPERATURE OF ROOT ZONE", "K", "TGRZ"},
{176, "BARE SOIL LATENT HEAT", "Ws/m2", "BSLH"},
{177, "POTENTIAL SFC EVAPORATION", "m", "EVPP"},
{178, "RUNOFF", "kg/m2/s)", "RNOF"},
{179, "INTERCEPTION LOSS", "W/m2", "PITP"},
{180, "VAPOR PRESSURE OF CANOPY AIR SPACE", "mb", "VPCA"},
{181, "SURFACE SPEC HUMIDITY", "kg/kg", "QSFC"},
{182, "SOIL WETNESS OF SURFACE", "0-1", "USSL"},
{183, "SOIL WETNESS OF ROOT ZONE", "0-1", "UZRS"},
{184, "SOIL WETNESS OF DRAINAGE ZONE", "0-1", "UZDS"},
{185, "STORAGE ON CANOPY", "m", "AMDL"},
{186, "STORAGE ON GROUND", "m", "AMSL"},
{187, "SURFACE TEMPERATURE", "K", "TSFC"},
{188, "SURFACE ABSOLUTE TEMPERATURE", "K", "TEMS"},
{189, "TEMPERATURE OF CANOPY AIR SPACE", "K", "TCAS"},
{190, "TEMPERATURE AT CANOPY", "K", "CTMP"},
{191, "GROUND/SURFACE COVER TEMPERATURE", "K", "TGSC"},
{192, "SURFACE ZONAL WIND (U)", "m/s", "UVES"},
{193, "SURFACE ZONAL WIND STRESS", "Pa", "USST"},
{194, "SURFACE MERIDIONAL WIND (V)", "m/s", "VVES"},
{195, "SURFACE MERIDIONAL WIND STRESS", "Pa", "VSST"},
{196, "SURFACE MOMENTUM FLUX", "W/m2", "SUVF"},
{197, "INCIDENT SHORT WAVE FLUX", "W/m2", "ISWF"},
{198, "TIME AVE GROUND HT FLX", "W/m2", "GHFL"},
{200, "NET LONG WAVE AT BOTTOM (CLEAR)", "W/m2", "LWBC"},
{201, "OUTGOING LONG WAVE AT TOP (CLEAR)", "W/m2", "LWTC"},
{202, "SHORT WV ABSRBD BY EARTH/ATMOS (CLEAR)", "W/m2", "SWEC"},
{203, "SHORT WAVE ABSORBED AT GROUND (CLEAR)", "W/m2", "OCAC"},
{205, "LONG WAVE RADIATIVE HEATING", "K/s", "LWRH"},
{206, "SHORT WAVE RADIATIVE HEATING", "K/s", "SWRH"},
{207, "DOWNWARD LONG WAVE AT BOTTOM", "W/m2", "OLIS"},
{208, "DOWNWARD LONG WAVE AT BOTTOM (CLEAR)", "W/m2", "OLIC"},
{209, "DOWNWARD SHORT WAVE AT GROUND", "W/m2", "OCIS"},
{210, "DOWNWARD SHORT WAVE AT GROUND (CLEAR)", "W/m2", "OCIC"},
{211, "UPWARD LONG WAVE AT BOTTOM", "W/m2", "OLES"},
{212, "UPWARD SHORT WAVE AT GROUND", "W/m2", "OCES"},
{213, "UPWARD SHORT WAVE AT GROUND (CLEAR)", "W/m2", "SWGC"},
{214, "UPWARD SHORT WAVE AT TOP", "W/m2", "ROCE"},
{215, "UPWARD SHORT WAVE AT TOP (CLEAR)", "W/m2", "SWTC"},
{218, "HORIZONTAL HEATING DIFFUSION", "K/s", "HHDF"},
{219, "HORIZONTAL MOISTURE DIFFUSION", "1/s", "HMDF"},
{220, "HORIZONTAL DIVERGENCE DIFFUSION", "1/s2", "HDDF"},
{221, "HORIZONTAL VORTICITY DIFFUSION", "1/s2", "HVDF"},
{222, "VERTICAL DIFF. MOISTURE SOURCE", "1/s", "VDMS"},
{223, "VERTICAL DIFFUSION DU/DT", "m/s2", "VDFU"},
{224, "VERTICAL DIFFUSION DV/DT", "m/s2", "VDFV"},
{225, "VERTICAL DIFFUSION HEATING", "K/s", "VDFH"},
{226, "SURFACE RELATIVE HUMIDITY", "no Dim", "UMRS"},
{227, "VERTICAL DIST TOTAL CLOUD COVER", "no Dim", "VDCC"},
{230, "TIME MEAN SURFACE ZONAL WIND (U)", "m/s", "USMT"},
{231, "TIME MEAN SURFACE MERIDIONAL WIND (V)", "m/s", "VSMT"},
{232, "TIME MEAN SURFACE ABSOLUTE TEMPERATURE", "K", "TSMT"},
{233, "TIME MEAN SURFACE RELATIVE HUMIDITY", "no Dim", "RSMT"},
{234, "TIME MEAN ABSOLUTE TEMPERATURE", "K", "ATMT"},
{235, "TIME MEAN DEEP SOIL TEMPERATURE", "K", "STMT"},
{236, "TIME MEAN DERIVED OMEGA", "Pa/s", "OMMT"},
{237, "TIME MEAN DIVERGENCE", "1/s", "DVMT"},
{238, "TIME MEAN GEOPOTENTIAL HEIGHT", "m", "ZHMT"},
{239, "TIME MEAN LOG SURFACE PRESSURE", "ln(cbar)", "LNMT"},
{240, "TIME MEAN MASK", "-/+", "MKMT"},
{241, "TIME MEAN MERIDIONAL WIND (V)", "m/s", "VVMT"},
{242, "TIME MEAN OMEGA", "cbar/s", "OMTM"},
{243, "TIME MEAN POTENTIAL TEMPERATURE", "K", "PTMT"},
{244, "TIME MEAN PRECIP. WATER", "kg/m2", "PCMT"},
{245, "TIME MEAN RELATIVE HUMIDITY", "%", "RHMT"},
{246, "TIME MEAN SEA LEVEL PRESSURE", "hPa", "MPMT"},
{247, "TIME MEAN SIGMADOT", "1/s", "SIMT"},
{248, "TIME MEAN SPECIFIC HUMIDITY", "kg/kg", "UEMT"},
{249, "TIME MEAN STREAM FUNCTION", "m2/s", "FCMT"},
{250, "TIME MEAN SURFACE PRESSURE", "hPa", "PSMT"},
{251, "TIME MEAN SURFACE TEMPERATURE", "K", "TMMT"},
{252, "TIME MEAN VELOCITY POTENTIAL", "m2/s", "PVMT"},
{253, "TIME MEAN VIRTUAL TEMPERATURE", "K", "TVMT"},
{254, "TIME MEAN VORTICITY", "1/s", "VTMT"},
{255, "TIME MEAN ZONAL WIND (U)", "m/s", "UVMT"},
};
