/*
 * Deutscher Wetterdienst (DWD): Offenbach
 * Center: 78
 * Subcenter: 0
 * Parameter table version: 201
 */

TBLE2 dwd_201_params[] = {
{1, "downward shortwave radiant flux density", "W/m**2", "DW_SW_FLUX"},
{2, "upward shortwave radiant flux density", "W/m**2", "UW_SW_FLUX"},
{3, "downward longwave radiant flux density", "W/m**2", "DW_LW_FLUX"},
{4, "upward longwave radiant flux density", "W/m**2", "UW_LW_FLUX"},
{5, "downwd photosynthetic active radiant flux density", "W/m**2", "APAB_S"},
{6, "net shortwave flux", "W/m**2", "NET_S_FLUX"},
{7, "net longwave flux", "W/m**2", "NET_L_FLUX"},
{8, "total net radiative flux density", "W/m**2", "NET_FLUX"},
{9, "downw shortw radiant flux density, cloudfree part", "W/m**2", "DW_SW_CLFR"},
{10, "upw shortw radiant flux density, cloudy part", "W/m**2", "UW_SW_CLDY"},
{11, "downw longw radiant flux density, cloudfree part", "W/m**2", "DW_LW_CLFR"},
{12, "upw longw radiant flux density, cloudy part", "W/m**2", "UW_LW_CLDY"},
{13, "shortwave radiative heating rate", "K/s", "SOHR_RAD"},
{14, "longwave radiative heating rate", "K/s", "THHR_RAD"},
{15, "total radiative heating rate", "K/s", "RAD_HEAT"},
{16, "soil heat flux, surface", "W/m**2", "SOILHEAT_S"},
{17, "soil heat flux, bottom of layer", "W/m**2", "SOILHEAT_L"},
{20, "sunshine hours",  "h", "SUNSHHRS"},
{29, "cloud cover, grid scale + convective", "1", "CLC"},
{30, "cloud cover, grid scale  (0...1)", "1", "CLC_GR_SC"},
{31, "specific cloud water content, grid scale", "kg/kg", "QC"},
{32, "cloud water content, grid scale, vert integrated", "kg/m**2", "CLW_GS_VI"},
{33, "specific cloud ice   content, grid scale", "kg/kg", "QI"},
{34, "cloud ice content, grid scale, vert integrated", "kg/m**2", "CLI_GS_VI"},
{35, "specific rainwater content, grid scale", "kg/kg", "SRC_GR_SC"},
{36, "specific snow content, grid scale", "kg/kg", "SSC_GR_SC"},
{37, "specific rainwater content, gs, vert. integrated", "kg/m**2", "SRC_GS_VI"},
{38, "specific snow content, gs, vert. integrated", "kg/m**2", "SSC_GS_VI"},
{39, "specific graupel content", "kg kg-1", "QG"},
{40, "total graupel content vertically integrated", "kg m-2", "TQG"},
{41, "vert. integral of humidity, cloud water (and ice)", "kg/(m**2)", "TOT_WATER"},
{42, "vert. integral of divergence of tot. water content", "kg/(m**2)", "HUM_DIV"},
{43, "sub scale specific cloud water content", "kg kg-1", "QC_RAD"},
{44, "subscale specific cloud ice content", "kg kg-1", "QI_RAD"},
{50, "cloud covers CH_CM_CL (000...888)", "1", "CH_CM_CL"},
{51, "cloud cover CH (0..8)", "1", "CL_COV_CH"},
{52, "cloud cover CM (0..8)", "1", "CL_COV_CM"},
{53, "cloud cover CL (0..8)", "1", "CL_COV_CL"},
{54, "total cloud cover (0..8)", "1", "CLOUD_COV"},
{55, "fog (0..8)", "1", "FOG"},
{56, "fog", "1", "FOG"},
{58, "height of shallow convective cloud base", "m", "HBAS_SC"},
{59, "height of shallow convective cloud top", "m", "HTOP_SC"},
{60, "cloud cover, convective cirrus  (0...1)", "1", "CLC_CON_CI"},
{61, "specific cloud water content, convective clouds", "kg/kg", "CLW_CON"},
{62, "cloud water content, conv clouds, vert integrated", "kg/m**2", "CLW_CON_VI"},
{63, "specific cloud ice content, convective clouds", "kg/kg", "CLI_CON"},
{64, "cloud ice content, conv clouds, vert integrated", "kg/m**2", "CLI_CON_VI"},
{65, "convective mass flux", "kg/(s*m**2)", "MASS_FL_CO"},
{66, "updraft velocity, convection", "m/s", "UPD_VEL_CO"},
{67, "entrainment parameter, convection", "m**(-1)", "ENTR_P_CO"},
{68, "cloud base, convective clouds (above msl)", "m", "HBAS_CON"},
{69, "cloud top, convective clouds (above msl)", "m", "HTOP_CON"},
{70, "convective layers (00...77)  (BKE)", "1", "CON_LAYERS"},
{71, "KO-index", "1", "KO_INDEX"},
{72, "convection base index", "1", "BAS_CON"},
{73, "convection top index", "1", "TOP_CON"},
{74, "convective temperature tendency", "K/s", "DT_CON"},
{75, "convective tendency of specific humidity", "s**(-1)", "DQV_CON"},
{76, "convective tendency of total heat", "J/(kg*s)", "H_TEN_CO"},
{77, "convective tendency of total water", "s**(-1)", "QDW_TEN_CO"},
{78, "convective momentum tendency (X-component)", "m/s**2", "DU_CON"},
{79, "convective momentum tendency (Y-component)", "m/s**2", "DV_CON"},
{80, "convective vorticity tendency", "s**(-2)", "VOR_TEN_CO"},
{81, "convective divergence tendency", "s**(-2)", "DIV_TEN_CO"},
{82, "top of dry convection (above msl)", "m", "HTOP_DC"},
{83, "dry convection top index", "1", "TOP_IND_DC"},
{84, "height of 0 degree Celsius isotherm above msl", "m", "HZEROCL"},
{85, "height of snow fall limit in m above sea level", "m", "SNOWLMT"},
{91, "shape factor of temperature profile in lake thermocline", "index", "C_T_LK"},
{92, "attenuation coefficient for solar radiation in lake water", "m-1", "GAMSO_LK"},
{93, "thickness of thermally active layer of bottom sediment", "m", "DP_BS_LK"},
{94, "thickness of the upper layer of bottom sediments", "m", "H_B1_LK"},
{95, "thickness of the mixed layer", "m", "H_ML_LK"},
{96, "lake depth", "m", "DEPTH_LK"},
{97, "wind fetch over lake", "m", "FETCH_LK"},
{99, "precipitation water (water loading)", "index", "QRS"},
{100, "surface precipitation rate, rain, grid scale", "kg/(s*m**2)", "PRR_GSP"},
{101, "surface precipitation rate, snow, grid scale", "kg/(s*m**2)", "PRS_GSP"},
{102, "surface precipitation amount, rain, grid scale", "kg/m**2", "RAIN_GSP"},
{103, "condensation rate, grid scale", "kg/(kg*s)", "CONDENS_GS"},
{104, "autoconversion rate, grid scale   (C+C  --> R)", "kg/(kg*s)", "AUTOCON_GS"},
{105, "accretion rate, grid scale        (R+C  --> R)", "kg/(kg*s)", "ACCRET_GS"},
{106, "nucleation rate, grid scale       (C+C  --> S)", "kg/(kg*s)", "NUCLEAT_GS"},
{107, "riming rate, grid scale           (S+C  --> S)", "kg/(kg*s)", "RIMING_GS"},
{108, "deposition rate, grid scale       (S+V <--> S)", "kg/(kg*s)", "DEPOSIT_GS"},
{109, "melting rate, grid scale          (S    --> R)", "kg/(kg*s)", "MELTING_GS"},
{110, "evaporation rate, grid scale      (R+V <--  R)", "kg/(kg*s)", "EVAPOR_GS"},
{111, "surface precipitation rate, rain, convective", "kg/(s*m**2)", "PRR_CON"},
{112, "surface precipitation rate, snow, convective", "kg/(s*m**2)", "PRS_CON"},
{113, "surface precipitation amount, rain, convective", "kg/m**2", "RAIN_CON"},
{114, "condensation rate, convective", "kg/(kg*s)", "CONDENS_CO"},
{115, "autoconversion rate, convective", "kg/(kg*s)", "AUTOCON_CO"},
{116, "accretion rate, convective", "kg/(kg*s)", "ACCRET_CO"},
{117, "nucleation rate, convective", "kg/(kg*s)", "NUCLEAT_CO"},
{118, "riming rate, convective", "kg/(kg*s)", "RIMING_CO"},
{119, "sublimation rate, convective", "kg/(kg*s)", "SUBLIM_CO"},
{120, "melting rate, convective", "kg/(kg*s)", "MELTING_CO"},
{121, "evaporation rate, convective", "kg/(kg*s)", "EVAPOR_CO"},
{122, "rain amount, grid-scale plus convective", "kg/m**2", "RAIN_AM"},
{123, "snow amount, grid-scale plus convective", "kg/m**2", "SNOW_AM"},
{124, "temperature tendency, grid-scale condensation", "K/s", "DT_GSP"},
{125, "tendency of specific humidity, grid-scale condens", "s**(-1)", "DQV_GSP"},
{126, "tendency of total heat, grid-scale condensation", "J/(kg*s)", "H_TEN_GS"},
{127, "tendency of total water, grid-scale condensation", "s**(-1)", "DQL_GSP"},
{128, "snowfall", "-", "SNOWFALL"},
{129, "freshness of snow", "index", "FRESHSNW"},
{130, "tend of the sp cl ice cont due to gs precipitation", "kg/(kg*s)", "TSCIC_GSPR"},
{131, "mass flux density of large scale graupel", "kg m-2 s-1", "PRG_GSP"},
{132, "surface precipitation amount, graupel, grid scale", "kg/(m**2)", "GRA_AM_GS"},
{133, "density of snow", "kg m-3", "RHO_SNOW"},
{139, "deviation of pressure from reference value", "Pa", "PPRIME"},
{140, "standard deviation of saturation deficit", "non-dim", "RCLD"},
{143, "capeof most unstable parcel", "J kg-1", "CAPE_MU"},
{144, "convective inhibition of most unstable parcel", "J kg-1", "CIN_MU"},
{145, "cape of mean surf layer parcel", "J kg-1", "CAPE_ML"},
{146, "convective inhibition of mean surface layer parcel", "J kg-1", "CIN_ML"},
{147, "convective turbulent kinetic energy", "J/kg", "TKE_CON"},
{148, "tendency of turbulent kinetic energy", "m/s", "TKETENS"},
{149, "kinetic energy ((u**2 + v**2) / 2)", "J/kg", "KE"},
{150, "coefficient of horizontal diffusion", "m**2/s", "HDI_COEFF"},
{151, "dissipation rate", "W/(Pa*m**2)", "DISSP_RATE"},
{152, "turbulent kinetic energy", "(m/s)**2", "TKE"},
{153, "coefficient of vertical diffusion, momentum", "m**2/s", "TKVM"},
{154, "coefficient of vertical diffusion, heat", "m**2/s", "TKVH"},
{155, "coefficient of vertical diffusion, cloud water", "m**2/s", "VDI_COE_CW"},
{156, "coefficient of vertical diffusion, cloud ice", "m**2/s", "VDI_COE_CI"},
{157, "coefficient of vertical diffusion, water vapour", "m**2/s", "VDI_COE_VP"},
{158, "turbulent dissipation length for momentum", "m", "DIS_LEN_M"},
{159, "turbulent dissipation length for heat", "m", "DIS_LEN_H"},
{160, "variance of u-component of momentum", "(m/s)**2", "VAR_U_MOM"},
{161, "variance of v-component of momentum", "(m/s)**2", "VAR_V_MOM"},
{162, "variance of w-component of momentum", "(m/s)**2", "VAR_W_MOM"},
{163, "variance of temperature", "K**2", "VAR_TEMP"},
{164, "variance of specific cloud water content", "(kg/kg)**2", "VAR_CL_WAT"},
{165, "variance of specific cloud ice content", "(kg/kg)**2", "VAR_CL_ICE"},
{166, "variance of water vapour mixing ratio", "(kg/kg)**2", "VAR_VAP_MR"},
{167, "turbulent vertical flux of spec cloud water", "m/s", "C_WAT_FLUX"},
{168, "turbulent vertical flux of spec cloud ice", "m/s", "C_ICE_FLUX"},
{169, "turbulent vertical flux of water vapour mix ratio", "m/s", "W_VAP_FLUX"},
{170, "drag coefficient CD", "1", "TCM"},
{171, "transfer coefficient CH (sensible heat)", "1", "TCH"},
{172, "transfer coefficient CQ (latent heat)", "1", "TR_COEF_CQ"},
{173, "PBL-top h", "m", "PBL_TOP_H"},
{174, "temperature jump at PBL-top", "K", "T_JUMP_H"},
{175, "specific humidity jump at PBL-top", "kg/kg", "Q_JUMP_H"},
{176, "entrainment at PBL-top", "kg/(s*m**2)", "ENTR_AT_H"},
{177, "upward mass flux at PBL-top", "kg/(s*m**2)", "MASS_FL_H"},
{178, "cloud cover of PBL-clouds (0...1)", "1", "CL_COV_PBL"},
{179, "specific cloud water content of PBL-clouds", "kg/kg", "CL_WAT_PBL"},
{180, "cloud top of PBL-clouds", "m", "CL_TOP_PBL"},
{181, "cloud base of PBL-clouds", "m", "CL_BAS_PBL"},
{182, "vertical mountain wave momentum flux (X component)", "kg/(m*s**2)", "MOUN_WAV_X"},
{183, "vertical mountain wave momentum flux (Y component)", "kg/(m*s**2)", "MOUN_WAV_Y"},
{184, "wave Richardson number", "1", "WAVE_RI"},
{185, "mountain wave momentum flux divergence (X comp)", "m/s**2", "WAV_DIV_X"},
{186, "mountain wave momentum flux divergence (Y comp)", "m/s**2", "WAV_DIV_Y"},
{187, "maximum wind velocity", "m/s", "VMAX_10M"},
{188, "mountain wave dissipation, vert integrated", "W/m**2", "WAV_DIS_VI"},
{189, "vertical wave energy flux", "kg*m/s**4", "WV_EN_FLUX"},
{190, "climatological temperature at bottom of thermally active layer of sediments", "K", "T_BS_LK"},
{191, "temperature at the water bottom sediment interface", "K", "T_BOT_LK"},
{192, "temperature at bottom of upper layer of sedients", "K", "T_B1_LK"},
{193, "mixed layer temperature", "K", "T_WML_LK"},
{194, "mean temperature of water column", "K", "T_MNW_LK"},
{195, "lake surface temperature", "K", "T_SFC_LK"},
{197, "temperature of soil layers", "K", "SO_TEMP"},
{198, "water + ice content of soil layers", "kg/(m**2)", "SO_WA_ICE"},
{199, "ice content of soil layers", "kg/(m**2)", "SO_ICE"},
{200, "water content of interception store", "kg/(m**2)", "W_I"},
{201, "icebit for interception store", "1", "INTERC_ICE"},
{202, "snow fraction", "1", "SNOW_FRACT"},
{203, "snow temperature", "K", "T_SNOW"},
{204, "foliage temperature", "K", "FOLIAG_TEM"},
{205, "infiltration", "m/s", "INFILTRAT"},
{206, "runoff", "m/s", "RUNOFF"},
{207, "bare soil evaporation", "m/s", "SOIL_EVAP"},
{208, "plant transpiration", "m/s", "PLANT_TRAN"},
{209, "interception store evaporation", "m/s", "INTER_EVAP"},
{210, "evaporation from water surfaces", "m/s", "WATER_EVAP"},
{211, "aerodynamic resistance", "s/m", "AERO_RESIS"},
{212, "plant resistance", "s/m", "PLANT_RES"},
{213, "soil resistance", "s/m", "SOIL_RES"},
{214, "total evaporation (water, soil, plants)", "m/s", "TOTAL_EVAP"},
{215, "temperature of ice upper surface", "K", "T_ICE"},
{217, "maximum wind velocity (modified)", "m/s", "MAX_WIND_M"},
{230, "S1", "1", "XYZ"},
{231, "S2", "1", "S2"},
{232, "S3", "1", "S3"},
{233, "S4", "1", "S4"},
{234, "S5", "1", "S5"},
{235, "S6", "1", "S6"},
{236, "S7", "1", "S7"},
{237, "S8", "1", "S8"},
{238, "S9", "1", "S9"},
{239, "S10", "1", "S10"},
{240, "S11", "1", "S11"},
{241, "OBS Gewitter (occasional)", "1", "OBS_TS_OC"},
{242, "OBS Gewitter (frequent)", "1", "OBS_TS_FQ"},
{243, "MOS Gewitter-Wahrscheinlichkeit (occasional)", "1", "MOS_PTS_OC"},
{244, "MOS Gewitter-Wahrscheinlichkeit (frequent)", "1", "MOS_PTS_FQ"},
{245, "MOS Gewitteranteil (occasional - frequent (1 - 2))", "1", "MOS_TS_COV"},
{246, "S17", "1", "S17"},
{247, "S18", "1", "S18"},
{248, "S19", "1", "S19"},
{249, "S20", "1", "S20"},
{250, "Wahrscheinlichkeit mindestens ein Blitz", "%", "MOS_TSISO1"},
{251, "Wahrscheinlichkeit mindestens zehn Blitze", "%", "MOS_TSISO2"},
{252, "Wahrscheinlichkeit mindestens hundert Blitze", "%", "MOS_TSISO3"},
{253, "Vorhersage der Blitzanzahl", "index", "MOS_TS_DEN"},
{254, "Gewitter-Wahrscheinlichkeit (occasional)", "%", "MOS_TS_OCC"},
{255, "Gewitter-Wahrscheinlichkeit (frequent)",  "%", "MOS_TS_FRQ"}
};
