/*
 * Deutscher Wetterdienst (DWD): Offenbach
 * Center: 78
 * Subcenter: 0
 * Parameter table version: 203
 */

TBLE2 dwd_203_params[] = {
{1, "pressure", "hPa", "PRESSURE"},
{2, "geopotential height", "10 * gpm", "GEOPOT_H"},
{4, "temperature", "1*degree Celsius", "TEMPERATUR"},
{5, "dew-point temperature", "1*degree Celsius", "DEW_PNT_TE"},
{6, "wind components X/Y (X*100000 + ((Y*10)+5000))", "m/s", "WINDCOMPXY"},
{7, "geometrical height", "kft", "GEOMET_H"},
{8, "geometrical height", "hft", "GEOMET_H"},
{9, "wind direction and speed (dd*1000 + ff)", "1*degree, 1*kt", "WIND_DI_SP"},
{10, "3 hour pressure change", "Pa/(3*h)", "3_H_PR_CHA"},
{11, "Schneemenge", "mm", "SCHNEE_MGE"},
{13, "Bodenwassergehalt", "mm", "BOD_WASS_G"},
{15, "stability index", "K", "STAB_IND"},
{18, "maximum wind velocity", "km/h", "MAX_WIND"},
{19, "maximum wind velocity", "kt", "MAX_WIND"},
{20, "wind direction and speed (dd*1000 + ff)", "5*degrees, 1*(m/s)", "WIND_DI_SP"},
{21, "wind direction and speed (dd*1000 + ff)", "5*degrees, 1*kt", "WIND_DI_SP"},
{22, "direction and height of wind waves (dd*1000 + h)", "1*degree, 1*cm", "WAVE_DI_HE"},
{23, "direction and height of swell (dd*1000 + h)", "1*degree, 1*cm", "SWE_DI_HE"},
{24, "mean direction and height of waves (dd*1000 + h)", "1*degree, 1*cm", "WAVE_M_D_H"},
{25, "wind speed", "kt", "WIND_SPEED"},
{27, "wind component X-direction", "kt", "WIND_COMPX"},
{28, "wind component Y-direction", "kt", "WIND_COMPY"},
{29, "wind shear", "m/s", "WIND_SHEAR"},
{30, "storm relative helicity", "m**2/s**2", "SRH"},
{33, "absolute vorticity advection", "1/(s**2)", "ABS_VORADV"},
{42, "vertical velocity", "hPa/h", "VERT_VEL"},
{55, "maximum temperature", "1*degree Celsius", "MAX_TEMP"},
{56, "minimum temperature", "1*degree Celsius", "MIN_TEMP"},
{57, "probability to perceive sultriness", "index", "SUL_PROB"},
{58, "value of isolation of clothes", "1", "CLO"},
{59, "predected mean vote (angepasst)", "1", "PMVA"},
{60, "feeled temperature", "1*degree Celsius", "FEELED_T"},
{61, "sea temperature", "1*degree Celsius", "SEA_TEMPER"},
{71, "precipitiation RV 5min", "kg/m^2", "RV_5MIN"},
{72, "precipitiation RQ 60min", "kg/m^2", "RQ_60MIN"},
{73, "precipitiation RS 60min", "kg/m^2", "RS_60MIN"},
{74, "radar PI 15min",  "non-dim", "PI_15MIN"},
{81, "total precipitation (1h)", "kg/m**2", "RRR1H"},
{82, "total precipitation (1h)", "kg/m**2", "RRR3H"},
{86, "Summe der Globalstrahlung ueber einen Zeitraum", "kWh/m**2", "GLOBALSTR"},
{87, "Niederschlagsart+Gewitter+Glatteis (T23-i) (0..99)", "1", "NIED_GW_GE"},
{88, "Niederschlagsart+Gewitter (T23-intern)     (0..99)", "1", "NIEDGW_ART"},
{89, "Niederschlagsart+Glatteis (T23-intern)     (0..99)", "1", "NIEDGE_ART"},
{90, "Kombination Niederschl.-Bew.-Blautherm. (283..407)", "1", "NIEDBEWART"},
{91, "Hoehe der Konvektionsuntergrenze ueber Grund", "m", "KONV_U_GR"},
{92, "Niederschlagsart -ww- (T23-intern)         (0..99)", "1", "NIED_ART"},
{93, "Konvektionsart                              (0..4)", "1", "KONV_ART"},
{94, "Hoehe der Konvektionsuntergrenze ueber nn", "m", "KONV_UG_NN"},
{95, "total precipitation (12h)", "kg/m**2", "RRR12H"},
{96, "convective precipitation (6h)", "kg/m**2", "RRR6H_CONV"},
{97, "total precipitation (6h)", "kg/m**2", "RRR6H"},
{98, "total precipitation (24h)", "kg/m**2", "RRR24H"},
{99, "Wetter (verschluesselt nach ww-Tabelle", "1", "WETTER_WW"},
{100, "geostrophische Vorticity", "1/s", "GEOSTR_VOR"},
{101, "geostrophische  Vorticityadvektion", "1/s**2", "GEO_VORADV"},
{102, "vert. Gradient der geostr. Vorticityadvektion", "m/(kg*s)", "VERGRAVOAD"},
{103, "geostrophische Schichtdickenadvektion", "m**3/(kg*s)", "GEO_TEMADV"},
{104, "Kruemmung der geostr. Schichtdickenadvektion", "m/(kg*s)", "LAP_TEMADV"},
{105, "Forcing rechte Seite Omegagleichung", "m/(kg*s)", "OMEGA_FORC"},
{107, "Schichtdicken-Advektion", "m**3/(kg*s)", "SCHICHTD_A"},
{108, "Advektion von geostr. Vorticity mit dem therm Wind", "m/(kg*s)", "ADGEVOTHWI"},
{109, "Winddivergenz", "1/s", "WIND_DIV"},
{110, "Q-vector direction and speed (dd*1000 + fff*1E13)", "5*deg,1E13*m**2/kg/s", "Q"},
{111, "Q-Vektor X-Komponente", "m**2/(kg*s)", "QX"},
{112, "Q-Vektor Y-Komponente", "m**2/(kg*s)", "QY"},
{113, "Divergenz Q", "m/(kg*s)", "DIV_Q"},
{114, "Frontogenesefunktion, Q isother-senkrecht-Kompon.", "m**2/(kg*s)", "FRONTOGEQN"},
{115, "Qs (geo),Komp. Q-Vektor parallel zu den Isothermen", "m**2/(kg*s)", "QS_GEO"},
{116, "Divergenz Qn  geostrophisch", "m/(kg*s)", "DIVQN_GEO"},
{117, "Divergenz Qs  geostrophisch", "m/(kg*s)", "DIVQS_GEO"},
{118, "Frontogenesefunktion", "K**2/(m**2*s)", "FRONTO_GEN"},
{124, "Frontogenese-Parameter", "1", "FRONTOGENP"},
{125, "Qs, Komp. Q-Vektor parallel zu den Isothermen", "m**2/(kg*s)", "QS_VEKTOR"},
{127, "Divergenz Qs", "m/(kg*s)", "DIV_QS"},
{130, "Isentrope potentielle Vorticity", "K*m**2/(s*kg)", "IPV"},
{131, "Wind X-Komponente auf isentropen Flaechen", "m/s", "WIND_KOMPX"},
{132, "Wind Y-Komponente auf isentropen Flaechen", "m/s", "WIND_KOMPY"},
{133, "Druck einer isentropen Flaeche", "hPa", "DRUCK_ISE"},
{140, "KO-Index", "K", "KO_INDEX"},
{141, "Totals-Totals-Index", "K", "TT_INDEX"},
{142, "S-Index", "K", "S_INDEX"},
{143, "Steinbeck-Index", "1", "STEIN_IND"},
{144, "Baily-Index", "1", "BAILY_IND"},
{145, "Microburst-Index", "1", "MICROBURST"},
{146, "Clear Air Turbulence Index", "1/s", "CAT_INDEX"},
{148, "Labilit{tsenergie", "J/g", "LAB_ENERG"},
{149, "Showalter-Index", "K", "SHOW_INDEX"},
{150, "Virtuelle Temperatur", "K", "VIRT_T"},
{151, "Pseudo-Temperatur", "K", "PSEUDO_T"},
{152, "Pseudopotentielle Temperatur", "K", "PSEUDO_POT"},
{153, "Aequivalent-Temperatur", "K", "AEQUI_T"},
{154, "Aequivalentpotentielle Temperatur", "K", "AEQUI_POT"},
{157, "Untergrenze strat. + konv. Bewoelkung", "m", "BAS_STCO_W"},
{158, "Untergrenze strat. + konv. Bewoelkung", "hft", "BAS_STCO_W"},
{159, "Untergrenze strat. + konv. Bewoelkung", "hPa", "BAS_STCO_W"},
{160, "Untergrenze strat. Bew|lkung", "hft", "BAS_ST_WOL"},
{161, "Untergrenze strat. Bew|lkung", "hPa", "BAS_ST_WOL"},
{162, "Untergrenze cumul. Bew|lkung", "hft", "BAS_CU_WOL"},
{163, "Untergrenze cumul. Bew|lkung", "hPa", "BAS_CU_WOL"},
{164, "Obergrenze strat. Bew|lkung", "hft", "TOP_ST_WOL"},
{165, "Obergrenze strat. Bew|lkung", "hPa", "TOP_ST_WOL"},
{166, "Obergrenze cumul. Bew|lkung", "hft", "TOP_CU_WOL"},
{167, "Obergrenze cumul. Bew|lkung", "hPa", "TOP_CU_WOL"},
{170, "Untergrenze Wolkenturbulenz", "hft", "BAS_TUR_WO"},
{171, "Untergrenze Wolkenturbulenz", "hPa", "BAS_TUR_WO"},
{172, "Obergrenze Wolkenturbulenz", "hft", "TOP_TUR_WO"},
{173, "Obergrenze Wolkenturbulenz", "hPa", "TOP_TUR_WO"},
{174, "Untergrenze Vereisung in Wolken", "hft", "BAS_EIS_WO"},
{175, "Untergrenze Vereisung in Wolken", "hPa", "BAS_EIS_WO"},
{176, "Obergrenze Vereisung in Wolken", "hft", "TOP_EIS_WO"},
{177, "Obergrenze Vereisung in Wolken", "hPa", "TOP_EIS_WO"},
{178, "Intensitaet der Turbulenz in Wolken  (0..4)", "1", "INT_TUR_WO"},
{179, "Intensitaet der Vereisung  (0..4)", "1", "INT_EIS_WO"},
{181, "Prognostic Icing: Degree (for composits)", "index", "PIP_D_COMP"},
{182, "Prognostic Icing: Scenario (for composits)", "index", "PIP_S_COMP"},
{183, "Diagnostic Icing: Degree (for composits)", "index", "DIP_D_COMP"},
{184, "Diagnostic Icing: Scenario (for composits)", "index", "DIP_S_COMP"},
{190, "Sichtweite", "m", "SICHTWEITE"},
{191, "Prognostic Icing: Degree (1=LGT,2=MOD,3=SEV)", "index", "PIP_DEGREE"},
{192, "Prog Icing:Scenario (1=gen,2=conv,3=strat,4=freez)", "index", "PIP_SCENAR"},
{193, "Diagnostic Icing: Degree (1=LGT,2=MOD,3=SEV)", "index", "DIP_DEGREE"},
{194, "Diag Icing:Scenario (1=gen,2=conv,3=strat,4=freez)", "index", "DIP_SCENAR"},
{195, "Icing Regime 1.Guess(1=gen,2=conv,3=strat,4=freez)", "1", "ICINGGUESS"},
{196, "Icing Grade (1=LGT,2=MOD,3=SEV)", "1", "ICINGGRADE"},
{197, "Icing Regime(1=general,2=convect,3=strat,4=freez)", "1", "ICINGREGIM"},
{200, "Wetter - Grundzustand   ww", "1", "GRU_WETTER"},
{201, "Wetter - 1. lokale Abweichung  ww", "1", "LOK_WETTER"},
{202, "Wetter - 2. lokale Abweichung  ww", "1", "LOK_WETTER"},
{203, "cloud depth grey scale", "1", "CLDEPTH"},
{204, "modified total cloud cover  (0..1)", "1", "CLCT_MOD"},
{205, "current weather symbol number", "1", "CURR_WEATH"},
{211, "Cumulus  (0..1)", "1", "CU"},
{212, "Cumulimbus  (0..1)", "1", "CB"},
{213, "Stratocumulus  (0..1)", "1", "SC"},
{214, "Altocumulus  (0..1)", "1", "AC"},
{215, "Cirrus  (0..1)", "1", "CI"},
{216, "Stratus  (0..1)", "1", "ST"},
{217, "Altostratus  (0..1)", "1", "AS"},
{221, "Bedeckung in Stufen", "1", "BEDECKUNG"},
{222, "Konvektion  ja/nein", "1", "KONVEKTION"},
{223, "Gesamtbedeckung > 90%  ja/nein", "1", "MN_90"},
{224, "relative Feuchte 700 hPa >= 90%  ja/nein", "1", "RF700_89"},
{225, "Niederschlag 12 std. zentriert", "mm", "RR12_ZENTR"},
{226, "Niederschlag 12 std. zentriert, Werte <= 0.5mm", "mm", "RR12_0_5"},
{227, "RR12 zentriert, Schneeanteil > 60%  ja/nein", "1", "RR12_SA_60"},
{228, "RR12 zentriert, konvektiver Anteil > 60%  ja/nein", "1", "RR12_KV_60"},
{229, "Starkniederschlag in Stufen (12 std. Folgezeitr)", "1", "SRR12FF"},
{230, "Maximaler Starkniederschlag / std", "mm/h", "RRMAX_STD"},
{231, "Maximaler Starkniederschlag / min", "mm/min", "RRMAX_MIN"},
{232, "Schneefall (12std. Folgezeitraum) > 15 mm  ja/nein", "1", "SN12FF_15"},
{233, "gefrierender Regen (12std. Folgezeitraum)  ja/nein", "1", "RRGEFR12FF"},
{234, "Boeenstaerke in Stufen", "1", "FFBOE"},
{235, "Gewitter in Stufen", "1", "GEWITTER"},
{236, "2m Maximumtemperatur 12h zentriert", "Grad Celsius", "TX2M12H_ZE"},
{237, "2m Minimumtemperatur 12h zentriert", "Grad Celsius", "TN2M12H_ZE"},
{251, "Schwuele-Index", "1", "SCHWUELIND"},
{252, "Smog-Intensitaetsstufen", "1", "SMOGSTUFEN"},
{254, "Obergrenze Smog  ( Inversionshoehe )", "m", "SMOGHOEHE"},
};
