/* 
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 130
 * Usage: Atlantic Stratocumulus Transition Experiment (ASTEX)
 */ 

TBLE2 ecmwf_130_params[] = {
{208, "Top solar radiation upward", "W m**-2", "TSRU"},
{209, "Top thermal radiation upward", "W m**-2", "TTRU"},
{210, "Top solar radiation upward clear sky", "W m**-2", "TSUC"},
{211, "Top thermal radiation upward clear sky", "W m**-2", "TTUC"},
{212, "Cloud liquid water", " kg kg**-1", "CLW"},
{213, "Cloud fraction", "0-1", "CF"},
{214, "Diabatic heating by radiation", "K s**-1", "DHR"},
{215, "Diabatic heating by vertical diffusion", "K s**-1", "DHVD"},
{216, "Diabatic heating by cumulus convection", "K s**-1", "DHCC"},
{217, "Diabatic heating by large-scale condensation", "K s**-1", "DHLC"},
{218, "Vertical diffusion of zonal wind", "m**2 s**-3", "VDZW"},
{219, "Vertical diffusion of meridional wind", "m**2 s**-3", "VDMW"},
{220, "EW gravity wave drag", "m**2 s**-3", "EWGD"},
{221, "NS gravity wave drag", "m**2 s**-3", "NSGD"},
{222, "Convective tendency of zonal wind", "m**2 s**-3", "CTZW"},
{223, "Convective tendency of meridional wind", "m**2 s**-3", "CTMW"},
{224, "Vertical diffusion of humidity", "kg kg**-1 s**-1", "VDH"},
{225, "Humidity tendency by cumulus convection", "kg kg**-1 s**-1", "HTCC"},
{226, "Humidity tendency by large-scale condensation", "kg kg**-1 s**-1", "HTLC"},
{227, "Change from removing negative humidity", "kg kg**-1 s**-1", "CRNH"},
{228, "Adiabatic tendency of temperature", "K s**-1", "ATT"},
{229, "Adiabatic tendency of humidity", "kg kg**-1 s**-1", "ATH"},
{230, "Adiabatic tendency of zonal wind", "m**2 s**-3", "ATZW"},
{231, "Adiabatic tendency of meridional wind", "m**2 s**-3", "ATMW"},
{232, "Mean vertical velocity", "Pa s**-1", "MVV"},
};
