/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Probability forecasts
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 131
 */

TBLE2 ecmwf_131_params[] = {
{1, "2m temperature anomaly of at least +2K", "%", "2TAG2"},
{2, "2m temperature anomaly of at least +1K", "%", "2TAG1"},
{3, "2m temperature anomaly of at least 0K", "%", "2TAG0"},
{4, "2m temperature anomaly of at most -1K", "%", "2TALM1"},
{5, "2m temperature anomaly of at most -2K", "%", "2TALM2"},
{6, "Total precipitation anomaly of at least 20 mm", "%", "TPAG20"},
{7, "Total precipitation anomaly of at least 10 mm", "%", "TPAG10"},
{8, "Total precipitation anomaly of at least 0 mm", "%", "TPAG0"},
{9, "Surface temperature anomaly of at least 0K", "%", "STAG0"},
{10, "Mean sea level pressure anomaly of at least 0 Pa", "%", "MSLAG0"},
{15, "Heigth of 0 degree isotherm probability", "%", "H0DIP"},
{16, "Heigth of snowfall limit probability", "%", "HSLP"},
{17, "Showalter index probability", "%", "SAIP"},
{18, "Whiting index probability", "%", "WHIP"},
{20, "Temperature anomaly less than -2 K", "%", "TALM2K"},
{21, "Temperature anomaly of at least +2 K", "%", "TAG2K"},
{22, "Temperature anomaly less than -8 K", "%", "TALM8K"},
{23, "Temperature anomaly less than -4 K", "%", "TALM4K"},
{24, "Temperature anomaly greater than +4 K", "%", "TAG4K"},
{25, "Temperature anomaly greater than +8 K", "%", "TAG8K"},
{49, "10 metre wind gust probability", "%", "10GP"},
{59, "Convective available potential energy probability", "%", "CAPEP"},
{60, "Total precipitation of at least 1 mm", "%", "TPG1"},
{61, "Total precipitation of at least 5 mm", "%", "TPG5"},
{62, "Total precipitation of at least 10 mm", "%", "TPG10"},
{63, "Total precipitation of at least 20 mm", "%", "TPG20"},
{64, "Total precipitation less than 0.1 mm", "%", "TPL01"},
{65, "Total precipitation rate less than 1 mm per day", "%", "TPRL1"},
{66, "Total precipitation rate of at least 3 mm per day", "%", "TPRG3"},
{67, "Total precipitation rate of at least 5 mm per day", "%", "TPRG5"},
{68, "10 metre Wind speed of at least 10 metre per second", "%", "10SPG10"},
{69, "10 metre Wind speed of at least 15 metre per second", "%", "10SPG15"},
{70, "10 metre Wind gust of at least 15 metre per second", "%", "10FGG15"},
{71, "10 metre Wind gust of at least 20 metre per second", "%", "10FGG20"},
{72, "10 metre Wind gust of at least 25 metre per second", "%", "10FGG25"},
{73, "2 metre temperature less than 273.15 K", "%", "2TL273"},
{74, "Significant wave height of at least 2 m", "%", "SWHG2"},
{75, "Significant wave height of at least 4 m", "%", "SWHG4"},
{76, "Significant wave height of at least 6 m", "%", "SWHG6"},
{77, "Significant wave height of at least 8 m", "%", "SWHG8"},
{78, "Mean wave period of at least 8 s", "%", "MWPG8"},
{79, "Mean wave period of at least 10 s", "%", "MWPG10"},
{80, "Mean wave period of at least 12 s", "%", "MWPG12"},
{81, "Mean wave period of at least 15 s", "%", "MWPG15"},
{82, "Total precipitation of at least 40 mm", "%", "TPG40"},
{83, "Total precipitation of at least 60 mm", "%", "TPG60"},
{84, "Total precipitation of at least 80 mm", "%", "TPG80"},
{85, "Total precipitation of at least 100 mm", "%", "TPG100"},
{86, "Total precipitation of at least 150 mm", "%", "TPG150"},
{87, "Total precipitation of at least 200 mm", "%", "TPG200"},
{88, "Total precipitation of at least 300 mm", "%", "TPG300"},
{129, "Geopotential probability", "%", "ZP"},
{130, "Temperature anomaly probability", "%", "TAP"},
{139, "2 metre temperature probability", "%", ""},
{144, "Snowfall probability", "%", "SFP"},
{151, "Total precipitation probability", "%", ""},
{164, "Total cloud cover probability", "%", "TCCP"},
{165, "10 metre speed probability", "%", "10SP"},
{167, "2 metre temperature probability", "%", "2TP"},
{201, "Maximum 2 metre temperature probability", "%", "MX2TP"},
{202, "Minimum 2 metre temperature probability", "%", "MN2TP"},
{228, "Total precipitation probability", "%", "TPP"},
{229, "Significant wave height probability", "%", "SWHP"},
{232, "Mean wave period probability", "%", "MWPP"},

};
