/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * SREPS
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 133
 */

TBLE2 ecmwf_133_params[] = {
{1, "2m temperature probability less than -10 C", "%", "2TPLM10"},
{2, "2m temperature probability less than -5 C", "%", "2TPLM5"},
{3, "2m temperature probability less than 0 C", "%", "2TPL0"},
{4, "2m temperature probability less than 5 C", "%", "2TPL5"},
{5, "2m temperature probability less than 10 C", "%", "2TPL10"},
{6, "2m temperature probability greater than 25 C", "%", "2TPG25"},
{7, "2m temperature probability greater than 30 C", "%", "2TPG30"},
{8, "2m temperature probability greater than 35 C", "%", "2TPG35"},
{9, "2m temperature probability greater than 40 C", "%", "2TPG40"},
{10, "2m temperature probability greater than 45 C", "%", "2TPG45"},
{11, "Minimum 2 metre temperature probability less than -10 C", "%", "MN2TPLM10"},
{12, "Minimum 2 metre temperature probability less than -5 C", "%", "MN2TPLM5"},
{13, "Minimum 2 metre temperature probability less than 0 C", "%", "MN2TPL0"},
{14, "Minimum 2 metre temperature probability less than 5 C", "%", "MN2TPL5"},
{15, "Minimum 2 metre temperature probability less than 10 C", "%", "MN2TPL10"},
{16, "Maximum 2 metre temperature probability greater than 25 C", "%", "MX2TPG25"},
{17, "Maximum 2 metre temperature probability greater than 30 C", "%", "MX2TPG30"},
{18, "Maximum 2 metre temperature probability greater than 35 C", "%", "MX2TPG35"},
{19, "Maximum 2 metre temperature probability greater than 40 C", "%", "MX2TPG40"},
{20, "Maximum 2 metre temperature probability greater than 45 C", "%", "MX2TPG45"},
{21, "10 metre wind speed probability of at least 10 m/s", "%", "10SPG10"},
{22, "10 metre wind speed probability of at least 15 m/s", "%", "10SPG15"},
{23, "10 metre wind speed probability of at least 20 m/s", "%", "10SPG20"},
{24, "10 metre wind speed probability of at least 35 m/s", "%", "10SPG35"},
{25, "10 metre wind speed probability of at least 50 m/s", "%", "10SPG50"},
{26, "10 metre wind gust probability of at least 20 m/s", "%", "10GPG20"},
{27, "10 metre wind gust probability of at least 35 m/s", "%", "10GPG35"},
{28, "10 metre wind gust probability of at least 50 m/s", "%", "10GPG50"},
{29, "10 metre wind gust probability of at least 75 m/s", "%", "10GPG75"},
{30, "10 metre wind gust probability of at least 100 m/s", "%", "10GPG100"},
{31, "Total precipitation probability of at least 1 mm", "%", "TPPG1"},
{32, "Total precipitation probability of at least 5 mm", "%", "TPPG5"},
{33, "Total precipitation probability of at least 10 mm", "%", "TPPG10"},
{34, "Total precipitation probability of at least 20 mm", "%", "TPPG20"},
{35, "Total precipitation probability of at least 40 mm", "%", "TPPG40"},
{36, "Total precipitation probability of at least 60 mm", "%", "TPPG60"},
{37, "Total precipitation probability of at least 80 mm", "%", "TPPG80"},
{38, "Total precipitation probability of at least 100 mm", "%", "TPPG100"},
{39, "Total precipitation probability of at least 150 mm", "%", "TPPG150"},
{40, "Total precipitation probability of at least 200 mm", "%", "TPPG200"},
{41, "Total precipitation probability of at least 300 mm", "%", "TPPG300"},
{42, "Snowfall probability of at least 1 mm", "%", "SFPG1"},
{43, "Snowfall probability of at least 5 mm", "%", "SFPG5"},
{44, "Snowfall probability of at least 10 mm", "%", "SFPG10"},
{45, "Snowfall probability of at least 20 mm", "%", "SFPG20"},
{46, "Snowfall probability of at least 40 mm", "%", "SFPG40"},
{47, "Snowfall probability of at least 60 mm", "%", "SFPG60"},
{48, "Snowfall probability of at least 80 mm", "%", "SFPG80"},
{49, "Snowfall probability of at least 100 mm", "%", "SFPG100"},
{50, "Snowfall probability of at least 150 mm", "%", "SFPG150"},
{51, "Snowfall probability of at least 200 mm", "%", "SFPG200"},
{52, "Snowfall probability of at least 300 mm", "%", "SFPG300"},
{53, "Total Cloud Cover probability greater than 10%", "%", "TCCPG10"},
{54, "Total Cloud Cover probability greater than 20%", "%", "TCCPG20"},
{55, "Total Cloud Cover probability greater than 30%", "%", "TCCPG30"},
{56, "Total Cloud Cover probability greater than 40%", "%", "TCCPG40"},
{57, "Total Cloud Cover probability greater than 50%", "%", "TCCPG50"},
{58, "Total Cloud Cover probability greater than 60%", "%", "TCCPG60"},
{59, "Total Cloud Cover probability greater than 70%", "%", "TCCPG70"},
{60, "Total Cloud Cover probability greater than 80%", "%", "TCCPG80"},
{61, "Total Cloud Cover probability greater than 90%", "%", "TCCPG90"},
{62, "Total Cloud Cover probability greater than 99%", "%", "TCCPG99"},
{63, "High Cloud Cover probability greater than 10%", "%", "HCCPG10"},
{64, "High Cloud Cover probability greater than 20%", "%", "HCCPG20"},
{65, "High Cloud Cover probability greater than 30%", "%", "HCCPG30"},
{66, "High Cloud Cover probability greater than 40%", "%", "HCCPG40"},
{67, "High Cloud Cover probability greater than 50%", "%", "HCCPG50"},
{68, "High Cloud Cover probability greater than 60%", "%", "HCCPG60"},
{69, "High Cloud Cover probability greater than 70%", "%", "HCCPG70"},
{70, "High Cloud Cover probability greater than 80%", "%", "HCCPG80"},
{71, "High Cloud Cover probability greater than 90%", "%", "HCCPG90"},
{72, "High Cloud Cover probability greater than 99%", "%", "HCCPG99"},
{73, "Medium Cloud Cover probability greater than 10%", "%", "MCCPG10"},
{74, "Medium Cloud Cover probability greater than 20%", "%", "MCCPG20"},
{75, "Medium Cloud Cover probability greater than 30%", "%", "MCCPG30"},
{76, "Medium Cloud Cover probability greater than 40%", "%", "MCCPG40"},
{77, "Medium Cloud Cover probability greater than 50%", "%", "MCCPG50"},
{78, "Medium Cloud Cover probability greater than 60%", "%", "MCCPG60"},
{79, "Medium Cloud Cover probability greater than 70%", "%", "MCCPG70"},
{80, "Medium Cloud Cover probability greater than 80%", "%", "MCCPG80"},
{81, "Medium Cloud Cover probability greater than 90%", "%", "MCCPG90"},
{82, "Medium Cloud Cover probability greater than 99%", "%", "MCCPG99"},
{83, "Low Cloud Cover probability greater than 10%", "%", "LCCPG10"},
{84, "Low Cloud Cover probability greater than 20%", "%", "LCCPG20"},
{85, "Low Cloud Cover probability greater than 30%", "%", "LCCPG30"},
{86, "Low Cloud Cover probability greater than 40%", "%", "LCCPG40"},
{87, "Low Cloud Cover probability greater than 50%", "%", "LCCPG50"},
{88, "Low Cloud Cover probability greater than 60%", "%", "LCCPG60"},
{89, "Low Cloud Cover probability greater than 70%", "%", "LCCPG70"},
{90, "Low Cloud Cover probability greater than 80%", "%", "LCCPG80"},
{91, "Low Cloud Cover probability greater than 90%", "%", "LCCPG90"},
{92, "Low Cloud Cover probability greater than 99%", "%", "LCCPG99"}
};
