/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Wave
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 140
 */

TBLE2 ecmwf_140_params[] = {
{200, "Maximum of significant wave height", "m", "MAXSWH"},
{215, "U-component stokes drift", "m s**-1", "UST"},
{216, "V-component stokes drift", "m s**-1", "VST"},
{217, "Period corresponding to maximum individual wave height", "s", "TMAX"},
{218, "Maximum individual wave height", "m", "HMAX"},
{219, "Model bathymetry", "m", "WMB"},
{220, "Mean wave period based on first moment", "s", "MP1"},
{221, "Mean wave period based on second moment", "s", "MP2"},
{222, "Wave spectral directional width", "-", "WDW"},
{223, "Mean wave period based on first moment for wind waves", "s", "P1WW"},
{224, "Mean wave period based on second moment for wind waves", "s", "P2WW"},
{225, "Wave spectral directional width for wind waves", "-", "DWWW"},
{226, "Mean wave period based on first moment for swell", "s", "P1PS"},
{227, "Mean wave period based on second moment for swell", "s", "P2PS"},
{228, "Wave spectral directional width for swell", "-", "DWPS"},
{229, "Significant wave height", "m", "SWH"},
{230, "Mean wave direction", "degrees", "MWD"},
{231, "Peak period of 1D spectra", "s", "PP1D"},
{232, "Mean wave period", "s", "MWP"},
{233, "Coefficient of drag with waves", "-", "CDWW"},
{234, "Significant height of wind waves", "m", "SHWW"},
{235, "Mean direction of wind waves", "degrees", "MDWW"},
{236, "Mean period of wind waves", "s", "MPWW"},
{237, "Significant height of total swell", "m", "SHTS"},
{238, "Mean direction of total swell", "degrees", "MDTS"},
{239, "Mean period of total swell", "s", "MPTS"},
{240, "Standard deviation wave height", "m", "SDHS"},
{241, "Mean of 10 metre wind speed", "m s**-1", "MU10"},
{242, "Mean wind direction", "degrees", "MDWI"},
{243, "Standard deviation of 10 metre wind speed", "m s**-1", "SDU"},
{244, "Mean square slope of waves", "dimensionless", "MSQS"},
{245, "10 metre wind speed", "m s**-1", "WIND"},
{246, "Altimeter wave height", "m", "AWH"},
{247, "Altimeter corrected wave height", "m", "ACWH"},
{248, "Altimeter range relative correction", "-", "ARRC"},
{249, "10 metre wind direction", "degrees", "DWI"},
{250, "2D wave spectra (multiple)", "m**2 s radian**-1", "2DSP"},
{251, "2D wave spectra (single)", "m**2 s radian**-1", "2DFD"},
{252, "Wave spectral kurtosis", "-", "WSK"},
{253, "Benjamin-Feir index", "-", "BFI"},
{254, "Wave spectral peakedness", "s**-1", "WSP"}
};
