/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Ocean - operational version
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 151
 */

TBLE2 ecmwf_151_params[] = {
{128, "In situ Temperature", "deg C", ""},
{129, "Ocean potential temperature", "deg C", "OCPT"},
{130, "Salinity", "psu", "S"},
{131, "Ocean current zonal component", "m s**-1", "OCU"},
{132, "Ocean current meridional component", "m s**-1", "OCV"},
{133, "Ocean current vertical component", "m s**-1", "OCW"},
{134, "Modulus of strain rate tensor", "s**-1", "MST"},
{135, "Vertical viscosity", "m**2 s**-1", "VVS"},
{136, "Vertical diffusivity", "m**2 s**-1", "VDF"},
{137, "Bottom level Depth", "m", "DEP"},
{138, "Sigma-theta", "kg m**-3", "STH"},
{139, "Richardson number", "-", "RN"},
{140, "UV product", "m**2 s**-2", "UV"},
{141, "UT product", "m s**-1 degC", "UT"},
{142, "VT product", "m s**-1 deg C", "VT"},
{143, "UU product", "m**2 s**-2", "UU"},
{144, "VV product", "m**2 s**-2", "VV"},
{145, "Sea level", "m", "SL"},
{146, "Sea level previous timestep", "m", "SL_1"},
{147, "Barotropic stream function", "m**3 s**-1", "BSF"},
{148, "Mixed layer depth", "m", "MLD"},
{149, "Bottom Pressure (equivalent height)", "m", "BTP"},
{150, "Steric height", "m", "SH"},
{151, "Curl of Wind Stress", "N m**-3", "CRL"},
{152, "Divergence of wind stress", "Nm**-3", ""},
{153, "U stress", "N m**-2", "TAX"},
{154, "V stress", "N m**-2", "TAY"},
{155, "Turbulent kinetic energy input", "W m**-2", "TKI"},
{156, "Net surface heat flux", "W m**-2", "NSF"},
{157, "Absorbed solar radiation", "W m**-2", "ASR"},
{158, "Precipitation - evaporation", "m s**-1", "PME"},
{159, "Specified sea surface temperature", "deg C", "SST"},
{160, "Specified surface heat flux", "W m**-2", "SHF"},
{161, "Diagnosed sea surface temperature error", "deg C", "DTE"},
{162, "Heat flux correction", "W m**-2", "HFC"},
{163, "20 degrees isotherm depth", "m", "20D"},
{164, "Average potential temperature in the upper 300m", "degrees C", "TAV300"},
{165, "Vertically integrated zonal velocity (previous time step)", "m**2 s**-1", "UBA1"},
{166, "Vertically Integrated meridional velocity (previous time step)", "m**2 s**-1", "VBA1"},
{167, "Vertically integrated zonal volume transport", "m**2 s**-1", "ZTR"},
{168, "Vertically integrated meridional volume transport", "m**2 s**-1", "MTR"},
{169, "Vertically integrated zonal heat transport", "J m**-1 s**-1", "ZHT"},
{170, "Vertically integrated meridional heat transport", "J m**-1 s**-1", "MHT"},
{171, "U velocity maximum", "m s**-1", "UMAX"},
{172, "Depth of the velocity maximum", "m", "DUMAX"},
{173, "Salinity maximum", "psu", "SMAX"},
{174, "Depth of salinity maximum", "m", "DSMAX"},
{175, "Average salinity in the upper 300m", "psu", "SAV300"},
{176, "Layer Thickness at scalar points", "m", "LDP"},
{177, "Layer Thickness  at vector points", "m", "LDU"},
{178, "Potential temperature increment", "deg C", "PTI"},
{179, "Potential temperature analysis error", "deg C", "PTAE"},
{180, "Background potential temperature", "deg C", "BPT"},
{181, "Analysed potential temperature", "deg C", "APT"},
{182, "Potential temperature background error", "deg C", "PTBE"},
{183, "Analysed salinity", "psu", "AS"},
{184, "Salinity increment", "psu", "SALI"},
{185, "Estimated Bias in Temperature", "deg C", "EBT"},
{186, "Estimated Bias in Salinity", "psu", "EBS"},
{187, "Zonal Velocity increment (from balance operator)", "m/s per time step", "UVI"},
{188, "Meridional Velocity increment (from balance operator)", "-", "VVI"},
{190, "Salinity increment (from salinity data)", "psu per time step", "SUBI"},
{191, "Salinity analysis error", "psu", "SALE"},
{192, "Background Salinity", "psu", "BSAL"},
{194, "Salinity background error", "psu", "SALBE"},
{199, "Estimated temperature bias from assimilation", "deg C", "EBTA"},
{200, "Estimated salinity bias from assimilation", "psu", "EBSA"},
{201, "Temperature increment from relaxation term", "deg C per time step", "LTI"},
{202, "Salinity increment from relaxation term", "-", "LSI"},
{203, "Bias in the zonal pressure gradient (applied)", "Pa**m-1", "BZPGA"},
{204, "Bias in the meridional pressure gradient (applied)", "Pa**m-1", "BMPGA"},
{205, "Estimated temperature bias from relaxation", "deg C", "EBTL"},
{206, "Estimated salinity bias from relaxation", "psu", "EBSL"},
{207, "First guess bias in temperature", "deg C", "FGBT"},
{208, "First guess bias in salinity", "psu", "FGBS"},
{209, "Applied bias in pressure", "Pa", "BPA"},
{210, "FG bias in pressure", "Pa", "FGBP"},
{211, "Bias in temperature(applied)", "deg C", "PTA"},
{212, "Bias in salinity (applied)", "psu", "PSA"}
};
