/* 
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 162
 * Usage: ECMWF re-analysis, ERA40
 */ 

TBLE2 ecmwf_162_params[] = {
{51, "Surface geopotential", "m**2 s**-2", "SZ"},
{52, "Surface pressure", "Pa", "SP"},
{53, "Vertical integral of mass of atmosphere", "kg m**-2", "VIMA"},
{54, "Vertical integral of temperature", "K kg m**-2", "VIT"},
{55, "Vertical integral of total column water vapour", "kg m**-2", "VITCWV"},
{56, "Vertical integral of total column liquid cloud water", "kg m**-2", "VITCLCW"},
{57, "Vertical integral of total column frozen cloud water", "kg m**-2", "VITCFCW"},
{58, "Vertical integral of total column ozone", "kg m**-2", "VITCO3"},
{59, "Vertical integral of kinetic energy", "J m**-2", "VIKE"},
{60, "Vertical integral of thermal energy", "J m**-2", "VITE"},
{61, "Vertical integral of dry static energy", "J m**-2", "VIDSE"},
{62, "Vertical integral of moist static energy", "J m**-2", "VIMSE"},
{63, "Vertical integral of total energy", "J m**-2", "VITOTE"},
{64, "Vertical integral of energy conversion", "W m**-2", "VIEC"},
{65, "Vertical integral of eastward mass flux", "kg m**-1 s**-1", "VIEMF"},
{66, "Vertical integral of northward mass flux", "kg m**-1 s**-1", "VINMF"},
{67, "Vertical integral of eastward kinetic energy flux", "W m**-2", "VIEKEF"},
{68, "Vertical integral of northward kinetic energy flux", "W m**-2", "VINKEF"},
{69, "Vertical integral of eastward heat flux", "W m**-2", "VIEHF"},
{70, "Vertical integral of northward heat flux", "W m**-2", "VINHF"},
{71, "Vertical integral of eastward water vapour flux", "kg m**-1 s**-1", "VIEWVF"},
{72, "Vertical integral of northward water vapour flux", "kg m**-1 s**-1", "VINWVF"},
{73, "Vertical integral of eastward geopotential flux", "W m**-2", "VIEGF"},
{74, "Vertical integral of northward geopotential flux", "W m**-2", "VINGF"},
{75, "Vertical integral of eastward total energy flux", "W m**-2", "VIETEF"},
{76, "Vertical integral of northward total energy flux", "W m**-2", "VINTEF"},
{77, "Vertical integral of eastward ozone flux", "kg m**-1 s**-1", "VIEO3F"},
{78, "Vertical integral of northward ozone flux", "kg m**-1 s**-1", "VINO3F"},
{81, "Vertical integral of divergence of mass flux", "kg m**-2 s**-1", "VIDMF"},
{82, "Vertical integral of divergence of kinetic energy flux", "W m**-2", "VIDKEF"},
{83, "Vertical integral of divergence of thermal energy flux", "W m**-2", "VIDTEF"},
{84, "Vertical integral of divergence of moisture flux", "kg m**-2 s**-1", "VIDMOF"},
{85, "Vertical integral of divergence of geopotential flux", "W m**-2", "VIDGF"},
{86, "Vertical integral of divergence of total energy flux", "W m**-2", "VIDTOTEF"},
{87, "Vertical integral of divergence of ozone flux", "kg m**-2 s**-1", "VIDO3F"},
{100, "Tendency of short wave radiation", "K", "TSWR"},
{101, "Tendency of long wave radiation", "K", "TLWR"},
{102, "Tendency of clear sky short wave radiation", "K", "TCSSWR"},
{103, "Tendency of clear sky long wave radiation", "K", "TCSLWR"},
{104, "Updraught mass flux", "kg m**-2", "UMF"},
{105, "Downdraught mass flux", "kg m**-2", "DMF"},
{106, "Updraught detrainment rate", "s m**-1", "UDR"},
{107, "Downdraught detrainment rate", "s m**-1", "DDR"},
{108, "Total precipitation flux", "kg m**-2", "TPF"},
{109, "Turbulent diffusion coefficient for heat", "m**2", "TDCFH"},
{110, "Tendency of temperature", "K", "TT"},
{111, "Tendency of specific humidity", "kg kg**-1", "TQ"},
{112, "Tendency of u component", "m s**-1", "TUC"},
{113, "Tendency of v component", "m s**-1", "TVC"},
{206, "Variance of geopotential", "m**4 s**-4", "VG"},
{207, "Covariance of geopotential/temperature", "m**2 K s**-2", "CG"},
{208, "Variance of temperature", "K**2", "VT"},
{209, "Covariance of geopotential/specific humidity", "m**2 s**-2", "CGQ"},
{210, "Covariance of temperature/specific humidity", "K", "CTQ"},
{211, "Variance of specific humidity", "-", "VQ"},
{212, "Covariance of u component/geopotential", "M**3 s**-3", "CUZ"},
{213, "Covariance of u component/temperature", "m s**-1 K", "CUT"},
{214, "Covariance of u component/specific humidity", "m s**-1", "CUQ"},
{215, "Variance of u component", "m**2 s**-2", "VU"},
{216, "Covariance of v component/geopotential", "M**3 s**-3", "CVZ"},
{217, "Covariance of v component/temperaure", "m s**-1 K", "CVT"},
{218, "Covariance of v component/specific humidity", "m s**-1", "CVQ"},
{219, "Covariance of v component/u component", "m**2 s**-2", "CVU"},
{220, "Variance of v component", "m**2 s**-2", "VV"},
{221, "Covariance of omega/geopotential", "m**2 Pa s**-3", "COZ"},
{222, "Covariance of omega/temperature", "Pa s**-1 K", "COT"},
{223, "Covariance of omega/specific humidity", "Pa s**-1", "COQ"},
{224, "Covariance of omega/u component", "m Pa s**-2", "COU"},
{225, "Covariance of omega/v component", "m Pa s**-2", "COV"},
{226, "Variance of omega", "Pa**2 s**-2", "VO"},
{227, "Variance of surface pressure", "Pa**2", "VSP"},
{229, "Variance of relative humidity", "dimensionless", "VRH"},
{230, "Covariance of u component/ozone", "m s**-1", "CUO3"},
{231, "Covariance of v component/ozone", "m s**-1", "CVO3"},
{232, "Covariance of omega/ozone", "Pa s**-1", "COO3"},
{233, "Variance of ozone", "dimensionless", "VO3"},
};
