/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Anomalies
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 171
 */

TBLE2 ecmwf_171_params[] = {
{1, "Stream function anomaly", "m**2 s**-1", "STRFA"},
{2, "Velocity potential anomaly", "m**2 s**-1", "VPOTA"},
{3, "Potential temperature", "K", ""},
{4, "Equivalent potential temperature", "K", ""},
{5, "Saturated equivalent potential temperature", "K", ""},
{11, "U component of divergent wind", "m s**-1", ""},
{12, "V component of divergent wind", "m s**-1", ""},
{13, "U component of rotational wind", "m s**-1", ""},
{14, "V component of rotational wind", "m s**-1", ""},
{21, "Unbalanced component of temperature", "K", ""},
{22, "Unbalanced component of logarithm of surface pressure", "-", ""},
{23, "Unbalanced component of divergence", "s**-1", ""},
{26, "Lake cover", "(0 - 1)", ""},
{27, "Low vegetation cover", "(0 - 1)", ""},
{28, "High vegetation cover", "(0 - 1)", ""},
{29, "Type of low vegetation", "-", ""},
{30, "Type of high vegetation", "-", ""},
{31, "Sea-ice cover", "(0 - 1)", ""},
{32, "Snow albedo", "(0 - 1)", ""},
{33, "Snow density", "kg m**-3", ""},
{34, "Sea surface temperature", "K", ""},
{35, "Ice surface temperature layer 1", "K", ""},
{36, "Ice surface temperature layer 2", "K", ""},
{37, "Ice surface temperature layer 3", "K", ""},
{38, "Ice surface temperature layer 4", "K", ""},
{39, "Volumetric soil water layer 1", "m**3 m**-3", ""},
{40, "Volumetric soil water layer 2", "m**3 m**-3", ""},
{41, "Volumetric soil water layer 3", "m**3 m**-3", ""},
{42, "Volumetric soil water layer 4", "m**3 m**-3", ""},
{43, "Soil type", "-", ""},
{44, "Snow evaporation", "m of water", ""},
{45, "Snowmelt", "m of water", ""},
{46, "Solar duration", "s", ""},
{47, "Direct solar radiation", "w m**-2", ""},
{48, "Magnitude of surface stress", "N m**-2 s", ""},
{49, "10 metre wind gust", "m s**-1", ""},
{50, "Large-scale precipitation fraction", "s", ""},
{51, "Maximum 2 metre temperature", "K", ""},
{52, "Minimum 2 metre temperature", "K", ""},
{53, "Montgomery potential", "m**2 s**-2", ""},
{54, "Pressure", "Pa", ""},
{55, "Mean 2 metre temperature in past 24 hours", "K", ""},
{56, "Mean 2 metre dewpoint temperature in past 24 hours", "K", ""},
{57, "Downward UV radiation at the surface", "w m**-2", ""},
{58, "Photosynthetically active radiation at the surface", "w m**-2", ""},
{59, "Convective available potential energy", "J kg**-1", ""},
{60, "Potential vorticity", "K m**2 kg**-1 s**-1", ""},
{61, "Total precipitation from observations", "Millimetres*100 + number of stations", ""},
{62, "Observation count", "-", ""},
{63, "Start time for skin temperature difference", "s", ""},
{64, "Finish time for skin temperature difference", "s", ""},
{65, "Skin temperature difference", "K", ""},
{78, "Total column liquid water anomaly", "kg m**-2", "TCLWA"},
{79, "Total column ice water anomaly", "kg m**-2", "TCIWA"},
{125, "Vertically integrated total energy", "J m**-2", ""},
{126, "Generic parameter for sensitive area prediction", "Various", ""},
{127, "Atmospheric tide", "-", ""},
{128, "Budget values", "-", ""},
{129, "Geopotential anomaly", "m**2 s**-2", "ZA"},
{130, "Temperature anomaly", "K", "TA"},
{131, "U velocity anomaly", "m s**-1", "UA"},
{132, "V velocity anomaly", "m s**-1", "VA"},
{133, "Specific humidity", "kg kg**-1", ""},
{134, "Surface pressure", "Pa", ""},
{135, "Vertical velocity", "Pa s**-1", ""},
{136, "Total column water", "kg m**-2", "TCWA"},
{137, "Total column water vapour", "kg m**-2", "TCWVA"},
{138, "Vorticity (relative)", "s**-1", ""},
{139, "Soil temperature level 1", "K", "STAL1"},
{140, "Soil wetness level 1", "m of water", ""},
{141, "Snow depth", "m of water equivalent", ""},
{142, "Stratiform precipitation (Large-scale precipitation)", "m", ""},
{143, "Convective precipitation", "m", ""},
{144, "Snowfall (convective + stratiform)", "m of water equivalent", ""},
{145, "Boundary layer dissipation", "W m**-2 s", ""},
{146, "Surface sensible heat flux", "W m**-2 s", ""},
{147, "Surface latent heat flux", "W m**-2 s", ""},
{148, "Charnock", "-", ""},
{149, "Surface net radiation", "W m**-2 s", ""},
{150, "Top net radiation", "-", ""},
{151, "Mean sea level pressure anomaly", "Pa", "MSLA"},
{152, "Logarithm of surface pressure", "-", ""},
{153, "Short-wave heating rate", "K", ""},
{154, "Long-wave heating rate", "K", ""},
{155, "Divergence", "s**-1", ""},
{156, "Height", "m", ""},
{157, "Relative humidity", "%", ""},
{158, "Tendency of surface pressure", "Pa s**-1", ""},
{159, "Boundary layer height", "m", ""},
{160, "Standard deviation of orography", "-", ""},
{161, "Anisotropy of sub-gridscale orography", "-", ""},
{162, "Angle of sub-gridscale orography", "rad", ""},
{163, "Slope of sub-gridscale orography", "-", ""},
{164, "Total cloud cover anomaly", "(0 - 1)", "TCCA"},
{165, "10 metre U wind component anomaly", "m s**-1", "10UA"},
{166, "10 metre V wind component anomaly", "m s**-1", "10VA"},
{167, "2 metre temperature anomaly", "K", "2TA"},
{168, "2 metre dewpoint temperature", "K", ""},
{169, "Surface solar radiation downwards", "W m**-2 s", ""},
{170, "Soil temperature level 2", "K", ""},
{171, "Soil wetness level 2", "m of water", ""},
{172, "Land-sea mask", "(0 - 1)", ""},
{173, "Surface roughness", "m", ""},
{174, "Albedo", "(0 - 1)", ""},
{175, "Surface thermal radiation downwards", "W m**-2 s", ""},
{176, "Surface solar radiation", "W m**-2 s", ""},
{177, "Surface thermal radiation", "W m**-2 s", ""},
{178, "Top solar radiation", "W m**-2 s", ""},
{179, "Top thermal radiation", "W m**-2 s", ""},
{180, "East-West surface stress", "N m**-2 s", ""},
{181, "North-South surface stress", "N m**-2 s", ""},
{182, "Evaporation", "m of water", ""},
{183, "Soil temperature level 3", "K", ""},
{184, "Soil wetness level 3", "m of water", ""},
{185, "Convective cloud cover", "(0 - 1)", ""},
{186, "Low cloud cover", "(0 - 1)", ""},
{187, "Medium cloud cover", "(0 - 1)", ""},
{188, "High cloud cover", "(0 - 1)", ""},
{189, "Sunshine duration anomaly", "s", "SUNDA"},
{190, "East-West component of sub-gridscale orographic variance", "m**2", ""},
{191, "North-South component of sub-gridscale orographic variance", "m**2", ""},
{192, "North-West/South-East component of sub-gridscale orographic variance", "m**2", ""},
{193, "North-East/South-West component of sub-gridscale orographic variance", "m**2", ""},
{194, "Brightness temperature", "K", ""},
{195, "Latitudinal component of gravity wave stress", "N m**-2 s", ""},
{196, "Meridional component of gravity wave stress", "N m**-2 s", ""},
{197, "Gravity wave dissipation", "W m**-2 s", ""},
{198, "Skin reservoir content", "m of water", ""},
{199, "Vegetation fraction", "(0 - 1)", ""},
{200, "Variance of sub-gridscale orography", "m**2", ""},
{201, "Maximum temperature at 2 metres anomaly", "K", "MX2TA"},
{202, "Minimum temperature at 2 metres anomaly", "K", "MN2TA"},
{203, "Ozone mass mixing ratio", "kg kg**-1", ""},
{204, "Precipitation analysis weights", "-", ""},
{205, "Runoff", "m", ""},
{206, "Total column ozone", "kg m**-2", ""},
{207, "10 metre wind speed", "m s**-1", ""},
{208, "Top net solar radiation, clear sky", "W m**-2 s", ""},
{209, "Top net thermal radiation, clear sky", "W m**-2 s", ""},
{210, "Surface net solar radiation, clear sky", "W m**-2 s", ""},
{211, "Surface net thermal radiation, clear sky", "W m**-2 s", ""},
{212, "Solar insolation", "W m**-2", ""},
{214, "Diabatic heating by radiation", "K", ""},
{215, "Diabatic heating by vertical diffusion", "K", ""},
{216, "Diabatic heating by cumulus convection", "K", ""},
{217, "Diabatic heating by large-scale condensation", "K", ""},
{218, "Vertical diffusion of zonal wind", "m s**-1", ""},
{219, "Vertical diffusion of meridional wind", "m s**-1", ""},
{220, "East-West gravity wave drag tendency", "m s**-1", ""},
{221, "North-South gravity wave drag tendency", "m s**-1", ""},
{222, "Convective tendency of zonal wind", "m s**-1", ""},
{223, "Convective tendency of meridional wind", "m s**-1", ""},
{224, "Vertical diffusion of humidity", "kg kg**-1", ""},
{225, "Humidity tendency by cumulus convection", "kg kg**-1", ""},
{226, "Humidity tendency by large-scale condensation", "kg kg**-1", ""},
{227, "Change from removal of negative humidity", "kg kg**-1", ""},
{228, "Total precipitation anomaly", "m", "TPA"},
{229, "Instantaneous X surface stress", "N m**-2", ""},
{230, "Instantaneous Y surface stress", "N m**-2", ""},
{231, "Instantaneous surface heat flux", "W m**-2", ""},
{232, "Instantaneous moisture flux", "kg m**-2 s", ""},
{233, "Apparent surface humidity", "kg kg**-1", ""},
{234, "Logarithm of surface roughness length for heat", "-", ""},
{235, "Skin temperature", "K", ""},
{236, "Soil temperature level 4", "K", ""},
{237, "Soil wetness level 4", "m", ""},
{238, "Temperature of snow layer", "K", ""},
{239, "Convective snowfall", "m of water equivalent", ""},
{240, "Large-scale snowfall", "m of water equivalent", ""},
{241, "Accumulated cloud fraction tendency", "(-1 to 1)", ""},
{242, "Accumulated liquid water tendency", "(-1 to 1)", ""},
{243, "Forecast albedo", "(0 - 1)", ""},
{244, "Forecast surface roughness", "m", ""},
{245, "Forecast logarithm of surface roughness for heat", "-", ""},
{246, "Cloud liquid water content", "kg kg**-1", ""},
{247, "Cloud ice water content", "kg kg**-1", ""},
{248, "Cloud cover", "(0 - 1)", ""},
{249, "Accumulated ice water tendency", "(-1 to 1)", ""},
{250, "Ice age", "(0 - 1)", ""},
{251, "Adiabatic tendency of temperature", "K", ""},
{252, "Adiabatic tendency of humidity", "kg kg**-1", ""},
{253, "Adiabatic tendency of zonal wind", "m s**-1", ""},
{254, "Adiabatic tendency of meridional wind", "m s**-1", ""}
};
