/* 
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 180
 * Usage: European Climate Support Network: High Resolution Ten Year Climate Simulation (ECSN - HIRETYCS)
 */ 

TBLE2 ecmwf_180_params[] = {
{129, "Geopotential", "m**2 s**-2", "Z"},
{130, "Temperature", "K", "T"},
{131, "U velocity", "m s**-1", "U"},
{132, "V velocity", "m s**-1", "V"},
{133, "Specific humidity", "kg kg**-1", "Q"},
{134, "Surface pressure", "Pa", "SP"},
{137, "Total column water vapour", "kg m**-2", "TCWV"},
{138, "Vorticity (relative)", "s**-1", "VO"},
{141, "Snow depth", "m of water equivalent", "SD"},
{142, "Large-scale precipitation", "m", "LSP"},
{143, "Convective precipitation", "m", "CP"},
{144, "Snowfall", "m of water equivalent", "SF"},
{146, "Surface sensible heat flux", "W m**-2 s", "SSHF"},
{147, "Surface latent heat flux", "W m**-2 s", "SLHF"},
{149, "Total soil wetness", "m", "TSW"},
{151, "Mean sea level pressure", "Pa", "MSL"},
{155, "Divergence", "s**-1", "D"},
{164, "Total cloud cover", "(0 - 1)", "TCC"},
{165, "10 metre U wind component", "m s**-1", "10U"},
{166, "10 metre V wind component", "m s**-1", "10V"},
{167, "2 metre temperature", "K", "2T"},
{168, "2 metre dewpoint temperature", "K", "2D"},
{172, "Land-sea mask", "(0, 1)", "LSM"},
{176, "Surface solar radiation", "J m**-2 s", "SSR"},
{177, "Surface thermal radiation", "J m**-2 s", "STR"},
{178, "Top solar radiation", "J m**-2 s", "TSR"},
{179, "Top thermal radiation", "J m**-2 s", "TTR"},
{180, "East-West surface stress", "N m**-2 s", "EWSS"},
{181, "North-South surface stress", "N m**-2 s", "NSSS"},
{182, "Evaporation", "m of water", "E"},
{205, "Runoff", "m", "RO"},
};
