/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Seasonal to interannual ensemble forecasts
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 190
 */

TBLE2 ecmwf_190_params[] = {
{129, "Geopotential", "m**2 s**-2", "Z"},
{130, "Temperature", "K", "T"},
{131, "U velocity", "m s**-1", "U"},
{132, "V velocity", "m s**-1", "V"},
{133, "Specific humidity", "kg kg**-1", "Q"},
{139, "Soil temperature level 1", "K", "STL1"},
{141, "Snow depth", "m of water", "SD"},
{146, "Surface sensible heat flux", "W m**-2 s", "SSHF"},
{147, "Surface latent heat flux", "W m**-2 s", "SLHF"},
{151, "Mean sea level pressure", "Pa", "MSL"},
{164, "Total cloud cover", "(0 - 1)", "TCC"},
{165, "10 metre U wind component", "m s**-1", "10U"},
{166, "10 metre V wind component", "m s**-1", "10V"},
{167, "2 metre temperature", "K", "2T"},
{168, "2 metre dewpoint temperature", "K", "2D"},
{169, "Downward surface solar radiation", "W m**-2 s (W m**-2 for monthly means)", "SSRD"},
{170, "Field capacity", "(0 - 1)", "CAP"},
{171, "Wilting point", "(0 - 1)", "WILT"},
{172, "Land-sea mask", "(0 - 1)", "LSM"},
{173, "Roughness length", "(0 - 1)", "SR"},
{174, "Albedo", "(0 - 1)", "AL"},
{175, "Downward surface long wave radiation", "W m**-2 s (W m**-2 for monthly means)", "STRD"},
{176, "Surface net solar radiation", "W m**-2 s (W m**-2 for monthly means)", "SSR"},
{177, "Surface net long wave radiation", "W m**-2 s (W m**-2 for monthly means)", "STR"},
{178, "Top net solar radiation", "W m**-2 s (W m**-2 for monthly means)", "TSR"},
{179, "Top net long wave radiation", "W m**-2 s (W m**-2 for monthly means)", "TTR"},
{182, "Evaporation", "m (m s**-1 for monthly means)", "E"},
{201, "Maximum 2 metre temperature", "K", "MX2T"},
{202, "Minimum 2 metre temperature", "K", "MN2T"},
{228, "Total precipitation", "m (m s**-1 for monthly means)", "TP"},
{229, "Total soil moisture", "m**3 m**-3", "TSM"}
};
