/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * COSMO
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 201
 */

TBLE2 ecmwf_201_params[] = {
{1, "downward shortwave radiant flux density", "W m**-2", ""},
{2, "upward shortwave radiant flux density", "W m**-2", ""},
{3, "downward longwave radiant flux density", "W m**-2", ""},
{4, "upward longwave radiant flux density", "W m**-2", ""},
{5, "downwd photosynthetic active radiant flux density", "W m**-2", "APAB_S"},
{6, "net shortwave flux", "W m**-2", ""},
{7, "net longwave flux", "W m**-2", ""},
{8, "total net radiative flux density", "W m**-2", ""},
{9, "downw shortw radiant flux density, cloudfree part", "W m**-2", ""},
{10, "upw shortw radiant flux density, cloudy part", "W m**-2", ""},
{11, "downw longw radiant flux density, cloudfree part", "W m**-2", ""},
{12, "upw longw radiant flux density, cloudy part", "W m**-2", ""},
{13, "shortwave radiative heating rate", "K s**-1", "SOHR_RAD"},
{14, "longwave radiative heating rate", "K s**-1", "THHR_RAD"},
{15, "total radiative heating rate", "W m**-2", ""},
{16, "soil heat flux, surface", "W m**-2", ""},
{17, "soil heat flux, bottom of layer", "W m**-2", ""},
{29, "fractional cloud cover", "(0-1)", "CLC"},
{30, "cloud cover, grid scale", "(0-1)", ""},
{31, "specific cloud water content", "kg kg**-1", "QC"},
{32, "cloud water content, grid scale, vert integrated", "kg m**-2", ""},
{33, "specific cloud ice content, grid scale", "kg kg**-1", "QI"},
{34, "cloud ice content, grid scale, vert integrated", "kg m**-2", ""},
{35, "specific rainwater content, grid scale", "kg kg**-1", ""},
{36, "specific snow content, grid scale", "kg kg**-1", ""},
{37, "specific rainwater content, gs, vert. integrated", "kg m**-2", ""},
{38, "specific snow content, gs, vert. integrated", "kg m**-2", ""},
{41, "total column water", "kg m**-2", "TWATER"},
{42, "vert. integral of divergence of tot. water content", "kg m**-2", ""},
{50, "cloud covers CH_CM_CL (000...888)", "(0-1)", "CH_CM_CL"},
{51, "cloud cover CH (0..8)", "(0-1)", ""},
{52, "cloud cover CM (0..8)", "(0-1)", ""},
{53, "cloud cover CL (0..8)", "(0-1)", ""},
{54, "total cloud cover (0..8)", "(0-1)", ""},
{55, "fog (0..8)", "(0-1)", ""},
{56, "fog", "(0-1)", ""},
{60, "cloud cover, convective cirrus", "(0-1)", ""},
{61, "specific cloud water content, convective clouds", "kg kg**-1", ""},
{62, "cloud water content, conv clouds, vert integrated", "kg m**-2", ""},
{63, "specific cloud ice content, convective clouds", "kg kg**-1", ""},
{64, "cloud ice content, conv clouds, vert integrated", "kg m**-2", ""},
{65, "convective mass flux", "kg s**-1 m**-2", ""},
{66, "updraft velocity, convection", "m s**-1", ""},
{67, "entrainment parameter, convection", "m**-1", ""},
{68, "cloud base, convective clouds (above msl)", "m", "HBAS_CON"},
{69, "cloud top, convective clouds (above msl)", "m", "HTOP_CON"},
{70, "convective layers (00...77)  (BKE)", "(0-1)", ""},
{71, "KO-index", "(1)", ""},
{72, "convection base index", "(1)", "BAS_CON"},
{73, "convection top index", "(1)", "TOP_CON"},
{74, "convective temperature tendency", "K s**-1", "DT_CON"},
{75, "convective tendency of specific humidity", "s**-1", "DQV_CON"},
{76, "convective tendency of total heat", "J kg**-1 s**-1", ""},
{77, "convective tendency of total water", "s**-1", ""},
{78, "convective momentum tendency (X-component)", "m s**-2", "DU_CON"},
{79, "convective momentum tendency (Y-component)", "m s**-2", "DV_CON"},
{80, "convective vorticity tendency", "s**-2", ""},
{81, "convective divergence tendency", "s**-2", ""},
{82, "top of dry convection (above msl)", "m", "HTOP_DC"},
{83, "dry convection top index", "(1)", ""},
{84, "height of 0 degree Celsius isotherm above msl", "m", "HZEROCL"},
{85, "height of snow-fall limit", "m", "SNOWLMT"},
{99, "spec. content of precip. particles", "kg kg**-1", "QRS_GSP"},
{100, "surface precipitation rate, rain, grid scale", "kg s**-1 m**-2", "PRR_GSP"},
{101, "surface precipitation rate, snow, grid scale", "kg s**-1 m**-2", "PRS_GSP"},
{102, "surface precipitation amount, rain, grid scale", "kg m**-2", "RAIN_GSP"},
{111, "surface precipitation rate, rain, convective", "kg s**-1 m**-2", "PRR_CON"},
{112, "surface precipitation rate, snow, convective", "kg s**-1 m**-2", "PRS_CON"},
{113, "surface precipitation amount, rain, convective", "kg m**-2", "RAIN_CON"},
{139, "deviation of pressure from reference value", "Pa", "PP"},
{150, "coefficient of horizontal diffusion", "m**2 s**-1", ""},
{187, "maximum wind velocity", "m s**-1", "VMAX_10M"},
{200, "water content of interception store", "kg m**-2", "W_I"},
{203, "snow temperature", "K", "T_SNOW"},
{215, "ice surface temperature", "K", "T_ICE"},
{241, "convective available potential energy", "J kg**-1", "CAPE_CON"}
};
