/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * GEMS
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 210
 */

TBLE2 ecmwf_210_params[] = {
{1, "Sea Salt Aerosol (0.03 - 0.5 um) Mixing Ratio", "kg kg**-1", "AERMR01"},
{2, "Sea Salt Aerosol (0.5 - 5 um) Mixing Ratio", "kg kg**-1", "AERMR02"},
{3, "Sea Salt Aerosol (5 - 20 um) Mixing Ratio", "kg kg**-1", "AERMR03"},
{4, "Dust Aerosol (0.03 - 0.55 um) Mixing Ratio", "kg kg**-1", "AERMR04"},
{5, "Dust Aerosol (0.55 - 0.9 um) Mixing Ratio", "kg kg**-1", "AERMR05"},
{6, "Dust Aerosol (0.9 - 20 um) Mixing Ratio", "kg kg**-1", "AERMR06"},
{7, "Hydrophobic Organic Matter Aerosol Mixing Ratio", "kg kg**-1", "AERMR07"},
{8, "Hydrophilic Organic Matter Aerosol Mixing Ratio", "kg kg**-1", "AERMR08"},
{9, "Hydrophobic Black Carbon Aerosol Mixing Ratio", "kg kg**-1", "AERMR09"},
{10, "Hydrophilic Black Carbon Aerosol Mixing Ratio", "kg kg**-1", "AERMR10"},
{11, "Sulphate Aerosol Mixing Ratio", "kg kg**-1", "AERMR11"},
{12, "Aerosol type 12 mixing ratio", "kg kg**-1", "AERMR12"},
{16, "Aerosol type 1 source/gain accumulated", "kg m**-2", "AERGN01"},
{17, "Aerosol type 2 source/gain accumulated", "kg m**-2", "AERGN02"},
{18, "Aerosol type 3 source/gain accumulated", "kg m**-2", "AERGN03"},
{19, "Aerosol type 4 source/gain accumulated", "kg m**-2", "AERGN04"},
{20, "Aerosol type 5 source/gain accumulated", "kg m**-2", "AERGN05"},
{21, "Aerosol type 6 source/gain accumulated", "kg m**-2", "AERGN06"},
{22, "Aerosol type 7 source/gain accumulated", "kg m**-2", "AERGN07"},
{23, "Aerosol type 8 source/gain accumulated", "kg m**-2", "AERGN08"},
{24, "Aerosol type 9 source/gain accumulated", "kg m**-2", "AERGN09"},
{25, "Aerosol type 10 source/gain accumulated", "kg m**-2", "AERGN10"},
{26, "Aerosol type 11 source/gain accumulated", "kg m**-2", "AERGN11"},
{27, "Aerosol type 12 source/gain accumulated", "kg m**-2", "AERGN12"},
{31, "Aerosol type 1 sink/loss accumulated", "kg m**-2", "AERLS01"},
{32, "Aerosol type 2 sink/loss accumulated", "kg m**-2", "AERLS02"},
{33, "Aerosol type 3 sink/loss accumulated", "kg m**-2", "AERLS03"},
{34, "Aerosol type 4 sink/loss accumulated", "kg m**-2", "AERLS04"},
{35, "Aerosol type 5 sink/loss accumulated", "kg m**-2", "AERLS05"},
{36, "Aerosol type 6 sink/loss accumulated", "kg m**-2", "AERLS06"},
{37, "Aerosol type 7 sink/loss accumulated", "kg m**-2", "AERLS07"},
{38, "Aerosol type 8 sink/loss accumulated", "kg m**-2", "AERLS08"},
{39, "Aerosol type 9 sink/loss accumulated", "kg m**-2", "AERLS09"},
{40, "Aerosol type 10 sink/loss accumulated", "kg m**-2", "AERLS10"},
{41, "Aerosol type 11 sink/loss accumulated", "kg m**-2", "AERLS11"},
{42, "Aerosol type 12 sink/loss accumulated", "kg m**-2", "AERLS12"},
{46, "Aerosol precursor mixing ratio", "kg kg**-1", "AERPR"},
{47, "Aerosol small mode mixing ratio", "kg kg**-1", "AERSM"},
{48, "Aerosol large mode mixing ratio", "kg kg**-1", "AERLG"},
{49, "Aerosol precursor optical depth", "dimensionless", "AODPR"},
{50, "Aerosol small mode optical depth", "dimensionless", "AODSM"},
{51, "Aerosol large mode optical depth", "dimensionless", "AODLG"},
{52, "Dust emission potential", "kg s**2 m**-5", "AERDEP"},
{53, "Lifting threshold speed", "m s**-1", "AERLTS"},
{54, "Soil clay content", "%", "AERSCC"},
{61, "Carbon Dioxide", "kg kg**-1", "CO2"},
{62, "Methane", "kg kg**-1", "CH4"},
{63, "Nitrous oxide", "kg kg**-1", "N2O"},
{64, "Total column Carbon Dioxide", "kg m**-2", "TCCO2"},
{65, "Total column Methane", "kg m**-2", "TCCH4"},
{66, "Total column Nitrous oxide", "kg m**-2", "TCN2O"},
{67, "Ocean flux of Carbon Dioxide", "kg m**-2 s**-1", "CO2OF"},
{68, "Natural biosphere flux of Carbon Dioxide", "kg m**-2 s**-1", "CO2NBF"},
{69, "Anthropogenic emissions of Carbon Dioxide", "kg m**-2 s**-1", "CO2APF"},
{70, "Methane Surface Fluxes", "kg m**-2 s**-1", "CH4F"},
{71, "Methane loss rate due to radical hydroxyl (OH)", "s**-1", "KCH4"},
{80, "Wildfire flux of Carbon Dioxide", "kg m**-2 s**-1", "CO2FIRE"},
{81, "Wildfire flux of Carbon Monoxide", "kg m**-2 s**-1", "COFIRE"},
{82, "Wildfire flux of Methane", "kg m**-2 s**-1", "CH4FIRE"},
{83, "Wildfire flux of Non-Methane Hydro-Carbons", "kg m**-2 s**-1", "NMHCFIRE"},
{84, "Wildfire flux of Hydrogen", "kg m**-2 s**-1", "H2FIRE"},
{85, "Wildfire flux of Nitrogen Oxides NOx", "kg m**-2 s**-1", "NOXFIRE"},
{86, "Wildfire flux of Nitrous Oxide", "kg m**-2 s**-1", "N2OFIRE"},
{87, "Wildfire flux of Particulate Matter PM2.5", "kg m**-2 s**-1", "PM2P5FIRE"},
{88, "Wildfire flux of Total Particulate Matter", "kg m**-2 s**-1", "TPMFIRE"},
{89, "Wildfire flux of Total Carbon in Aerosols", "kg m**-2 s**-1", "TCFIRE"},
{90, "Wildfire flux of Organic Carbon", "kg m**-2 s**-1", "OCFIRE"},
{91, "Wildfire flux of Black Carbon", "kg m**-2 s**-1", "BCFIRE"},
{92, "Wildfire overall flux of burnt Carbon", "kg m**-2 s**-1", "CFIRE"},
{93, "Wildfire fraction of C4 plants", "dimensionless", "C4FFIRE"},
{94, "Wildfire vegetation map index", "dimensionless", "VEGFIRE"},
{95, "Wildfire Combustion Completeness", "dimensionless", "CCFIRE"},
{96, "Wildfire Fuel Load", "kg m**-2", "FLFIRE"},
{97, "Wildfire fraction of area burnt", "dimensionless", "BFFIRE"},
{98, "Wildfire observed area", "m**2", "OAFIRE"},
{99, "Wildfire radiative power", "W m**-2", "FRPFIRE"},
{100, "Wildfire combustion rate", "kg m**-2 s**-1", "CRFIRE"},
{121, "Nitrogen dioxide", "kg kg**-1", "NO2"},
{122, "Sulphur dioxide", "kg kg**-1", "SO2"},
{123, "Carbon monoxide", "kg kg**-1", "CO"},
{124, "Formaldehyde", "kg kg**-1", "HCHO"},
{125, "Total column Nitrogen dioxide", "kg m**-2", "TCNO2"},
{126, "Total column Sulphur dioxide", "kg m**-2", "TCSO2"},
{127, "Total column Carbon monoxide", "kg m**-2", "TCCO"},
{128, "Total column Formaldehyde", "kg m**-2", "TCHCHO"},
{129, "Nitrogen Oxides", "kg kg**-1", "NOX"},
{130, "Total Column Nitrogen Oxides", "kg m**-2", "TCNOX"},
{131, "Reactive tracer 1 mass mixing ratio", "kg kg**-1", "GRG1"},
{132, "Total column GRG tracer 1", "kg m**-2", "TCGRG1"},
{133, "Reactive tracer 2 mass mixing ratio", "kg kg**-1", "GRG2"},
{134, "Total column GRG tracer 2", "kg m**-2", "TCGRG2"},
{135, "Reactive tracer 3 mass mixing ratio", "kg kg**-1", "GRG3"},
{136, "Total column GRG tracer 3", "kg m**-2", "TCGRG3"},
{137, "Reactive tracer 4 mass mixing ratio", "kg kg**-1", "GRG4"},
{138, "Total column GRG tracer 4", "kg m**-2", "TCGRG4"},
{139, "Reactive tracer 5 mass mixing ratio", "kg kg**-1", "GRG5"},
{140, "Total column GRG tracer 5", "kg m**-2", "TCGRG5"},
{141, "Reactive tracer 6 mass mixing ratio", "kg kg**-1", "GRG6"},
{142, "Total column GRG tracer 6", "kg m**-2", "TCGRG6"},
{143, "Reactive tracer 7 mass mixing ratio", "kg kg**-1", "GRG7"},
{144, "Total column GRG tracer 7", "kg m**-2", "TCGRG7"},
{145, "Reactive tracer 8 mass mixing ratio", "kg kg**-1", "GRG8"},
{146, "Total column GRG tracer 8", "kg m**-2", "TCGRG8"},
{147, "Reactive tracer 9 mass mixing ratio", "kg kg**-1", "GRG9"},
{148, "Total column GRG tracer 9", "kg m**-2", "TCGRG9"},
{149, "Reactive tracer 10 mass mixing ratio", "kg kg**-1", "GRG10"},
{150, "Total column GRG tracer 10", "kg m**-2", "TCGRG10"},
{151, "Surface flux Nitrogen oxides", "kg m**-2 s**-1", "SFNOX"},
{152, "Surface flux Nitrogen dioxide", "kg m**-2 s**-1", "SFNO2"},
{153, "Surface flux Sulphur dioxide", "kg m**-2 s**-1", "SFSO2"},
{154, "Surface flux Carbon monoxide", "kg m**-2 s**-1", "SFCO2"},
{155, "Surface flux Formaldehyde", "kg m**-2 s**-1", "SFHCHO"},
{156, "Surface flux GEMS Ozone", "kg m**-2 s**-1", "SFGO3"},
{157, "Surface flux reactive tracer 1", "kg m**-2 s**-1", "SFGR1"},
{158, "Surface flux reactive tracer 2", "kg m**-2 s**-1", "SFGR2"},
{159, "Surface flux reactive tracer 3", "kg m**-2 s**-1", "SFGR3"},
{160, "Surface flux reactive tracer 4", "kg m**-2 s**-1", "SFGR4"},
{161, "Surface flux reactive tracer 5", "kg m**-2 s**-1", "SFGR5"},
{162, "Surface flux reactive tracer 6", "kg m**-2 s**-1", "SFGR6"},
{163, "Surface flux reactive tracer 7", "kg m**-2 s**-1", "SFGR7"},
{164, "Surface flux reactive tracer 8", "kg m**-2 s**-1", "SFGR8"},
{165, "Surface flux reactive tracer 9", "kg m**-2 s**-1", "SFGR9"},
{166, "Surface flux reactive tracer 10", "kg m**-2 s**-1", "SFGR10"},
{181, "Radon", "kg kg**-1", "R"},
{182, "Sulphur Hexafluoride", "kg kg**-1", "SF6"},
{183, "Total column Radon", "kg m**-2", "TCR"},
{184, "Total column Sulphur Hexafluoride", "kg m**-2", "TCSF6"},
{185, "Anthropogenic Emissions of Sulphur Hexafluoride", "kg m**-2 s**-1", "SF6APF"},
{203, "GEMS Ozone", "kg kg**-1", "GO3"},
{206, "GEMS Total column ozone", "kg m**-2", "GTCO3"},
{207, "Total Aerosol Optical Depth at 550nm", "-", "AOD550"},
{208, "Sea Salt Aerosol Optical Depth at 550nm", "-", "SSAOD550"},
{209, "Dust Aerosol Optical Depth at 550nm", "-", "DUAOD550"},
{210, "Organic Matter Aerosol Optical Depth at 550nm", "-", "OMAOD550"},
{211, "Black Carbon Aerosol Optical Depth at 550nm", "-", "BCAOD550"},
{212, "Sulphate Aerosol Optical Depth at 550nm", "-", "SUAOD550"},
{213, "Total Aerosol Optical Depth at 469nm", "-", "AOD469"},
{214, "Total Aerosol Optical Depth at 670nm", "-", "AOD670"},
{215, "Total Aerosol Optical Depth at 865nm", "-", "AOD865"},
{216, "Total Aerosol Optical Depth at 1240nm", "-", "AOD1240"}
};
