/*
 *
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Parameters on coarse grid for variable resolutions systems
 *
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 230
 */

TBLE2 ecmwf_230_params[] = {
{44, "Snow evaporation (variable resolution)", "m of water", "ESVAR"},
{45, "Snowmelt (variable resolution)", "m of water", "SMLTVAR"},
{46, "Solar duration (variable resolution)", "s", "SDURVAR"},
{57, "Downward UV radiation at the surface (variable resolution)", "w m**-2 s", "UVBVAR"},
{58, "Photosynthetically active radiation at the surface (variable resolution)", "w m**-2 s", "PARVAR"},
{142, "Stratiform precipitation (Large-scale precipitation) (variable resolution)", "m", "LSPVAR"},
{143, "Convective precipitation (variable resolution)", "m", "CPVAR"},
{144, "Snowfall (convective + stratiform) (variable resolution)", "m of water equivalent", "SFVAR"},
{145, "Boundary layer dissipation (variable resolution)", "W m**-2 s", "BLDVAR"},
{146, "Surface sensible heat flux (variable resolution)", "W m**-2 s", "SSHFVAR"},
{147, "Surface latent heat flux (variable resolution)", "W m**-2 s", "SLHFVAR"},
{169, "Surface solar radiation downwards (variable resolution)", "W m**-2 s", "SSRDVAR"},
{175, "Surface thermal radiation downwards (variable resolution)", "W m**-2 s", "STRDVAR"},
{176, "Surface solar radiation (variable resolution)", "W m**-2 s", "SSRVAR"},
{177, "Surface thermal radiation (variable resolution)", "W m**-2 s", "STRVAR"},
{178, "Top solar radiation (variable resolution)", "W m**-2 s", "TSRVAR"},
{179, "Top thermal radiation (variable resolution)", "W m**-2 s", "TTRVAR"},
{180, "East-West surface stress (variable resolution)", "N m**-2 s", "EWSSVAR"},
{181, "North-South surface stress (variable resolution)", "N m**-2 s", "NSSSVAR"},
{182, "Evaporation (variable resolution)", "m of water", "EVAR"},
{189, "Sunshine duration (variable resolution)", "s", "SUNDVAR"},
{195, "Latitudinal component of gravity wave stress (variable resolution)", "N m**-2 s", "LGWSVAR"},
{196, "Meridional component of gravity wave stress (variable resolution)", "N m**-2 s", "MGWSVAR"},
{197, "Gravity wave dissipation (variable resolution)", "W m**-2 s", "GWDVAR"},
{198, "Skin reservoir content (variable resolution)", "m of water", "SRCVAR"},
{205, "Runoff (variable resolution)", "m", "ROVAR"},
{208, "Top net solar radiation, clear sky (variable resolution)", "W m**-2 s", "TSRCVAR"},
{209, "Top net thermal radiation, clear sky (variable resolution)", "W m**-2 s", "TTRCVAR"},
{210, "Surface net solar radiation, clear sky (variable resolution)", "W m**-2 s", "SSRCVAR"},
{211, "Surface net thermal radiation, clear sky (variable resolution)", "W m**-2 s", "STRCVAR"},
{212, "TOA incident solar radiation (variable resolution)", "W m**-2 s", "TISRVAR"}
};
